/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package bdd;

import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.sql.ResultSet;
import objectes.assignaturaTipologiaGrup;
import objectes.professor;

/**
 *
 * @author z0rskrab
 */
public class bdd_professors {


    public static boolean insertProfessor(connect con, professor a) {
        try {
            String sql="insert into t_professors(t_professor_nom,t_professor_cognom,t_professor_departament,t_professor_mincredits,t_professor_maxcredits) values(?,?,?,?,?)";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            pStmt.setString(1, a.getNom());
            pStmt.setString(2, a.getCognoms());
            pStmt.setInt(3,a.getDepartament());
            pStmt.setInt(4, a.getMinCredits());
            pStmt.setInt(5, a.getMaxCredits());
            int rs=pStmt.executeUpdate();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_professors.class.getName()).log(Level.SEVERE, null, ex);
            return false;
        }
        return true;
    }

    public static void updateProfessor(connect con, professor p) {
        try {
            String sql="update t_professors set t_professor_nom=?, t_professor_cognom=?, t_professor_mincredits=?, t_professor_maxcredits=? where t_professor_id=?";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            pStmt.setString(1, p.getNom());
            pStmt.setString(2, p.getCognoms());
            pStmt.setInt(3, p.getMinCredits());
            pStmt.setInt(4, p.getMaxCredits());
            pStmt.setInt(5, p.getId());
            int rs=pStmt.executeUpdate();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_professors.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public static Object[] selectAll(connect con) {
        professor[] professors=null;
        professor aux;
        try {
            String sql="select * from t_professors";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            ResultSet rs=pStmt.executeQuery();
            //ResultSet rs=stmt.executeQuery("select * from t_professors");
            rs.last();
            int nreg=rs.getRow();
            professors=new professor[nreg];
            rs.beforeFirst();
            int count=0;
            while (rs.next()) {
                aux=new professor(rs.getInt("t_professor_id"),rs.getString("t_professor_nom"),rs.getString("t_professor_cognom"));
                aux.setMinCredits(rs.getInt("t_professor_mincredits"));
                aux.setMaxCredits(rs.getInt("t_professor_maxcredits"));
                professors[count++]=aux;
            }
            rs.close();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_professors.class.getName()).log(Level.SEVERE, null, ex);
        }

        return professors;
    }

    public static Object[] selectAllCapacitats(connect con, int idAssignatura, int idTipologia) {
        professor[] professors=null;
        professor aux;
        try {
            String sql="select * from t_professors, t_capacitacions where t_professors.t_professor_id=t_capacitacions.t_professor_id and t_assignatura_id=? and t_assignatura_tipologia_id=?";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            pStmt.setInt(1, idAssignatura);
            pStmt.setInt(2, idTipologia);
            ResultSet rs = pStmt.executeQuery();
            rs.last();
            int nreg=rs.getRow();
            professors=new professor[nreg];
            rs.beforeFirst();
            int count=0;
            while (rs.next()) {
                aux=new professor(rs.getInt("t_professor_id"),rs.getString("t_professor_nom"),rs.getString("t_professor_cognom"));
                aux.setMinCredits(rs.getInt("t_professor_mincredits"));
                aux.setMaxCredits(rs.getInt("t_professor_maxcredits"));
                professors[count++]=aux;
            }
            rs.close();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_professors.class.getName()).log(Level.SEVERE, null, ex);
        }

        return professors;
    }

    public static Object[][] selectAllNoCapacitats(connect con, int idAssignatura, int idTipologia) {
        Object[][] professors=null;
        professor aux;
        try {
            String sql="select * from t_professors where t_professor_id not in (select t_professor_id from t_capacitacions where t_assignatura_id=? and t_assignatura_tipologia_id=?)";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            pStmt.setInt(1, idAssignatura);
            pStmt.setInt(2, idTipologia);
            ResultSet rs = pStmt.executeQuery();
            rs.last();
            int nreg=rs.getRow();
            professors=new Object[nreg][2];
            rs.beforeFirst();
            int count=0;
            while (rs.next()) {
                aux=new professor(rs.getInt("t_professor_id"),rs.getString("t_professor_nom"),rs.getString("t_professor_cognom"));
                aux.setMinCredits(rs.getInt("t_professor_mincredits"));
                aux.setMaxCredits(rs.getInt("t_professor_maxcredits"));
                professors[count][0]=false;
                professors[count++][1]=aux;
            }
            rs.close();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_professors.class.getName()).log(Level.SEVERE, null, ex);
        }

        return professors;
    }

    public static Object[][] selectAllNoCapacitats(connect con, int idAssignatura) {
        Object[][] professors=null;
        professor aux;
        try {
            String sql="select p.t_professor_id \"t_professor_id\" ,p.t_professor_nom \"t_professor_nom\",p.t_professor_cognom \"t_professor_cognom\", p.t_professor_mincredits \"t_professor_mincredits\", p.t_professor_maxcredits \"t_professor_maxcredits\", c.conta from t_professors p left join (select *, count(t_assignatura_tipologia_id) as conta from t_capacitacions where t_assignatura_id=? group by t_professor_id) c on p.t_professor_id=c.t_professor_id where (c.conta<((select count(t_tipologia_id) from t_assignatures_tipologia where t_assignatura_tipologia_ncredits>0 and t_assignatura_id=?)) or isnull(c.conta)=1)";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            pStmt.setInt(1, idAssignatura);
            pStmt.setInt(2, idAssignatura);
            ResultSet rs = pStmt.executeQuery();
            rs.last();
            int nreg=rs.getRow();
            professors=new Object[nreg][2];
            rs.beforeFirst();
            int count=0;
            while (rs.next()) {
                aux=new professor(rs.getInt("t_professor_id"),rs.getString("t_professor_nom"),rs.getString("t_professor_cognom"));
                aux.setMinCredits(rs.getInt("t_professor_mincredits"));
                aux.setMaxCredits(rs.getInt("t_professor_maxcredits"));
                professors[count][0]=false;
                professors[count++][1]=aux;
            }
            rs.close();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_professors.class.getName()).log(Level.SEVERE, null, ex);
        }

        return professors;
    }

    public static void deleteProfessor(connect con, professor p) {
            try {
                String sql="delete from t_capacitacions where t_professor_id=?";
                PreparedStatement pStmt=con.getConn().prepareStatement(sql);
                pStmt.setInt(1, p.getId());
                int rs=pStmt.executeUpdate();
                sql="delete from t_horaris_professors where t_professor_id=?";
                pStmt=con.getConn().prepareStatement(sql);
                pStmt.setInt(1, p.getId());
                rs=pStmt.executeUpdate();
                sql="delete from t_professors where t_professor_id=?";
                pStmt=con.getConn().prepareStatement(sql);
                pStmt.setInt(1, p.getId());
                rs=pStmt.executeUpdate();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_professors.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public static Object[] getPreSolucions(connect con, professor p) {
        Object[] presolucions=null;
        professor aux;
        try {
            String sql="select * from t_presolucions where t_professor_id=?";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            pStmt.setInt(1, p.getId());
            ResultSet rs=pStmt.executeQuery();
            rs.last();
            int nreg=rs.getRow();
            presolucions=new professor[nreg];
            rs.beforeFirst();
            int count=0;
            while (rs.next()) {
                //aux=new assignaturaTipologiaGrup()
                //aux.setMinCredits(rs.getInt("t_professor_mincredits"));
                //aux.setMaxCredits(rs.getInt("t_professor_maxcredits"));
                //presolucions[count++]=aux;
            }
            rs.close();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_professors.class.getName()).log(Level.SEVERE, null, ex);
        }

        return presolucions;
    }

}
