grammar CompFlatzinc;


 
 

options{
output=AST;
} 



tokens{
//paraules reservades del flatzinc
ARRAY = 'array';
BOOL = 'bool';
CONSTRAINT = 'constraint';
FALSE = 'false';
FLOAT = 'float';
INT = 'int';
MAXIMIZE = 'maximize';
MINIMIZE = 'minimize';
OF = 'of';
OUTPUT = 'output';
PREDICATE = 'predicate';
SATISFY = 'satisfy';
SET = 'set';
SHOW = 'show';
SHOW_COND = 'show_cond';
SOLVE = 'solve';
TRUE = 'true';
VAR = 'var';
//paraules reservades del SMT
AND = 'and';
BENCHMARK = 'benchmark';
DISTINCT = 'distinct';
EXISTS = 'exists';
FLET = 'flet';
FORALL = 'forall';
IF_THEN_ELSE = 'if_then_else';
IFF = 'iff';
IMPLIES = 'implies';
ITE = 'ite';
LET = 'let';
LOGIC = 'logic';
NOT = 'not';
OR = 'or'; 
SAT = 'sat';
THEORY = 'theory';
UNKNOWN= 'unknown';
UNSAT = 'unsat';
XOR = 'xor'; 
/*
MAND = 'AND';
MBENCHMARK = 'BENCHMARK';
MDISTINCT = 'DISTINCT';
MEXISTS = 'EXISTS';
MFALSE = 'FALSE';
MFLET = 'FLET';
MFORALL = 'FORALL';
MIF_THEN_ELSE = 'IF_THEN_ELSE';
MIFF = 'IFF';
MIMPLIES = 'IMPLIES';
MITE = 'ITE';
MLET = 'LET';
MLOGIC = 'LOGIC';
MNOT = 'NOT';
MOR = 'OR'; 
MSAT = 'SAT';
MTHEORY = 'THEORY'; 
MTRUE = 'TRUE';
MUNKNOWN= 'UNKNOWN';
MUNSAT = 'UNSAT';
MXOR = 'XOR'; 
*/

NOVAR;
LLISTA;
ANNO;
}

@header {
import java.io.*;
import java.lang.Object;
}


@lexer::header {
import java.io.*;
import java.lang.Object;   
} 

@members {
	Integer ce=0; //comptador d'errors
    	public void displayRecognitionError(String[] tokenNames,RecognitionException e) {
        	String hdr = getErrorHeader(e);
        	String msg = getErrorMessage(e, tokenNames);
        	System.err.println("Syntax error: "+hdr+" "+msg);
        	ce++;
    	}
}

@lexer::members {
    	public void displayRecognitionError(String[] tokenNames,RecognitionException e) {
        	String hdr = getErrorHeader(e);
        	String msg = getErrorMessage(e, tokenNames);
        	System.err.println("Syntax error: "+hdr+" "+msg);
    	}
}
 
 
 
 
flatzinc_model returns [Integer cer]
	:	(pred_decl_item! PUNTICOMA!)*  (var_decl_item PUNTICOMA!)*  (constraint_item PUNTICOMA!)*  solve_item PUNTICOMA!  ((output_item! PUNTICOMA!))?
		{$cer=ce;}
	; 

pred_decl_item
	:	PREDICATE ('fzn2smt_all_different_int'|'fzn2smt_cumulative'|IDENT) PARENRO pred_arg (COMA pred_arg)* PARENRT // {System.err.println("Predicate definition non supported: predicate "+$i.text+" removed. At line : "+$i.getLine());}
	;	
pred_arg
	:	VAR non_array_ti_expr_tail DPUNTS IDENT -> ^(VAR ^(IDENT non_array_ti_expr_tail))
	| 	non_array_ti_expr_tail DPUNTS IDENT -> ^(NOVAR ^(IDENT non_array_ti_expr_tail))
	|	ARRAY PARENQO INT
			  PARENQT OF array_decl_tail_arg  -> ^(ARRAY INT)
	;	
			
var_decl_item
	:	VAR non_array_ti_expr_tail DPUNTS IDENT annotations (IGUAL n=non_array_flat_expr )? -> ^(VAR ^(IDENT annotations non_array_ti_expr_tail ^(IGUAL $n)? ))
	| 	non_array_ti_expr_tail DPUNTS IDENT annotations IGUAL n2=non_array_flat_expr -> ^(NOVAR ^(IDENT annotations non_array_ti_expr_tail ^(IGUAL $n2) ))
	|	ARRAY PARENQO i=INT_LITERAL 
			{if (!( $i.text.equals("1"))) {
					//RecognitionException errno1 = new RecognitionException(input);throw errno1;
					ce++;
					System.err.println("Low array index non equal to 1. At line : "+$i.getLine());
					} 
				}
			DOSPUNTS i2=INT_LITERAL {if ($i2.text.equals("exception")) {ce++;}}PARENQT OF array_decl_tail   -> ^(ARRAY $i2 array_decl_tail)
	;
	
array_decl_tail
	:	non_array_ti_expr_tail DPUNTS IDENT annotations IGUAL array_literal -> ^(NOVAR ^(IDENT annotations non_array_ti_expr_tail ^(IGUAL array_literal) ))
	|	VAR non_array_ti_expr_tail DPUNTS IDENT annotations ( IGUAL array_literal )? -> ^(VAR ^(IDENT annotations non_array_ti_expr_tail ^(IGUAL array_literal)? ))
	;

array_decl_tail_arg
	:	non_array_ti_expr_tail DPUNTS IDENT 
	|	VAR non_array_ti_expr_tail DPUNTS IDENT  
	;
	
constraint_item
	:	CONSTRAINT^ constraint_elem annotations!
	;
	
constraint_elem 
	:	pred_array
	|	pred_bool
	|	pred_float
	|	pred_int
	|	pred_set
	|	pred_global
	|	i=IDENT PARENRO flat_expr ( COMA flat_expr )* PARENRT {System.err.println("Predicate non supported: predicate "+$i.text+" removed. At line : "+$i.getLine());ce++;} -> ^(IDENT flat_expr+) 
	|	variable_expr
	;

pred_array
	:	'array_bool_and' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('array_bool_and' flat_expr+) 
	| 	'array_bool_element' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('array_bool_element' flat_expr+) 
	| 	'array_bool_or' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('array_bool_or' flat_expr+) 
	| 	'array_float_element' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('array_float_element' flat_expr+)
	| 	'array_int_element' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('array_int_element' flat_expr+) 
	| 	'array_set_element' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('array_set_element' flat_expr+) 
	| 	'array_var_bool_element' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('array_var_bool_element' flat_expr+) 
	| 	'array_var_float_element' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('array_var_float_element' flat_expr+)
	| 	'array_var_int_element' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('array_var_int_element' flat_expr+) 
	| 	'array_var_set_element' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('array_var_set_element' flat_expr+) 
	;

pred_bool
	: 	'bool2int' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('bool2int' flat_expr+) 
	| 	'bool_and' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('bool_and' flat_expr+) 
	| 	'bool_clause' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('bool_clause' flat_expr+) 
	| 	'bool_clause_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('bool_clause_reif' flat_expr+) 
	| 	'bool_eq' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('bool_eq'  flat_expr+) 
	| 	'bool_eq_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('bool_eq_reif'  flat_expr+) 
	| 	'bool_ge' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('bool_ge'  flat_expr+) 
	| 	'bool_ge_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('bool_ge_reif'  flat_expr+) 
	| 	'bool_gt' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('bool_gt'  flat_expr+)
	| 	'bool_gt_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('bool_gt_reif'  flat_expr+) 
	| 	'bool_le' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('bool_le'  flat_expr+) 
	| 	'bool_le_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('bool_le_reif'  flat_expr+) 
	| 	'bool_left_imp' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('bool_left_imp'  flat_expr+) 
	| 	'bool_lt' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('bool_lt'  flat_expr+) 
	| 	'bool_lt_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('bool_lt_reif'  flat_expr+) 
	| 	'bool_ne' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('bool_ne'  flat_expr+) 
	| 	'bool_ne_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('bool_ne_reif'  flat_expr+) 
	|	'bool_not' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('bool_not'  flat_expr+) 
	| 	'bool_or' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('bool_or'  flat_expr+)
	| 	'bool_right_imp' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('bool_right_imp'  flat_expr+)
	| 	'bool_xor' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('bool_xor'  flat_expr+)
	;
	
pred_float
	:	'float_abs' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_abs'  flat_expr+) 
	| 	'float_div' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_div'  flat_expr+) 
	| 	'float_eq' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_eq'  flat_expr+)
	| 	'float_eq_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_eq_reif'  flat_expr+)
	| 	'float_ge' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_ge'  flat_expr+)
	| 	'float_ge_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_ge_reif'  flat_expr+) 
	| 	'float_gt' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_gt'  flat_expr+) 
	| 	'float_gt_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_gt_reif'  flat_expr+) 
	|	'float_le' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_le'  flat_expr+)
	| 	'float_le_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_le_reif'  flat_expr+) 
	| 	'float_lin_eq' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_lin_eq'  flat_expr+)
	| 	'float_lin_eq_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_lin_eq_reif'  flat_expr+)			
	| 	'float_lin_ge' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_lin_ge'  flat_expr+) 
	| 	'float_lin_gt' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_lin_gt'  flat_expr+) 
	| 	'float_lin_gt_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_lin_gt_reif'  flat_expr+) 
	| 	'float_lin_le' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_lin_le'  flat_expr+) 
	| 	'float_lin_le_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_lin_le_reif'  flat_expr+)
	| 	'float_lin_lt' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_lin_lt'  flat_expr+) 
	| 	'float_lin_lt_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_lin_lt_reif'  flat_expr+) 
	| 	'float_lin_ne' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_lin_ne'  flat_expr+) 
	| 	'float_lin_ne_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_lin_ne_reif'  flat_expr+)
	| 	'float_lt' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_lt'  flat_expr+) 
	| 	'float_lt_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_lt_reif'  flat_expr+) 
	| 	'float_max' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_max'  flat_expr+)
	| 	'float_min' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_min'  flat_expr+) 
	| 	'float_minus' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_minus'  flat_expr+) 
	| 	'float_ne' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_ne'  flat_expr+) 
	| 	'float_ne_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_ne_reif'  flat_expr+) 
	| 	'float_negate' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_negate'  flat_expr+) 
	| 	'float_plus' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_plus'  flat_expr+) 
	| 	'float_times' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('float_times'  flat_expr+) 
	;

pred_int
	:	'int_abs' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_abs'  flat_expr+) 
	| 	'int_div' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_div'  flat_expr+) 
	| 	'int_eq' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_eq'  flat_expr+)
	| 	'int_eq_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_eq_reif'  flat_expr+) 
	| 	'int_ge' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_ge'  flat_expr+) 
	| 	'int_ge_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_ge_reif'  flat_expr+) 
	| 	'int_gt' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_gt'  flat_expr+) 
	| 	'int_gt_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_gt_reif'  flat_expr+) 
	| 	'int_le' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_le'  flat_expr+) 
	| 	'int_le_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_le_reif'  flat_expr+) 
	| 	'int_lin_eq' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_lin_eq'  flat_expr+) 
	| 	'int_lin_eq_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_lin_eq_reif'  flat_expr+) 
	| 	'int_lin_ge' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_lin_ge'  flat_expr+) 
	| 	'int_lin_ge_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_lin_ge_reif'  flat_expr+) 
	| 	'int_lin_gt' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_lin_gt'  flat_expr+) 
	| 	'int_lin_gt_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_lin_gt_reif'  flat_expr+) 
	| 	'int_lin_le' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_lin_le'  flat_expr+) 
	| 	'int_lin_le_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_lin_le_reif'  flat_expr+) 
	| 	'int_lin_lt' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_lin_lt'  flat_expr+) 
	| 	'int_lin_lt_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_lin_lt_reif'  flat_expr+) 
	| 	'int_lin_ne' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_lin_ne'  flat_expr+) 
	| 	'int_lin_ne_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_lin_ne_reif'  flat_expr+) 
	| 	'int_lt' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_lt'  flat_expr+) 
	| 	'int_lt_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_lt_reif'  flat_expr+) 
	| 	'int_max' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_max'  flat_expr+) 
	| 	'int_min' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_min'  flat_expr+) 
	| 	'int_minus' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_minus'  flat_expr+) 
	| 	'int_mod' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_mod'  flat_expr+) 
	| 	'int_ne' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_ne'  flat_expr+) 
	| 	'int_ne_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_ne_reif'  flat_expr+) 
	| 	'int_negate' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_negate'  flat_expr+) 
	| 	'int_plus' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_plus'  flat_expr+) 
	| 	'int_times' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int_times'  flat_expr+) 
	| 	'int2float' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('int2float'  flat_expr+) 
	;
		
pred_set
	:	'set_card' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('set_card'  flat_expr+) 
	| 	'set_diff' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('set_diff'  flat_expr+) 
	| 	'set_eq' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('set_eq'  flat_expr+) 
	| 	'set_eq_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('set_eq_reif'  flat_expr+) 
	| 	'set_ge' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('set_ge'  flat_expr+) 
	| 	'set_ge_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('set_ge_reif'  flat_expr+) 
	| 	'set_gt' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('set_gt'  flat_expr+) 
	| 	'set_gt_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('set_gt_reif'  flat_expr+) 
	| 	'set_in' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('set_in'  flat_expr+) 
	| 	'set_in_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('set_in_reif'  flat_expr+) 
	| 	'set_intersect' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('set_intersect'  flat_expr+) 
	| 	'set_le' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('set_le'  flat_expr+) 
	| 	'set_le_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('set_le_reif'  flat_expr+) 
	| 	'set_lt' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('set_lt' flat_expr+)
	| 	'set_lt_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('set_lt_reif'  flat_expr+) 
	| 	'set_ne' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('set_ne'  flat_expr+) 
	| 	'set_ne_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('set_ne_reif'  flat_expr+) 
	| 	'set_subset' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('set_subset'  flat_expr+) 
	| 	'set_subset_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('set_subset_reif'  flat_expr+)
	| 	'set_superset' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('set_superset'  flat_expr+) 
	| 	'set_superset_reif' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('set_superset_reif'  flat_expr+) 
	| 	'set_symdiff' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('set_symdiff'  flat_expr+) 
	| 	'set_union' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('set_union'  flat_expr+)
	;
			
pred_global
	:	'fzn2smt_all_different_int' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('fzn2smt_all_different_int' flat_expr+) 
	|	'fzn2smt_cumulative' PARENRO flat_expr ( COMA flat_expr )* PARENRT -> ^('fzn2smt_cumulative' flat_expr+) 
	;

solve_item
	:	SOLVE^ annotations! solve_kind
	;

solve_kind
	:	SATISFY 
	|	i=MINIMIZE^ solve_expr //{System.err.println("Minimize non suported, assumed Satisfy. At line : "+$i.getLine());}
	|	i2=MAXIMIZE^ solve_expr //{System.err.println("Maximize non suported, assumed Satisfy. At line : "+$i2.getLine());}
	;

solve_expr
	:	IDENT ( PARENRO flat_expr ( COMA flat_expr )* PARENRT)? -> ^(IDENT)
	|	array_access_expr
	;

non_array_ti_expr_tail
	:	scalar_ti_expr_tail
	|	set_ti_expr_tail
	;

scalar_ti_expr_tail
	:	bool_ti_expr_tail
	|	int_ti_expr_tail
	|	float_ti_expr_tail
	;
	
bool_ti_expr_tail
	:	BOOL
	;	

int_ti_expr_tail
	:	INT
	|	i=INT_LITERAL DOSPUNTS^ i1=INT_LITERAL {if ($i.text.equals("exception") || $i1.text.equals("exception")) {ce++;}}
	|	CLAUO i2=INT_LITERAL {if ($i2.text.equals("exception")) {ce++;}} ( COMA i3=INT_LITERAL {if ($i3.text.equals("exception")) {ce++;}})* CLAUT -> ^(LLISTA INT_LITERAL+)
	;


float_ti_expr_tail
	:	FLOAT
	|	t=FLOAT_LITERAL DOSPUNTS^ t2=FLOAT_LITERAL {if ($t.text.equals("exception") || $t2.text.equals("exception")) {ce++;}}
	;

set_ti_expr_tail
	:	SET^ OF! scalar_ti_expr_tail
	;

ann_expr
	:	IDENT PARENRO ann_expr ( COMA ann_expr )* PARENRT
	|	non_array_flat_expr
	|	array_literal2
	;
	
flat_expr
	:	non_array_flat_expr
	|	array_literal
	;

non_array_flat_expr 
	:	scalar_flat_expr
	|	set_literal
	;

scalar_flat_expr
	:	IDENT
	|	array_access_expr
	|	bool_literal
	| 	i=INT_LITERAL {if ($i.text.equals("exception")) {ce++;}}
	|	t=FLOAT_LITERAL  {if ($t.text.equals("exception")) {ce++;}}
	|	STRING_LITERAL
	;

int_flat_expr
	:	IDENT
	|	array_access_expr
	|	i=INT_LITERAL {if ($i.text.equals("exception")) {ce++;}}
	;
	
variable_expr
	:	IDENT
	|	array_access_expr
	;


array_access_expr
	:	IDENT PARENQO^ int_index_expr PARENQT!
	;

int_index_expr
	:	IDENT
	|	i=INT_LITERAL {if ($i.text.equals("exception")) {ce++;}}
	;

bool_literal
	:	TRUE
	|	FALSE 
	;

set_literal
	:	CLAUO ( scalar_flat_expr ( COMA scalar_flat_expr )* )? CLAUT -> ^(LLISTA scalar_flat_expr*)
	|	int_flat_expr DOSPUNTS^ int_flat_expr
	;
	
array_literal
	:	PARENQO (non_array_flat_expr ( COMA non_array_flat_expr )* )? PARENQT -> ^(PARENQT  non_array_flat_expr* )
	;
	
array_literal2
	:	PARENQO (ann_expr ( COMA ann_expr )* )? PARENQT -> ^(PARENQT ann_expr* )
	;
	
annotations
	:	(QPUNTS annotation)* -> ANNO
	|	QPUNTS 'output_var' -> ^('output_var')
	|	QPUNTS 'output_array' PARENRO PARENQO  rangoset (COMA rangoset)* PARENQT PARENRT -> ^('output_array' rangoset+) 
	;
	
rangoset
	:	i=INT_LITERAL DOSPUNTS^ i2=INT_LITERAL {if ($i.text.equals("exception") || $i2.text.equals("exception")) {ce++;}}
	|	CLAUO i3=INT_LITERAL {if ($i3.text.equals("exception")) {ce++;}} ( COMA i4=INT_LITERAL {if ($i4.text.equals("exception")) {ce++;}})* CLAUT 
	;	

annotation
	:	IDENT ( PARENRO ann_expr (COMA ann_expr)* PARENRT )?   
	;	

output_item
	:	i=OUTPUT PARENQO ( output_elem (COMA output_elem)* )? PARENQT {System.err.println("Output not supported. At line : "+$i.getLine());}
	;
	
output_elem
	:	STRING_LITERAL
	|	IDENT PARENRO ( flat_expr (COMA flat_expr )* )? PARENRT 
	;
	
PARENRO
	:	'(' 
	;
	
PARENRT
	:	')'
	;
	
PARENQO
	:	'['
	;
	
PARENQT
	:	']'
	;
	
CLAUO
	:	'{'
	;
	
CLAUT
	:	'}'
	;
	
COMA
	:	','
	;
	
DOSPUNTS
	:	'..'
	;
	
IGUAL
	:	'='
	;

DPUNTS	
	:	':'
	;
	
QPUNTS
	:	'::'
	;
	
PUNTICOMA
	:	';'
	;

		
INT_LITERAL 
	: 	('-')?'0x'('0'..'9' | 'A'..'F' | 'a'..'f' )+  
				{
					Integer i;
					if ($text.substring(0,1).equals("-")) {i=3;} else {i=2;}
					String a=Integer.valueOf($text.substring(i),16).toString();
					if (i==3) {a="-"+a;}
					setText(a);
					Integer y=Integer.parseInt(a);
					if ((y<-10000000) || (y>10000000) || $text.equals("Infinity") || $text.equals("-Infinity")) {System.err.println("Integer out of range : "+$text+" At line : "+getLine());setText("exception");}
				}
	|	('-')?'0o'('0'..'7')+ 
				{
					Integer i;
					if ($text.substring(0,1).equals("-")) {i=3;} else {i=2;}
					String a=Integer.valueOf($text.substring(i),8).toString();
					if (i==3) {a="-"+a;}
					setText(a);
					Integer y=Integer.parseInt(a);
					if ((y<-10000000) || (y>10000000)|| $text.equals("Infinity") || $text.equals("-Infinity")) {System.err.println("Integer out of range : "+$text+" At line : "+getLine());setText("exception");}
				}
	;

FLOAT_LITERAL 
	: 	(('-')?('0'..'9')+ '.' ('0'..'9')+ )  => ('-')?('0'..'9')+ '.' ('0'..'9')+  
			(
			 ('E' | 'e') ('+'|'-')? ('0'..'9')+ 
			|
			)
			{
			 	Float f=Float.parseFloat($text);
			 	setText(f.toString());
			 	if ($text.indexOf("e",0)!=(-1) || $text.indexOf("E",0)!=(-1) || $text.equals("Infinity") || $text.equals("-Infinity")) {System.err.println("Float out of range : "+$text+" At line : "+getLine());setText("exception");}
			}
		| ('-')?('0'..'9')+ (
					('E' | 'e') ('+'|'-')? ('0'..'9')+ 
						 {
						 	/*Float f=Float.parseFloat($text);
						 	Float f2=f;
						 	if (f<0) {f2=-f;} 
						 	if ((f2<=1.0E-3) || (f2>=1.0E+7)) {System.err.println("Float range : not 1.0E-3 < |"+f2+"| < 1.0E+7. At line : "+getLine());setText("exception");}  else {setText(f.toString());} */
						 	Float f=Float.parseFloat($text);
						 	setText(f.toString());
						 	if ($text.indexOf("e",0)!=(-1) || $text.indexOf("E",0)!=(-1) || $text.equals("Infinity") || $text.equals("-Infinity")) {System.err.println("Float out of range : "+$text+" At line : "+getLine());setText("exception");}				 	
						 }
					| {
						$type=INT_LITERAL;
						Integer y=Integer.parseInt($text);
						if ((y<-10000000) || (y>10000000) || $text.equals("Infinity") || $text.equals("-Infinity")) {System.err.println("Integer out of range : "+$text+" At line : "+getLine());setText("exception");}
					  }
					)
	;

STRING_LITERAL
	:	'"' (~'"')* '"' 
	;
	
WS
	: (' '|'\n'|'\r'|'\t')+	{$channel=HIDDEN;}   //ignore whitespace
	;	
COMMENT
	: '%' .* '\r'? '\n'	{$channel=HIDDEN;}  //ignore comments
	;	

IDENT
	:	 
	('A'..'Z'|'a'..'z')(('A'..'Z'|'a'..'z'|'0'..'9'|'_')*('A'..'Z'|'a'..'z'|'0'..'9'))?
	;