/*
 * MainAPP.java
 */
package gui;

import control.ctrl_assignatures;
import control.ctrl_assignatures_tipologies;
import control.ctrl_assignatures_tipologies_grup;
import control.ctrl_capacitacions;
import control.ctrl_franja_horaries;
import control.ctrl_professors;
import fzn2smt.fzn2smt;
import java.awt.Color;
import java.awt.Component;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Writer;
import java.lang.reflect.Method;
import java.net.URL;
import java.net.URLClassLoader;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.ArrayList;
import java.util.Vector;
import java.util.TreeSet;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultListModel;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellRenderer;
import java.util.HashMap;
import java.util.Map;
import org.jdesktop.application.SingleFrameApplication;
import org.jdesktop.application.FrameView;
import java.util.Iterator;

import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import objectes.assignatura;
import objectes.assignaturaTipologia;
import objectes.assignaturaTipologiaGrup;
import objectes.franjaHoraria;
import objectes.preSolucio;
import objectes.professor;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 * The application's main frame.
 */
public final class MainAPP extends FrameView {

	public MainAPP(SingleFrameApplication app) {
		super(app);
		java.util.logging.Logger logger = java.util.logging.Logger.getLogger(org.jdesktop.application.SessionStorage.class.getName());
		logger.setLevel(java.util.logging.Level.OFF);
		initComponents();
		carregarAssignatures();
		carregarProfessors();
		carregarHorari();
		editarHorarisGrups=false;
		editarHorarisProfessors=false;
		btnCancelEditHorari.setVisible(false);
		btnEditHorari.setVisible(false);
		btnCancelEditHorariProfessor.setVisible(false);
		btnEditHorariProfessor.setVisible(false);
                llegirXML();
                
	}

	/** This method is called from within the constructor to
	 * initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is
	 * always regenerated by the Form Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        statusPanel = new javax.swing.JPanel();
        statusMessageLabel = new javax.swing.JLabel();
        statusAnimationLabel = new javax.swing.JLabel();
        jTabbedPanePrincipal = new javax.swing.JTabbedPane();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        treeAssignatures = new javax.swing.JTree();
        jLabel2 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        spProfessors = new javax.swing.JScrollPane();
        lstProfessors = new javax.swing.JList();
        btnAdd = new javax.swing.JButton();
        btnEdit = new javax.swing.JButton();
        btnDelete = new javax.swing.JButton();
        btnAddProfessor = new javax.swing.JButton();
        btnDeleteProfessor = new javax.swing.JButton();
        btnEditHorari = new javax.swing.JButton();
        btnCancelEditHorari = new javax.swing.JButton();
        HorarisGrups = new javax.swing.JTabbedPane();
        jScrollPane3 = new javax.swing.JScrollPane();
        tblHoraris = new javax.swing.JTable();
        jScrollPane6 = new javax.swing.JScrollPane();
        tblHoraris2 = new javax.swing.JTable();
        jPanel3 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        spGeneralProfessors = new javax.swing.JScrollPane();
        lstGeneralProfessors = new javax.swing.JList();
        btnAddProfessors = new javax.swing.JButton();
        btnEditProfessors = new javax.swing.JButton();
        btnDelProf = new javax.swing.JButton();
        btnEditHorariProfessor = new javax.swing.JButton();
        btnCancelEditHorariProfessor = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        treeAssigCapacitades = new javax.swing.JTree();
        jButton1 = new javax.swing.JButton();
        HorarisProfessors = new javax.swing.JTabbedPane();
        jScrollPane4 = new javax.swing.JScrollPane();
        tblHorarisProfessors = new javax.swing.JTable();
        jScrollPane7 = new javax.swing.JScrollPane();
        tblHorarisProfessors2 = new javax.swing.JTable();
        jPanel5 = new javax.swing.JPanel();
        btnCreateDznFile = new javax.swing.JButton();
        jScrollPane5 = new javax.swing.JScrollPane();
        txtOutput = new javax.swing.JTextArea();
        btnCreateFznFile = new javax.swing.JButton();
        calculgecode = new javax.swing.JButton();
        calculG12 = new javax.swing.JButton();
        calculfzn2smt = new javax.swing.JButton();
        mostrarResultats = new javax.swing.JButton();

        statusPanel.setName("statusPanel"); // NOI18N
        statusPanel.setPreferredSize(new java.awt.Dimension(886, 700));

        statusMessageLabel.setName("statusMessageLabel"); // NOI18N

        statusAnimationLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        statusAnimationLabel.setName("statusAnimationLabel"); // NOI18N

        jTabbedPanePrincipal.setTabLayoutPolicy(javax.swing.JTabbedPane.SCROLL_TAB_LAYOUT);
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(gui.ProvaApp.class).getContext().getResourceMap(MainAPP.class);
        jTabbedPanePrincipal.setFont(resourceMap.getFont("jTabbedPanePrincipal.font")); // NOI18N
        jTabbedPanePrincipal.setName("jTabbedPanePrincipal"); // NOI18N

        jPanel2.setName("jPanel2"); // NOI18N

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        javax.swing.tree.DefaultMutableTreeNode treeNode1 = new javax.swing.tree.DefaultMutableTreeNode("root");
        treeAssignatures.setModel(new javax.swing.tree.DefaultTreeModel(treeNode1));
        treeAssignatures.setExpandsSelectedPaths(true);
        treeAssignatures.setName("treeAssignatures"); // NOI18N
        treeAssignatures.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
            public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
                treeAssignaturesValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(treeAssignatures);

        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N

        jLabel4.setText(resourceMap.getString("jLabel4.text")); // NOI18N
        jLabel4.setName("jLabel4"); // NOI18N

        spProfessors.setName("spProfessors"); // NOI18N

        lstProfessors.setName("lstProfessors"); // NOI18N
        spProfessors.setViewportView(lstProfessors);

        btnAdd.setText(resourceMap.getString("btnAdd.text")); // NOI18N
        btnAdd.setName("btnAdd"); // NOI18N
        btnAdd.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddActionPerformed(evt);
            }
        });

        btnEdit.setText(resourceMap.getString("btnEdit.text")); // NOI18N
        btnEdit.setEnabled(false);
        btnEdit.setName("btnEdit"); // NOI18N
        btnEdit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnEditActionPerformed(evt);
            }
        });

        btnDelete.setText(resourceMap.getString("btnDelete.text")); // NOI18N
        btnDelete.setEnabled(false);
        btnDelete.setName("btnDelete"); // NOI18N
        btnDelete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDeleteActionPerformed(evt);
            }
        });

        btnAddProfessor.setText(resourceMap.getString("btnAddProfessor.text")); // NOI18N
        btnAddProfessor.setEnabled(false);
        btnAddProfessor.setName("btnAddProfessor"); // NOI18N
        btnAddProfessor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddProfessorActionPerformed(evt);
            }
        });

        btnDeleteProfessor.setText(resourceMap.getString("btnDeleteProfessor.text")); // NOI18N
        btnDeleteProfessor.setEnabled(false);
        btnDeleteProfessor.setName("btnDeleteProfessor"); // NOI18N
        btnDeleteProfessor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDeleteProfessorActionPerformed(evt);
            }
        });

        btnEditHorari.setText(resourceMap.getString("btnEditHorari.text")); // NOI18N
        btnEditHorari.setName("btnEditHorari"); // NOI18N
        btnEditHorari.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnEditHorariMouseClicked(evt);
            }
        });

        btnCancelEditHorari.setText(resourceMap.getString("btnCancelEditHorari.text")); // NOI18N
        btnCancelEditHorari.setName("btnCancelEditHorari"); // NOI18N
        btnCancelEditHorari.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnCancelEditHorariMouseClicked(evt);
            }
        });

        HorarisGrups.setName("HorarisGrups"); // NOI18N
        HorarisGrups.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                HorarisGrupsMouseClicked(evt);
            }
        });

        jScrollPane3.setName("jScrollPane3"); // NOI18N

        tblHoraris.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {},
                {},
                {},
                {}
            },
            new String [] {

            }
        ));
        tblHoraris.setName("tblHoraris"); // NOI18N
        jScrollPane3.setViewportView(tblHoraris);

        HorarisGrups.addTab(resourceMap.getString("jScrollPane3.TabConstraints.tabTitle"), jScrollPane3); // NOI18N

        jScrollPane6.setName("jScrollPane6"); // NOI18N

        tblHoraris2.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {},
                {},
                {},
                {}
            },
            new String [] {

            }
        ));
        tblHoraris2.setName("tblHoraris2"); // NOI18N
        jScrollPane6.setViewportView(tblHoraris2);

        HorarisGrups.addTab(resourceMap.getString("jScrollPane6.TabConstraints.tabTitle"), jScrollPane6); // NOI18N

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(32, 32, 32)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel4)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 227, Short.MAX_VALUE))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 321, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(spProfessors, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 318, Short.MAX_VALUE)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel2Layout.createSequentialGroup()
                                .addComponent(btnAddProfessor)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(btnDeleteProfessor))
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel2Layout.createSequentialGroup()
                                .addComponent(btnAdd, javax.swing.GroupLayout.PREFERRED_SIZE, 95, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(btnEdit, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(12, 12, 12)
                                .addComponent(btnDelete, javax.swing.GroupLayout.PREFERRED_SIZE, 104, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGap(61, 61, 61)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(HorarisGrups, javax.swing.GroupLayout.PREFERRED_SIZE, 495, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(92, 92, 92))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap(560, Short.MAX_VALUE)
                .addComponent(btnEditHorari)
                .addGap(18, 18, 18)
                .addComponent(btnCancelEditHorari)
                .addGap(200, 200, 200))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(27, 27, 27)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 173, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(btnAdd)
                            .addComponent(btnDelete)
                            .addComponent(btnEdit))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 35, Short.MAX_VALUE)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(btnAddProfessor)
                            .addComponent(btnDeleteProfessor, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel4)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(spProfessors, javax.swing.GroupLayout.PREFERRED_SIZE, 152, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(HorarisGrups, javax.swing.GroupLayout.PREFERRED_SIZE, 476, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnEditHorari)
                    .addComponent(btnCancelEditHorari))
                .addGap(50, 50, 50))
        );

        jTabbedPanePrincipal.addTab(resourceMap.getString("jPanel2.TabConstraints.tabTitle"), jPanel2); // NOI18N

        jPanel3.setName("jPanel3"); // NOI18N

        jLabel5.setText(resourceMap.getString("jLabel5.text")); // NOI18N
        jLabel5.setName("jLabel5"); // NOI18N

        jLabel6.setText(resourceMap.getString("jLabel6.text")); // NOI18N
        jLabel6.setName("jLabel6"); // NOI18N

        spGeneralProfessors.setName("spGeneralProfessors"); // NOI18N

        lstGeneralProfessors.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        lstGeneralProfessors.setName("lstGeneralProfessors"); // NOI18N
        lstGeneralProfessors.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                lstGeneralProfessorsMouseClicked(evt);
            }
        });
        spGeneralProfessors.setViewportView(lstGeneralProfessors);

        btnAddProfessors.setText(resourceMap.getString("btnAddProfessors.text")); // NOI18N
        btnAddProfessors.setName("btnAddProfessors"); // NOI18N
        btnAddProfessors.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddProfessorsActionPerformed(evt);
            }
        });

        btnEditProfessors.setText(resourceMap.getString("btnEditProfessors.text")); // NOI18N
        btnEditProfessors.setEnabled(false);
        btnEditProfessors.setName("btnEditProfessors"); // NOI18N
        btnEditProfessors.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnEditProfessorsActionPerformed(evt);
            }
        });

        btnDelProf.setText(resourceMap.getString("btnDelProf.text")); // NOI18N
        btnDelProf.setEnabled(false);
        btnDelProf.setName("btnDelProf"); // NOI18N
        btnDelProf.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDelProfActionPerformed(evt);
            }
        });

        btnEditHorariProfessor.setText(resourceMap.getString("btnEditHorariProfessor.text")); // NOI18N
        btnEditHorariProfessor.setName("btnEditHorariProfessor"); // NOI18N
        btnEditHorariProfessor.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnEditHorariProfessorMouseClicked(evt);
            }
        });

        btnCancelEditHorariProfessor.setText(resourceMap.getString("btnCancelEditHorariProfessor.text")); // NOI18N
        btnCancelEditHorariProfessor.setName("btnCancelEditHorariProfessor"); // NOI18N
        btnCancelEditHorariProfessor.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnCancelEditHorariProfessorMouseClicked(evt);
            }
        });

        jScrollPane2.setName("jScrollPane2"); // NOI18N

        treeNode1 = new javax.swing.tree.DefaultMutableTreeNode("Assignatures");
        treeAssigCapacitades.setModel(new javax.swing.tree.DefaultTreeModel(treeNode1));
        treeAssigCapacitades.setName("treeAssigCapacitades"); // NOI18N
        jScrollPane2.setViewportView(treeAssigCapacitades);

        jButton1.setText(resourceMap.getString("jButton1.text")); // NOI18N
        jButton1.setName("jButton1"); // NOI18N
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        HorarisProfessors.setName("HorarisProfessors"); // NOI18N
        HorarisProfessors.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                HorarisProfessorsMouseClicked(evt);
            }
        });

        jScrollPane4.setName("jScrollPane4"); // NOI18N

        tblHorarisProfessors.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {},
                {},
                {},
                {}
            },
            new String [] {

            }
        ));
        tblHorarisProfessors.setName("tblHorarisProfessors"); // NOI18N
        jScrollPane4.setViewportView(tblHorarisProfessors);

        HorarisProfessors.addTab(resourceMap.getString("jScrollPane4.TabConstraints.tabTitle"), jScrollPane4); // NOI18N

        jScrollPane7.setName("jScrollPane7"); // NOI18N

        tblHorarisProfessors2.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {},
                {},
                {},
                {}
            },
            new String [] {

            }
        ));
        tblHorarisProfessors2.setName("tblHorarisProfessors2"); // NOI18N
        jScrollPane7.setViewportView(tblHorarisProfessors2);

        HorarisProfessors.addTab(resourceMap.getString("jScrollPane7.TabConstraints.tabTitle"), jScrollPane7); // NOI18N

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                .addGap(32, 32, 32)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 279, Short.MAX_VALUE)
                    .addComponent(jLabel6)
                    .addComponent(jLabel5, javax.swing.GroupLayout.DEFAULT_SIZE, 279, Short.MAX_VALUE)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(btnAddProfessors)
                        .addGap(31, 31, 31)
                        .addComponent(btnEditProfessors)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(btnDelProf))
                    .addComponent(spGeneralProfessors, javax.swing.GroupLayout.DEFAULT_SIZE, 279, Short.MAX_VALUE))
                .addGap(40, 40, 40)
                .addComponent(HorarisProfessors, javax.swing.GroupLayout.PREFERRED_SIZE, 496, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(172, 172, 172))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                .addContainerGap(335, Short.MAX_VALUE)
                .addComponent(jButton1)
                .addGap(18, 18, 18)
                .addComponent(btnEditHorariProfessor)
                .addGap(18, 18, 18)
                .addComponent(btnCancelEditHorariProfessor)
                .addGap(235, 235, 235))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGap(26, 26, 26)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel6)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(spGeneralProfessors, javax.swing.GroupLayout.PREFERRED_SIZE, 141, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(btnAddProfessors)
                            .addComponent(btnDelProf)
                            .addComponent(btnEditProfessors))
                        .addGap(26, 26, 26)
                        .addComponent(jLabel5)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 209, Short.MAX_VALUE))
                    .addComponent(HorarisProfessors, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 455, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnEditHorariProfessor)
                    .addComponent(btnCancelEditHorariProfessor)
                    .addComponent(jButton1))
                .addGap(71, 71, 71))
        );

        jTabbedPanePrincipal.addTab(resourceMap.getString("jPanel3.TabConstraints.tabTitle"), jPanel3); // NOI18N

        jPanel5.setName("jPanel5"); // NOI18N

        btnCreateDznFile.setText(resourceMap.getString("btnCreateDznFile.text")); // NOI18N
        btnCreateDznFile.setName("btnCreateDznFile"); // NOI18N
        btnCreateDznFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCreateDznFileActionPerformed(evt);
            }
        });

        jScrollPane5.setName("jScrollPane5"); // NOI18N

        txtOutput.setColumns(20);
        txtOutput.setName("txtOutput"); // NOI18N
        jScrollPane5.setViewportView(txtOutput);

        btnCreateFznFile.setText(resourceMap.getString("btnCreateFznFile.text")); // NOI18N
        btnCreateFznFile.setName("btnCreateFznFile"); // NOI18N
        btnCreateFznFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCreateFznFileActionPerformed(evt);
            }
        });

        calculgecode.setText(resourceMap.getString("calculgecode.text")); // NOI18N
        calculgecode.setName("calculgecode"); // NOI18N
        calculgecode.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                calculgecodeActionPerformed(evt);
            }
        });

        calculG12.setText(resourceMap.getString("calculG12.text")); // NOI18N
        calculG12.setName("calculG12"); // NOI18N
        calculG12.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                calculG12ActionPerformed(evt);
            }
        });

        calculfzn2smt.setText(resourceMap.getString("calculfzn2smt.text")); // NOI18N
        calculfzn2smt.setName("calculfzn2smt"); // NOI18N
        calculfzn2smt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                calculfzn2smtActionPerformed(evt);
            }
        });

        mostrarResultats.setText(resourceMap.getString("mostrarResultats.text")); // NOI18N
        mostrarResultats.setName("mostrarResultats"); // NOI18N
        mostrarResultats.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mostrarResultatsActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addGap(105, 105, 105)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(calculfzn2smt, 0, 0, Short.MAX_VALUE)
                    .addComponent(calculgecode, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(calculG12, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(btnCreateFznFile, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(btnCreateDznFile, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(48, 48, 48)
                .addComponent(jScrollPane5, javax.swing.GroupLayout.PREFERRED_SIZE, 337, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(316, Short.MAX_VALUE))
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addGap(284, 284, 284)
                .addComponent(mostrarResultats, javax.swing.GroupLayout.DEFAULT_SIZE, 184, Short.MAX_VALUE)
                .addGap(522, 522, 522))
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addGap(92, 92, 92)
                        .addComponent(btnCreateDznFile)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnCreateFznFile)
                        .addGap(39, 39, 39)
                        .addComponent(calculG12)
                        .addGap(18, 18, 18)
                        .addComponent(calculfzn2smt)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 23, Short.MAX_VALUE)
                        .addComponent(calculgecode)
                        .addGap(52, 52, 52))
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addGap(50, 50, 50)
                        .addComponent(jScrollPane5, javax.swing.GroupLayout.PREFERRED_SIZE, 293, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(mostrarResultats)
                .addGap(209, 209, 209))
        );

        jTabbedPanePrincipal.addTab(resourceMap.getString("jPanel5.TabConstraints.tabTitle"), jPanel5); // NOI18N

        javax.swing.GroupLayout statusPanelLayout = new javax.swing.GroupLayout(statusPanel);
        statusPanel.setLayout(statusPanelLayout);
        statusPanelLayout.setHorizontalGroup(
            statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(statusPanelLayout.createSequentialGroup()
                .addGroup(statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(statusPanelLayout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(statusMessageLabel)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 862, Short.MAX_VALUE)
                        .addComponent(statusAnimationLabel))
                    .addComponent(jTabbedPanePrincipal, javax.swing.GroupLayout.PREFERRED_SIZE, 817, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        statusPanelLayout.setVerticalGroup(
            statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(statusPanelLayout.createSequentialGroup()
                .addComponent(jTabbedPanePrincipal, javax.swing.GroupLayout.PREFERRED_SIZE, 503, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(1727, 1727, 1727)
                .addGroup(statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(statusMessageLabel)
                    .addComponent(statusAnimationLabel))
                .addContainerGap())
        );

        setComponent(jTabbedPanePrincipal);
    }// </editor-fold>//GEN-END:initComponents

	public void carregarHorari() {
		ctrl_franja_horaries horaris=new ctrl_franja_horaries();
		Object[][] dades=horaris.selectAll();
		Object[] columnNames=new Object[6];
		columnNames[0]="";
		columnNames[1]="Dilluns";
		columnNames[2]="Dimarts";
		columnNames[3]="Dimecres";
		columnNames[4]="Dijous";
		columnNames[5]="Divendres";
		modelHoraris=new TaulaHoraris(dades,columnNames);
		getDesti().setSelectionForeground(Color.black);
		getDesti().setSelectionBackground(Color.white);
		RenderHoraris render=new RenderHoraris();
		getDesti().setDefaultRenderer(franjaHoraria.class, render);
		getDesti().setModel(modelHoraris);

		getDestiProfessors().setSelectionForeground(Color.black);
		getDestiProfessors().setSelectionBackground(Color.white);
		getDestiProfessors().setDefaultRenderer(franjaHoraria.class, render);
		getDestiProfessors().setModel(modelHoraris);
	}

	public void carregarHorari(Object obj, JTable desti) {
		ctrl_franja_horaries horaris=new ctrl_franja_horaries();
		Object[][] dades=null;
		if (obj instanceof assignaturaTipologiaGrup) dades=horaris.selectPersonalitzat((assignaturaTipologiaGrup)obj,HorarisGrups.getSelectedIndex()+1);
		else if (obj instanceof assignaturaTipologia) dades=horaris.selectPersonalitzat((assignaturaTipologia)obj,HorarisGrups.getSelectedIndex()+1);
		else if (obj instanceof assignatura) dades=horaris.selectPersonalitzat((assignatura)obj,HorarisGrups.getSelectedIndex()+1);
		else if (obj instanceof professor) dades=horaris.selectPersonalitzat((professor)obj,HorarisProfessors.getSelectedIndex()+1);
		Object[] columnNames=new Object[6];
		columnNames[0]="";
		columnNames[1]="Dilluns";
		columnNames[2]="Dimarts";
		columnNames[3]="Dimecres";
		columnNames[4]="Dijous";
		columnNames[5]="Divendres";

		if (obj instanceof professor) {
			modelHorarisProfessor=new TaulaHoraris(dades,columnNames);
			desti.setSelectionForeground(Color.black);
			desti.setSelectionBackground(Color.white);
			RenderHoraris render=new RenderHoraris();
			desti.setDefaultRenderer(franjaHoraria.class, render);
			desti.setModel(modelHorarisProfessor);
			editarHorarisProfessors=false;
			btnEditHorariProfessor.setText("Editar Horari");
			btnCancelEditHorariProfessor.setVisible(false);
		} else {
			modelHoraris=new TaulaHoraris(dades,columnNames);
			desti.setSelectionForeground(Color.black);
			desti.setSelectionBackground(Color.white);
			RenderHoraris render=new RenderHoraris();
			desti.setDefaultRenderer(franjaHoraria.class, render);
			desti.setModel(modelHoraris);
			editarHorarisGrups=false;
			btnEditHorari.setText("Editar Horari");
			btnCancelEditHorari.setVisible(false);
		}

	}

        public void llegirXML() {
                try {
                        String control="",hash="";
                        try {
                                File file = new File("c:\\MyXMLFile.xml");
                                DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
                                DocumentBuilder db = dbf.newDocumentBuilder();
                                Document doc = db.parse(file);
                                doc.getDocumentElement().normalize();
                                control+="<"+doc.getDocumentElement().getNodeName()+">";
                                NodeList nodeLst = doc.getElementsByTagName("presolucio");
                                for (int s = 0; s < nodeLst.getLength(); s++) {
                                        control+="<presolucio>";
                                        Node fstNode = nodeLst.item(s);
                                        if (fstNode.getNodeType() == Node.ELEMENT_NODE) {
                                                Element fstElmnt = (Element) fstNode;
                                                NodeList fstNmElmntLst = fstElmnt.getElementsByTagName("professor");
                                                Element fstNmElmnt = (Element) fstNmElmntLst.item(0);
                                                NodeList fstNm = fstNmElmnt.getChildNodes();
                                                control+="<professor>"+((Node) fstNm.item(0)).getNodeValue()+"</professor>";
                                                NodeList lstNmElmntLst = fstElmnt.getElementsByTagName("assignatura");
                                                Element lstNmElmnt = (Element) lstNmElmntLst.item(0);
                                                NodeList lstNm = lstNmElmnt.getChildNodes();
                                                control+="<assignatura>"+((Node) lstNm.item(0)).getNodeValue()+"</assignatura>";
                                                lstNmElmntLst = fstElmnt.getElementsByTagName("tipologia");
                                                lstNmElmnt = (Element) lstNmElmntLst.item(0);
                                                lstNm = lstNmElmnt.getChildNodes();
                                                control+="<tipologia>"+((Node) lstNm.item(0)).getNodeValue()+"</tipologia>";
                                                lstNmElmntLst = fstElmnt.getElementsByTagName("grup");
                                                lstNmElmnt = (Element) lstNmElmntLst.item(0);
                                                lstNm = lstNmElmnt.getChildNodes();
                                                control+="<grup>"+((Node) lstNm.item(0)).getNodeValue()+"</grup>";
                                                control+="</"+doc.getDocumentElement().getNodeName()+">";
                                        }
                                        control+="</presolucio>";
                                        nodeLst = doc.getElementsByTagName("control");
                                        fstNode = nodeLst.item(0);
                                        Element fstElmnt = (Element) fstNode;
                                        NodeList lstNmElmntLst = fstElmnt.getElementsByTagName("hash");
                                        Element lstNmElmnt = (Element) lstNmElmntLst.item(0);
                                        NodeList lstNm = lstNmElmnt.getChildNodes();
                                        hash=((Node) lstNm.item(0)).getNodeValue();
                                }
                        } catch (Exception e) {
                        }
                        MessageDigest digest=MessageDigest.getInstance("MD5");
                        digest.update(control.getBytes());
                        byte[] hash_control=digest.digest();
                        int j;
                        StringBuilder hexString = new StringBuilder();
                        for (j=0;j<hash_control.length;j++) {
                                hexString.append(Integer.toHexString(0xFF & hash_control[j]));
                        }
                        if (hexString.toString().equals(hash)) {
                            
                            System.out.println("Aquí es tractarien les presolucions");
                        } else {
                           // System.out.println("Fitxer manipulat, no es té en compte");
                        }
                } catch (NoSuchAlgorithmException ex) {
                        Logger.getLogger(MainAPP.class.getName()).log(Level.SEVERE, null, ex);
                }
        }


	public Object obtAssignaturaSeleccionada() {
		Object seleccionat = ((DefaultMutableTreeNode) treeAssignatures.getLastSelectedPathComponent()).getUserObject();
		return seleccionat;
	}

	public Object obtProfessorSeleccionat() {
		Object seleccionat = lstGeneralProfessors.getSelectedValue();
		return seleccionat;
	}
        public void carregarPresolucions(professor p) {
            ctrl_franja_horaries cfh=new ctrl_franja_horaries();
            llistaPreSolucions = cfh.selectPresolucions(p);

            ctrl_franja_horaries horaris=new ctrl_franja_horaries();
            Object[][] dades=horaris.selectPersonalitzat(p, HorarisGrups.getSelectedIndex()+1);
            DefaultTableModel horariProfessor=new DefaultTableModel(dades,null);
                    for(int row = 0;row < horariProfessor.getRowCount();row++) {
                            for(int col = 0;col < horariProfessor.getColumnCount();col++) {
                                    Object casella=horariProfessor.getValueAt(row, col);
                                    if (casella instanceof franjaHoraria) {
                                        if (((franjaHoraria)casella).getMarcat()) {
                                            Iterator it=llistaPreSolucions.entrySet().iterator();
                                            while(it.hasNext()) {
                                                Map.Entry pairs = (Map.Entry)it.next();
                                                TreeSet aux=(TreeSet) pairs.getValue();
                                                aux.remove(((franjaHoraria)casella).getId());
                                             }
                                        }
                                    }
                            }
                    }
                                Iterator its=llistaPreSolucions.entrySet().iterator();
                                        while(its.hasNext()) {
                                            Map.Entry pairs = (Map.Entry)its.next();
                                            TreeSet aux=(TreeSet) pairs.getValue();
                                            assignaturaTipologiaGrup auxKey=(assignaturaTipologiaGrup) pairs.getKey();
                                            System.out.println(auxKey.getNom()+"=>"+auxKey.getNomTipologia()+"=>"+auxKey.getNomGrup()+"===>"+aux.size());
                                            if (aux.isEmpty()) {
                                            //    System.out.println(pairs.getKey());
                                            }
                                        }
        }
	public void carregarProfessors() {
		lstProfessors=new JList();
		ctrl_professors control_prof = new ctrl_professors();
		Object[] professors=control_prof.selectAll();
		DefaultListModel llista=new DefaultListModel();
		int i, nombre_professors=professors.length;
		llista.clear();
		for (i=0;i<nombre_professors;i++) {
			llista.addElement(professors[i]);
		}
		lstGeneralProfessors.setModel(llista);
                btnEditProfessors.setEnabled(false);
                btnDelProf.setEnabled(false);
	}

	public void carregarProfessors(int idAssignatura, int idTipologia) {
		ctrl_professors control_prof = new ctrl_professors();
		Object[] professors=control_prof.selectAllCapacitats(idAssignatura, idTipologia);
		DefaultListModel llista=new DefaultListModel();
		int i, nombre_professors=professors.length;
		llista.clear();
		for (i=0;i<nombre_professors;i++) {
			llista.addElement(professors[i]);
		}
		lstProfessors=new JList(llista);
		spProfessors.setViewportView(lstProfessors);

	}

	public void carregarAssignatures() {
            ctrl_assignatures control = new ctrl_assignatures();
            ctrl_assignatures_tipologies control_tipo = new ctrl_assignatures_tipologies();
            ctrl_assignatures_tipologies_grup control_tipo_grup = new ctrl_assignatures_tipologies_grup();
            Object[] assignatures = control.selectAll();
            Object[] assignatures_tipologia = null;
            Object[] assignatures_tipologia_grup = null;
            DefaultMutableTreeNode root = new DefaultMutableTreeNode("Assignatures");
            DefaultTreeModel model = new DefaultTreeModel(root);

            int i, j, k;
            for (i = 0; i < assignatures.length; i++) {
                    DefaultMutableTreeNode x = new DefaultMutableTreeNode(assignatures[i]);
                    model.insertNodeInto(x, root, i);
                    assignatures_tipologia = control_tipo.selectById(((assignatura)assignatures[i]).getId());
                    for (j = 0; j < assignatures_tipologia.length; j++) {
                            DefaultMutableTreeNode y = new DefaultMutableTreeNode(assignatures_tipologia[j]);
                            model.insertNodeInto(y, x, j);
                            assignaturaTipologia aux=(assignaturaTipologia) assignatures_tipologia[j];
                            assignatures_tipologia_grup = control_tipo_grup.selectById(aux.getId(), aux.getTipologia());
                            for (k = 0; k < assignatures_tipologia_grup.length; k++) {
                                    DefaultMutableTreeNode z = new DefaultMutableTreeNode(assignatures_tipologia_grup[k]);
                                    model.insertNodeInto(z, y, k);
                            }
                    }

            }
            treeAssignatures.setModel(model);
            btnEdit.setEnabled(false);
            btnDelete.setEnabled(false);
            btnAddProfessor.setEnabled(false);
            btnDeleteProfessor.setEnabled(false);
	}

	public void carregarAssignaturesCapacitades(professor p) {
		ctrl_capacitacions x=new ctrl_capacitacions();
		Object[] assignatures=x.getCapacitacions(p);
		Object[] ats=null;
		DefaultMutableTreeNode root = new DefaultMutableTreeNode("Assignatures");
		DefaultTreeModel model = new DefaultTreeModel(root);
		DefaultMutableTreeNode as= null, astipo = null;
		DefaultListModel llistaAssignatures=new DefaultListModel();
		assignaturaTipologia actual=new assignaturaTipologia(0,"",0);
		int nAssignatures=0;
		int nTipologies=0;
		if (assignatures!=null) {
			int i,nreg=assignatures.length;
			for (i=0;i<nreg;i++) {
				assignaturaTipologia at=(assignaturaTipologia)assignatures[i];
				if (actual.getId()==at.getId()) {
					astipo=new DefaultMutableTreeNode(at);
					as.insert(astipo, nTipologies);
				} else {
					assignatura a=new assignatura(at.getId(),at.getNom());
					as = new DefaultMutableTreeNode(a);
					astipo=new DefaultMutableTreeNode(at);
					model.insertNodeInto(as, root, nAssignatures);
					as.insert(astipo, nTipologies);
				}
				actual=at;
			}
			treeAssigCapacitades.setModel(model);
			for (i=0;i<treeAssigCapacitades.getRowCount();i++){
				treeAssigCapacitades.expandRow(i);
			}
		} else treeAssigCapacitades.setModel(null);
	}

	public void netejarCamps() {
		tblHoraris.setModel(new DefaultTableModel());
		lstProfessors.setModel(new DefaultListModel());
		carregarAssignatures();
		editarHorarisGrups=false;
		btnCancelEditHorari.setVisible(false);
		btnEditHorari.setVisible(false);
		tblHorarisProfessors.setModel(new DefaultTableModel());
		lstGeneralProfessors.setModel(new DefaultListModel());
	}

	private void btnAddActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddActionPerformed
            try {
                    Object seleccionat = ((DefaultMutableTreeNode) treeAssignatures.getLastSelectedPathComponent()).getUserObject();
                    if (seleccionat instanceof assignaturaTipologiaGrup) {
                    } else if (seleccionat instanceof assignaturaTipologia) {
                            MantenirAssignaturaTipologiaGrup x=new MantenirAssignaturaTipologiaGrup(this.getFrame(),true, ((assignaturaTipologia)seleccionat).getId(),((assignaturaTipologia)seleccionat).getTipologia());
                            x.setVisible(true);
                    } else if (seleccionat instanceof assignatura) {
                            MantenirAssignaturaTipologia x=new MantenirAssignaturaTipologia(this.getFrame(),true,((assignatura)seleccionat).getId(),((assignatura)seleccionat).getNom());
                            x.setVisible(true);
                    } else {
                            MantenirAssignatura x=new MantenirAssignatura(this.getFrame(),true);
                            x.setVisible(true);
                    }
            } catch (NullPointerException e) {
            }
            carregarAssignatures();
	}//GEN-LAST:event_btnAddActionPerformed

	private void btnEditActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnEditActionPerformed
		try {
			Object seleccionat = ((DefaultMutableTreeNode) treeAssignatures.getLastSelectedPathComponent()).getUserObject();
			if (seleccionat instanceof assignaturaTipologiaGrup) {
				MantenirAssignaturaTipologiaGrup x=new MantenirAssignaturaTipologiaGrup(this.getFrame(),true, (assignaturaTipologiaGrup)seleccionat);
				x.setVisible(true);
			} else if (seleccionat instanceof assignaturaTipologia) {
				MantenirAssignaturaTipologia x=new MantenirAssignaturaTipologia(this.getFrame(),true,((assignatura)seleccionat).getId(),((assignatura)seleccionat).getNom());
				x.setVisible(true);
			} else if (seleccionat instanceof assignatura) {
				MantenirAssignaturaTipologia x=new MantenirAssignaturaTipologia(this.getFrame(),true,((assignatura)seleccionat).getId(),((assignatura)seleccionat).getNom());
				x.setVisible(true);
			} else {
				MantenirAssignatura x=new MantenirAssignatura(this.getFrame(),true);
				x.setVisible(true);
			}
		} catch (NullPointerException e) {
		}
		carregarAssignatures();
	}//GEN-LAST:event_btnEditActionPerformed

	private void treeAssignaturesValueChanged(javax.swing.event.TreeSelectionEvent evt) {//GEN-FIRST:event_treeAssignaturesValueChanged
		btnEditHorari.setVisible(false);
                JTable desti=tblHoraris;
                switch (HorarisGrups.getSelectedIndex()) {
                    case 0:
                        desti=tblHoraris;
                        break;
                    case 1:
                        desti=tblHoraris2;
                        break;
                }
		try {
			Object seleccionat = ((DefaultMutableTreeNode) treeAssignatures.getLastSelectedPathComponent()).getUserObject();
			if (seleccionat instanceof assignaturaTipologiaGrup) {
				assignaturaTipologiaGrup x=(assignaturaTipologiaGrup)seleccionat;
				carregarProfessors(x.getId(),x.getTipologia());
				carregarHorari(x,desti);
				btnEditHorari.setVisible(true);
                                btnEdit.setEnabled(true);
                                btnDelete.setEnabled(true);
                                btnAddProfessor.setEnabled(true);
                                btnDeleteProfessor.setEnabled(true);
			} else if (seleccionat instanceof assignaturaTipologia) {
				assignaturaTipologia x=(assignaturaTipologia)seleccionat;
				carregarProfessors(x.getId(),x.getTipologia());
				carregarHorari(x,desti);
                                btnEdit.setEnabled(true);
                                btnDelete.setEnabled(true);
                                btnAddProfessor.setEnabled(true);
                                btnDeleteProfessor.setEnabled(true);
			} else if (seleccionat instanceof assignatura) {
				assignatura x=(assignatura)seleccionat;
				carregarHorari(x,desti);
                                btnEdit.setEnabled(true);
                                btnDelete.setEnabled(true);
                                btnAddProfessor.setEnabled(true);
                                btnDeleteProfessor.setEnabled(true);
			} else {
				//System.out.println("ROOT");
			}
		} catch (NullPointerException e) {

		}
	}//GEN-LAST:event_treeAssignaturesValueChanged

	private void btnAddProfessorsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddProfessorsActionPerformed
		MantenirProfessors x = new MantenirProfessors(this.getFrame(),true);
		x.setVisible(true);
		carregarProfessors();
	}//GEN-LAST:event_btnAddProfessorsActionPerformed

	private void btnEditProfessorsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnEditProfessorsActionPerformed
		Object x = lstGeneralProfessors.getSelectedValue();
		if (x!=null) {
                    	MantenirProfessors m = new MantenirProfessors(this.getFrame(),true,((professor)x));
                        m.setVisible(true);
			carregarProfessors();
		}
	}//GEN-LAST:event_btnEditProfessorsActionPerformed

        private JTable getDesti() {
            JTable desti=tblHoraris;
                switch (HorarisGrups.getSelectedIndex()) {
                    case 0:
                        desti=tblHoraris;
                        break;
                    case 1:
                        desti=tblHoraris2;
                        break;
                }
                return desti;
        }
        
        private JTable getDestiProfessors() {
            JTable desti=tblHorarisProfessors;
                switch (HorarisProfessors.getSelectedIndex()) {
                    case 0:
                        desti=tblHorarisProfessors;
                        break;
                    case 1:
                        desti=tblHorarisProfessors2;
                        break;
                }
                return desti;
        }
        
	private void lstGeneralProfessorsMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_lstGeneralProfessorsMouseClicked
		professor x=(professor) lstGeneralProfessors.getSelectedValue();
                JTable desti=getDestiProfessors();
		if (x!=null) {
                        carregarAssignaturesCapacitades(x);
			carregarHorari(x,desti);
			btnEditHorariProfessor.setVisible(true);
                        btnEditProfessors.setEnabled(true);
                        btnDelProf.setEnabled(true);
		}
	}//GEN-LAST:event_lstGeneralProfessorsMouseClicked

	private void btnAddProfessorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddProfessorActionPerformed
		try {
			Object seleccionat = ((DefaultMutableTreeNode) treeAssignatures.getLastSelectedPathComponent()).getUserObject();
			if (seleccionat instanceof assignaturaTipologiaGrup) {
				assignaturaTipologiaGrup atg=(assignaturaTipologiaGrup)seleccionat;
				MantenirCapacitacions x=new MantenirCapacitacions(this.getFrame(), true, atg.getId(),atg.getTipologia());
				x.setVisible(true);
				carregarProfessors(atg.getId(),atg.getTipologia());
			} else if (seleccionat instanceof assignaturaTipologia) {
				assignaturaTipologia atg=(assignaturaTipologia)seleccionat;
				MantenirCapacitacions x=new MantenirCapacitacions(this.getFrame(), true, atg.getId(),atg.getTipologia());
				x.setVisible(true);
				carregarProfessors(atg.getId(),atg.getTipologia());
			} else if (seleccionat instanceof assignatura) {
				assignatura atg=(assignatura)seleccionat;
				MantenirCapacitacions x=new MantenirCapacitacions(this.getFrame(), true, atg.getId(),-1);
				x.setVisible(true);
				//carregarProfessors(atg.getId());
			} else {
			}
		} catch (NullPointerException e) {

		}
	}//GEN-LAST:event_btnAddProfessorActionPerformed

	private void btnDeleteProfessorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDeleteProfessorActionPerformed
		try {
			Object seleccionat = ((DefaultMutableTreeNode) treeAssignatures.getLastSelectedPathComponent()).getUserObject();
			Object p=lstProfessors.getSelectedValue();
			ctrl_capacitacions x=new ctrl_capacitacions();
			Object[] tipologies={"Teoria","Practiques","Laboratori","Altres"};
			if (seleccionat instanceof assignaturaTipologiaGrup) {
				assignaturaTipologiaGrup atg=(assignaturaTipologiaGrup)seleccionat;
				Object[] options = { "Si", "No" };
				Object opcio=JOptionPane.showOptionDialog(null,"Estàs segur que vols eliminar el professor "+((professor)p)+" de l'assignatura "+atg.getNom()+"=>"+tipologies[atg.getTipologia()], "Confirmació d'eliminació de professor",JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,null, options, options[1]);
				if (opcio.equals(0)){
					x.deleteProfessor((professor)p, atg);
					carregarProfessors(atg.getId(),atg.getTipologia());
				}
			} else if (seleccionat instanceof assignaturaTipologia) {
				assignaturaTipologia atg=(assignaturaTipologia)seleccionat;
				Object[] options = { "Si", "No" };
				Object opcio=JOptionPane.showOptionDialog(null,"Estàs segur que vols eliminar el professor "+((professor)p)+" de l'assignatura "+atg.getNom()+"=>"+tipologies[atg.getTipologia()], "Confirmació d'eliminació de professor",JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,null, options, options[1]);
				if (opcio.equals(0)){
					x.deleteProfessor((professor)p, atg);
					carregarProfessors(atg.getId(),atg.getTipologia());
				}
			} else if (seleccionat instanceof assignatura) {
				assignatura a=(assignatura)seleccionat;
				Object[] options = { "Si", "No" };
				Object opcio=JOptionPane.showOptionDialog(null,"Estàs segur que vols eliminar el professor "+((professor)p)+" de l'assignatura "+a.getNom()+"?", "Confirmació d'eliminació de professor",JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,null, options, options[1]);
				if (opcio.equals(0)){
					x.deleteProfessor((professor)p, a);
					//carregarProfessors(a.getId());
				}
			} else {
				//System.out.println("ROOT");
			}
		} catch (NullPointerException e) {

		}
	}//GEN-LAST:event_btnDeleteProfessorActionPerformed

	private void btnEditHorariMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnEditHorariMouseClicked
		ctrl_franja_horaries x=new ctrl_franja_horaries();
                
		if (editarHorarisGrups) {
			int i,j;
			int nCol=tblHoraris.getColumnCount();
			int nFil=tblHoraris.getRowCount();
			Vector<Integer> frangesAdd=new Vector<Integer>();
			Vector<Integer> frangesDel=new Vector<Integer>();
			for (i=1;i<nCol;i++) {
				for  (j=0;j<nFil;j++) {
					Object pos=getDesti().getModel().getValueAt(j, i);
                                        Object aux2=modelHoraris.getValueAt(j, i);
                                        if (aux2 instanceof preSolucio) {
                                            if (pos.equals(false)) frangesDel.addElement(((preSolucio)aux2).getFranja().getId());
                                            // no té sentit mirar si ja era veritat..
                                        } else {
                                            franjaHoraria aux=(franjaHoraria) modelHoraris.getValueAt(j, i);
                                            if (!pos.equals(aux.getMarcat())) {
                                                    if (aux.getMarcat()) { // Si no són iguals i el vell està marcat, és que s'ha esborrat
                                                            frangesDel.addElement(aux.getId());
                                                    } else { // Si no són iguals i el vell està desmarcat, s'ha afegit
                                                            frangesAdd.addElement(aux.getId());
                                                    }
                                            }
                                        }
				}
			}
                        
			x.actualitzarHoraris((assignaturaTipologiaGrup)obtAssignaturaSeleccionada(),frangesDel,frangesAdd, HorarisGrups.getSelectedIndex()+1);
			carregarHorari((assignaturaTipologiaGrup)obtAssignaturaSeleccionada(),getDesti());
		} else {
			int nColumnes=modelHoraris.getColumnCount();
			int nFiles=modelHoraris.getRowCount();
			Object[][] dades=new Object[nFiles][nColumnes];
			Object[] columnNames=new Object[6];
			columnNames[0]="";
			columnNames[1]="Dilluns";
			columnNames[2]="Dimarts";
			columnNames[3]="Dimecres";
			columnNames[4]="Dijous";
			columnNames[5]="Divendres";
			int i,j;
			dades[0][0]="8:00-8:30";
			dades[1][0]="8:30-9:00";
			dades[2][0]="9:00-9:30";
			dades[3][0]="9:30-10:00";
			dades[4][0]="10:00-10:30";
			dades[5][0]="10:30-11:00";
			dades[6][0]="11:00-11:30";
			dades[7][0]="11:30-12:00";
			dades[8][0]="12:00-12:30";
			dades[9][0]="12:30-13:00";
			dades[10][0]="13:00-13:30";
			dades[11][0]="13:30-14:00";
			dades[12][0]="14:00-14:30";
			dades[13][0]="14:30-15:00";
			dades[14][0]="15:00-15:30";
			dades[15][0]="15:30-16:00";
			dades[16][0]="16:00-16:30";
			dades[17][0]="16:30-17:00";
			dades[18][0]="17:00-17:30";
			dades[19][0]="17:30-18:00";
			dades[20][0]="18:00-18:30";
			dades[21][0]="18:30-19:00";
			dades[22][0]="19:00-19:30";
			dades[23][0]="19:30-20:00";
			dades[24][0]="20:00-20:30";
			dades[25][0]="20:30-21:00";
			for (i=0;i<nFiles;i++) {
				for (j=1;j<nColumnes;j++) {
					if (modelHoraris.getValueAt(i,j) instanceof franjaHoraria) dades[i][j]=((franjaHoraria)modelHoraris.getValueAt(i, j)).getMarcat();
                                        else dades[i][j]=true; // si no es que està preassignat i per tant ok!
				}
			}
			TaulaBoolHoraris model=new TaulaBoolHoraris(dades,columnNames);
			getDesti().setModel(model);
			btnEditHorari.setText("Actualitzar");
			btnCancelEditHorari.setVisible(true);
			editarHorarisGrups=true;
		}
	}//GEN-LAST:event_btnEditHorariMouseClicked

	private void btnCancelEditHorariMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnCancelEditHorariMouseClicked
		JTable desti=tblHoraris;
                switch (HorarisGrups.getSelectedIndex()) {
                    case 0:
                        desti=tblHoraris;
                        break;
                    case 1:
                        desti=tblHoraris2;
                        break;
                }
                carregarHorari((assignaturaTipologiaGrup) obtAssignaturaSeleccionada(),desti);
		btnCancelEditHorari.setVisible(false);
		editarHorarisGrups=false;
	}//GEN-LAST:event_btnCancelEditHorariMouseClicked

	private void btnDeleteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDeleteActionPerformed
		try {
			Object seleccionat = ((DefaultMutableTreeNode) treeAssignatures.getLastSelectedPathComponent()).getUserObject();
			Object p=lstProfessors.getSelectedValue();
			Object[] tipologies={"Teoria","Practiques","Laboratori","Altres"};
			if (seleccionat instanceof assignaturaTipologiaGrup) {
				ctrl_assignatures_tipologies_grup x=new ctrl_assignatures_tipologies_grup();
				assignaturaTipologiaGrup atg=(assignaturaTipologiaGrup)seleccionat;
				Object[] options = { "Si", "No" };
				Object opcio=JOptionPane.showOptionDialog(null,"Estàs segur que vols eliminar el grup "+atg.getNomGrup()+" de l'assignatura "+atg.getNom()+"=>"+tipologies[atg.getTipologia()]+"\nS'eliminarà també l'horari assignat.", "Confirmació d'eliminació de grup",JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,null, options, options[1]);
				if (opcio.equals(0)){
					x.deleteGrup(atg);
					netejarCamps();
				}
			} else if (seleccionat instanceof assignaturaTipologia) {
				ctrl_assignatures_tipologies x=new ctrl_assignatures_tipologies();
				assignaturaTipologia at=(assignaturaTipologia)seleccionat;
				Object[] options = { "Si", "No" };
				Object opcio=JOptionPane.showOptionDialog(null,"Estàs segur que vols eliminar la tipologia "+tipologies[at.getTipologia()]+" de l'assignatura "+at.getNom()+"\nS'eliminaràn també els seus grups, horaris i professors capacitats.", "Confirmació d'eliminació de tipologia",JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,null, options, options[1]);
				if (opcio.equals(0)){
					x.deleteTipologia(at);
					netejarCamps();
				}
			} else if (seleccionat instanceof assignatura) {
				ctrl_assignatures x=new ctrl_assignatures();
				assignatura a=(assignatura)seleccionat;
				Object[] options = { "Si", "No" };
				Object opcio=JOptionPane.showOptionDialog(null,"Estàs segur que vols eliminar l'assignatura "+a.getNom()+"\nS'eliminaràn també les seves tipologies, grups, horaris i professors capacitats.", "Confirmació d'eliminació d'assignatura",JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,null, options, options[1]);
				if (opcio.equals(0)){
					x.deleteAssignatura(a);
					netejarCamps();
				}
			} else {
				//System.out.println("ROOT");
			}
		} catch (NullPointerException e) {

		}
	}//GEN-LAST:event_btnDeleteActionPerformed

	private void btnEditHorariProfessorMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnEditHorariProfessorMouseClicked
		ctrl_franja_horaries x=new ctrl_franja_horaries();
		if (editarHorarisProfessors) {
			int i,j;
			int nCol=getDestiProfessors().getColumnCount();
			int nFil=getDestiProfessors().getRowCount();
			Vector<Integer> frangesAdd=new Vector<Integer>();
			Vector<Integer> frangesDel=new Vector<Integer>();
			for (i=1;i<nCol;i++) {
				for  (j=0;j<nFil;j++) {
					Object pos=getDestiProfessors().getModel().getValueAt(j, i);
                                        Object aux2=modelHorarisProfessor.getValueAt(j, i);
                                        if (aux2 instanceof preSolucio) {
                                            if (pos.equals(false)) frangesDel.addElement(((preSolucio)aux2).getFranja().getId());
                                        } else  {
                                                franjaHoraria aux=(franjaHoraria) aux2;
                                                if (!pos.equals(aux.getMarcat())) {
                                                    if (aux.getMarcat()) { // Si no són iguals i el vell està marcat, és que s'ha esborrat
                                                            frangesDel.addElement(aux.getId());
                                                    } else { // Si no són iguals i el vell està desmarcat, s'ha afegit
                                                            frangesAdd.addElement(aux.getId());
                                                    }
                                                }
					}
				}
			}
			x.actualitzarHoraris((professor)obtProfessorSeleccionat(),frangesDel,frangesAdd, HorarisProfessors.getSelectedIndex()+1);
                        JTable desti=getDestiProfessors();
                	carregarHorari((professor)obtProfessorSeleccionat(),desti);
		} else {
			int nColumnes=modelHorarisProfessor.getColumnCount();
			int nFiles=modelHorarisProfessor.getRowCount();
			Object[][] dades=new Object[nFiles][nColumnes];
			Object[] columnNames=new Object[6];
			columnNames[0]="";
			columnNames[1]="Dilluns";
			columnNames[2]="Dimarts";
			columnNames[3]="Dimecres";
			columnNames[4]="Dijous";
			columnNames[5]="Divendres";
			int i,j;
			dades[0][0]="8:00-8:30";
			dades[1][0]="8:30-9:00";
			dades[2][0]="9:00-9:30";
			dades[3][0]="9:30-10:00";
			dades[4][0]="10:00-10:30";
			dades[5][0]="10:30-11:00";
			dades[6][0]="11:00-11:30";
			dades[7][0]="11:30-12:00";
			dades[8][0]="12:00-12:30";
			dades[9][0]="12:30-13:00";
			dades[10][0]="13:00-13:30";
			dades[11][0]="13:30-14:00";
			dades[12][0]="14:00-14:30";
			dades[13][0]="14:30-15:00";
			dades[14][0]="15:00-15:30";
			dades[15][0]="15:30-16:00";
			dades[16][0]="16:00-16:30";
			dades[17][0]="16:30-17:00";
			dades[18][0]="17:00-17:30";
			dades[19][0]="17:30-18:00";
			dades[20][0]="18:00-18:30";
			dades[21][0]="18:30-19:00";
			dades[22][0]="19:00-19:30";
			dades[23][0]="19:30-20:00";
			dades[24][0]="20:00-20:30";
			dades[25][0]="20:30-21:00";
			for (i=0;i<nFiles;i++) {
				for (j=1;j<nColumnes;j++) {
					if (modelHorarisProfessor.getValueAt(i, j) instanceof franjaHoraria) dades[i][j]=((franjaHoraria)modelHorarisProfessor.getValueAt(i, j)).getMarcat();
                                        else dades[i][j]=true;
				}
			}
			TaulaBoolHoraris model=new TaulaBoolHoraris(dades,columnNames);
			getDestiProfessors().setModel(model);
			btnEditHorariProfessor.setText("Actualitzar");
			btnCancelEditHorariProfessor.setVisible(true);
			editarHorarisProfessors=true;
		}        // TODO add your handling code here:
	}//GEN-LAST:event_btnEditHorariProfessorMouseClicked

	private void btnCancelEditHorariProfessorMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnCancelEditHorariProfessorMouseClicked
		if (obtProfessorSeleccionat()!=null) {     
			carregarHorari((professor)obtProfessorSeleccionat(),getDestiProfessors());
			btnCancelEditHorari.setVisible(false);
			editarHorarisGrups=false;        // TODO add your handling code here:
		}
	}//GEN-LAST:event_btnCancelEditHorariProfessorMouseClicked

	private void btnDelProfActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDelProfActionPerformed
		professor p=(professor) obtProfessorSeleccionat();
		if (p!=null) {
			Object[] options = { "Si", "No" };
			Object opcio=JOptionPane.showOptionDialog(null,"Estàs segur que vols eliminar el professor "+p+"?\nS'eliminaràn també les seves assignatures capacitades i horaris", "Confirmació d'eliminació de professor",JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,null, options, options[1]);
			if (opcio.equals(0)){
				ctrl_professors c=new ctrl_professors();
				c.deleteProfessor(p);
				carregarProfessors();
			}
		}
	}//GEN-LAST:event_btnDelProfActionPerformed

        private void btnCreateDznFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCreateDznFileActionPerformed
            String fitxer=".//dadespfc.dzn";
            ctrl_capacitacions ctrl=new ctrl_capacitacions();
            ctrl_professors cpf=new ctrl_professors();
            ctrl_franja_horaries cfh=new ctrl_franja_horaries();
            ctrl_assignatures_tipologies_grup catg=new ctrl_assignatures_tipologies_grup();
            File output=new File(fitxer);
            if (output.exists()) {
                System.out.println("Fitxer existeix, sobreescrivim");
                output.delete();
            }
                int nProfessors=lstGeneralProfessors.getModel().getSize();
                int nAssignatures=treeAssignatures.getModel().getChildCount(treeAssignatures.getModel().getRoot());
                int nGrups=0;
                int i,j,k;
                String nomProfessors="";
                String minCredits="", maxCredits="", lstGrups="", lstCreditsGrups="", lstAssignatures="", lstTipologies="";
                
                for (i=0;i<nProfessors;i++) {
                    professor p=(professor) lstGeneralProfessors.getModel().getElementAt(i);
                    nomProfessors+="\"|"+p.getNom()+" "+p.getCognoms()+"\",";
                    minCredits+=p.getMinCredits()+",";
                    maxCredits+=p.getMaxCredits()+",";
                }
                minCredits=minCredits.substring(0,minCredits.length()-1);
                maxCredits=maxCredits.substring(0,maxCredits.length()-1);
                for (i=0;i<nAssignatures;i++) {
                    DefaultMutableTreeNode childTree=(DefaultMutableTreeNode) treeAssignatures.getModel().getChild(treeAssignatures.getModel().getRoot(), i);
                    int nChildren=childTree.getChildCount();
                    for (j=0;j<nChildren;j++) {
                        DefaultMutableTreeNode deepNode=((DefaultMutableTreeNode)childTree.getChildAt(j));
                        assignaturaTipologia at=(assignaturaTipologia) deepNode.getUserObject();
                        int nChildrenDeep=deepNode.getChildCount();
                        for (k=0;k<nChildrenDeep;k++) {
                            DefaultMutableTreeNode deeperNode=((DefaultMutableTreeNode)deepNode.getChildAt(k));
                            assignaturaTipologiaGrup atg=(assignaturaTipologiaGrup) deeperNode.getUserObject();
                            lstAssignatures+="\"|"+atg.getNom()+"\",";
                            lstTipologies+=atg.getTipologia()+",";
                            lstGrups+="\"|"+atg.getNomGrup()+"\",";
                            lstCreditsGrups+=at.getNcredits()+",";
                        }
                    }
                }
                Object[] grups=catg.selectAllGrups();
                nGrups=grups.length;
                String horaris_grups="|";
                for (i=0;i<nGrups;i++) {
                                assignaturaTipologiaGrup atg=(assignaturaTipologiaGrup) grups[i];
                                int quatrimestres=HorarisProfessors.getTabCount();
                                int q;
                                for (q=0;q<quatrimestres;q++) {
                                    Object[] horaris=cfh.selectHoresLliures(atg,q+1);
                                    for (j=0;j<horaris.length;j++) {
                                        horaris_grups+=horaris[j]+",";
                                    }   
                                }
                                horaris_grups=horaris_grups.substring(0, horaris_grups.length()-1)+"|";
                }
                minCredits=minCredits.substring(0,minCredits.length());
                maxCredits=maxCredits.substring(0,maxCredits.length());
                lstCreditsGrups=lstCreditsGrups.substring(0,lstCreditsGrups.length()-1);
                nomProfessors=nomProfessors.substring(0, nomProfessors.length()-1);

                Object[] llista_profes=cpf.selectAll();
                String horaris_profes="|";
                for (i=0;i<llista_profes.length;i++) {
                    int id=((professor)(llista_profes[i])).getId();
                    int quatrimestres=HorarisProfessors.getTabCount();
                    int q;
                    for (q=0;q<quatrimestres;q++) {
                        Object[] horaris=cfh.selectHoresLliures((professor)llista_profes[i],q+1);
                        for (j=0;j<horaris.length;j++) {
                            horaris_profes+=horaris[j]+",";
                        }    
                    }
                    horaris_profes=horaris_profes.substring(0, horaris_profes.length()-1)+"|";
                }
                
                int nFranges=cfh.selectAllFranges().length;

                String taula_capacitacions=ctrl.getTaulaCapacitacions();
                String[] auxCapacitacions=taula_capacitacions.substring(2, taula_capacitacions.length()-2).replace(",","").split("\\|");

                String[] auxHorarisGrups=horaris_grups.substring(1,horaris_grups.length()-1).replace(",","").split("\\|");
                String[] auxHorarisProfessors=horaris_profes.substring(1, horaris_profes.length()-1).replace(",","").split("\\|");
                String[][] incompatibles=new String[nGrups][nGrups];
                String[][] incompatiblesProfs=new String[nProfessors][nGrups];
                for (i=0;i<nGrups;i++) {
                    for (j=0;j<=i;j++) {    
                         int index=-1;
                         int assign1,assign2;
                        do {
                            index++;                          
                            if (auxHorarisGrups[i].charAt(index)=='1') assign1=1;
                            else assign1=0;
                            if (auxHorarisGrups[j].charAt(index)=='1') assign2=1;
                            else assign2=0;
                        } while ( assign1*assign2==0 && index<=nFranges);
                        if (index<=nFranges) {
                            incompatibles[i][j]="1";
                            incompatibles[j][i]="1";
                        } else {
                            incompatibles[i][j]="0";
                            incompatibles[j][i]="0";
                        }
                    }
                }
                String incompat="";
                for (i=0;i<nGrups;i++) {
                            for (j=0;j<nGrups;j++) {
                                incompat+=incompatibles[i][j]+",";
                            }
                            incompat=incompat.substring(0, incompat.length()-1)+"|";
                        }
                incompat="[|"+incompat.substring(0,incompat.length()-1)+"|]";

                for (i=0;i<nProfessors;i++) {
                    for (j=0;j<nGrups;j++) {
                         int index=-1;
                         int assign1,assign2;
                        do {
                            index++;
                            if (auxHorarisProfessors[i].charAt(index)=='1') assign1=1;                             
                            else assign1 = 0;
                            if (auxHorarisGrups[j].charAt(index)=='1') assign2=1;
                            else assign2=0;
                        } while ( assign1>=assign2 && index<=nFranges);
                        if (index<=nFranges) {
                            incompatiblesProfs[i][j]="1";
                        } else {
                            if (auxCapacitacions[i].charAt(j)=='0') incompatiblesProfs[i][j] = "1";
                            else incompatiblesProfs[i][j] = "0";
                        }
                    }
                }

                String incompatProfs="";
                for (i=0;i<nProfessors;i++) {
                            for (j=0;j<nGrups;j++) {
                                incompatProfs+=incompatiblesProfs[i][j]+",";
                            }
                            incompatProfs=incompatProfs.substring(0, incompatProfs.length()-1)+"|";
                        }
                incompatProfs="[|"+incompatProfs.substring(0,incompatProfs.length()-1)+"|]";

                try {
                    BufferedWriter bw = new BufferedWriter(new FileWriter(output));
                    String dadesfitxer="nprofessors="+nProfessors+";\n"+"nassignatures="+nGrups+";\n"+"nfranges="+nFranges*2+";\n"+"minCredits=["+minCredits+"]"+";\n"+"maxCredits=["+maxCredits+"]"+";\n"+"creditsAssignatura=["+lstCreditsGrups+"]"+";\n"+"capacitacions="+taula_capacitacions+";\n"+"nomGrups=["+lstGrups+"];\n"+"nomAssignatures=["+lstAssignatures+"];\n"+"tipologies=["+lstTipologies+"];\n"+"incompatibles="+incompat+";\n"+"incompatiblesProf="+incompatProfs+";\n"+"horarisAssignatures=["+horaris_grups+"];\n"+"horarisProfessors=["+horaris_profes+"];\n"+"nomProfessors=["+nomProfessors+"];\n";
                    /*bw.write("nprofessors="+nProfessors+";\n");
                    bw.write("nassignatures="+nGrups+";\n");
                    bw.write("nfranges="+nFranges*2+";\n");
                    bw.write("minCredits=["+minCredits+"]"+";\n");
                    bw.write("maxCredits=["+maxCredits+"]"+";\n");
                    //bw.write("Assignatures=["+lstGrups+"]"+";\n");
                    bw.write("creditsAssignatura=["+lstCreditsGrups+"]"+";\n");
                    bw.write("capacitacions="+ctrl.getTaulaCapacitacions()+";\n");
                    bw.write("horarisAssignatures=["+horaris_grups+"];\n");
                    bw.write("horarisProfessors="+horaris_profes+";\n");*/
                    bw.write(dadesfitxer);
                    bw.close();
                    txtOutput.setText(txtOutput.getText()+"Fitxer de dades creat correctament"+"\n");
                } catch (IOException ex) {
                    Logger.getLogger(MainAPP.class.getName()).log(Level.SEVERE, null, ex);
                }
        }//GEN-LAST:event_btnCreateDznFileActionPerformed

        private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
            MantenirPresolucions x=new MantenirPresolucions(this.getFrame(),true,obtProfessorSeleccionat(), HorarisGrups.getSelectedIndex()+1);
            x.setVisible(true);
            professor p=(professor) lstGeneralProfessors.getSelectedValue();
		if (x!=null) {
			carregarAssignaturesCapacitades(p);
			//carregarHorari(p);
			btnEditHorariProfessor.setVisible(true);
		}
            
        }//GEN-LAST:event_jButton1ActionPerformed

        private void HorarisGrupsMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_HorarisGrupsMouseClicked
            JTable desti=tblHoraris;
                switch (HorarisGrups.getSelectedIndex()) {
                    case 0:
                        desti=tblHoraris;
                        break;
                    case 1:
                        desti=tblHoraris2;
                        break;
                }
            Object seleccionat = ((DefaultMutableTreeNode) treeAssignatures.getLastSelectedPathComponent()).getUserObject();
				carregarHorari(seleccionat,desti);
				
            
        }//GEN-LAST:event_HorarisGrupsMouseClicked

        private void HorarisProfessorsMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_HorarisProfessorsMouseClicked
            JTable desti=getDestiProfessors();
            Object seleccionat=(professor)lstGeneralProfessors.getSelectedValue();
            carregarHorari(seleccionat,desti);
        }//GEN-LAST:event_HorarisProfessorsMouseClicked

        private void btnCreateFznFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCreateFznFileActionPerformed
                String args[]=new String[3];
                args[0]=".\\support\\runtimes\\minizinc\\bin\\mzn2fzn.bat";
                args[1]=".\\pfc.mzn";
                args[2]=".\\dadespfc.dzn";
                ArrayList<String> resposta=executaPrograma(args);
                Integer exitCode=Integer.parseInt(resposta.get(resposta.size()-1));
                if (exitCode==0) {
                    txtOutput.setText(txtOutput.getText()+"Fitxer fzn creat correctament"+"\n");
                } else {
                    txtOutput.setText(txtOutput.getText()+"Problemes creant fitxer fzn"+"\n");
                }
        }//GEN-LAST:event_btnCreateFznFileActionPerformed

        private void calculG12ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_calculG12ActionPerformed
            String args2[]=new String[2];
                args2[0]=".\\support\\runtimes\\minizinc\\bin\\flatzinc.exe";
                args2[1]=".\\pfc.fzn";
                ArrayList<String> resposta = executaPrograma(args2);
                Integer exitCode=Integer.parseInt(resposta.get(resposta.size()-1));
                if (exitCode==0) {
                    txtOutput.setText(txtOutput.getText()+"Execució del programa G12 completada, el resultat és:"+"\n");
                    resposta.remove(resposta.size()-1);
                    Writer output = null;
            File file = new File("resultat.txt");
            try {
                output = new BufferedWriter(new FileWriter(file));
                int f;
                for (f=0;f<resposta.size();f++) {
                    output.write(resposta.get(f));
                }
            } catch (IOException ex) {
                Logger.getLogger(MainAPP.class.getName()).log(Level.SEVERE, null, ex);
            } finally {
                try {
                    output.close();
                } catch (IOException ex) {
                    Logger.getLogger(MainAPP.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
                    parserResultats(resposta);
                } else {
                    txtOutput.setText(txtOutput.getText()+"Problemes creant fitxer fzn"+"\n");
                }
        }//GEN-LAST:event_calculG12ActionPerformed

        private void parserResultats(ArrayList<String> resposta) {
            if (resposta.get(0).equals("=====UNSATISFIABLE=====")) {
                        txtOutput.setText(txtOutput.getText()+"Model impossible de complir segons les dades introduides"+"\n");
                    } else if (resposta.get(resposta.size()-1).equals("----------")) {
                        txtOutput.setText(txtOutput.getText()+"Solució obtinguda:"+"\n");
                        int nlinies=resposta.size()-1;
                        int i=0;
                        String resultat="|";
                        for(i=0;i<nlinies;i++) {
                            String dividit[];

                            dividit=resposta.get(i).split("=");
                            if (dividit[0].trim().equals("credits")) {
                                dividit[1]=dividit[1].substring(9, dividit[1].length()-3);
                                String credits[]=dividit[1].split("\\[");
                                String dades[]=credits[0].split("\\.\\.");
                                String nprofessors=dades[1].trim();
                                nprofessors=nprofessors.substring(0, nprofessors.length()-1);
                                int profes=Integer.valueOf(nprofessors);
                                String ncredits[]=credits[1].split(",");
                                int j;
                                for (j=0;j<profes;j++) {
                                    txtOutput.setText(txtOutput.getText()+"Professor "+j+" té "+ncredits[j].trim()+" credits"+"\n");
                                }
                            } else if (dividit[0].trim().equals("solucio")) {
                                dividit[1]=dividit[1].substring(9, dividit[1].length()-3);
                                String solucio[]=dividit[1].split("\\[");
                                String taula[]=solucio[0].split(",");
                                String x[]=taula[0].split("\\.\\.");
                                String y[]=taula[1].split("\\.\\.");
                                String tresultats[]=solucio[1].split(",");
                                int nprofessors=Integer.valueOf(x[1]);
                                int nassignatures=Integer.valueOf(y[1]);
                                int j,k;

                                for (j=0;j<nprofessors;j++) {
                                    txtOutput.setText(txtOutput.getText()+"Professor "+j+":"+"\n");
                                    for (k=0;k<nassignatures;k++) {
                                        resultat+=tresultats[j*nassignatures+k].trim()+",";
                                        if (tresultats[j*nassignatures+k].trim().equals("1")) {
                                            txtOutput.setText(txtOutput.getText()+">>>ATG "+k+"\n");
                                        }
                                    }
                                    resultat+="|";
                                }

                            }



                            //System.out.println(dividit[1]);
                        }
                        VisorResultats vr = new VisorResultats(this.getFrame(),true, resultat);
                            vr.setVisible(true);
                        String dividit=null;

                    }
        }

        private void calculgecodeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_calculgecodeActionPerformed
            String args2[]=new String[2];
                args2[0]=".//support//runtimes//gecode//bin//fz.exe";
                args2[1]=".//pfc.fzn";
                ArrayList<String> resposta = executaPrograma(args2);
                Integer exitCode=Integer.parseInt(resposta.get(resposta.size()-1));
                if (exitCode==0) {
                    txtOutput.setText(txtOutput.getText()+"Execució del programa G12 completada, el resultat és:"+"\n");
                    resposta.remove(resposta.size()-1);
                    Writer output = null;
            File file = new File("resultat.txt");
            try {
                output = new BufferedWriter(new FileWriter(file));
                int f;
                for (f=0;f<resposta.size();f++) {
                    output.write(resposta.get(f));
                }
            } catch (IOException ex) {
                Logger.getLogger(MainAPP.class.getName()).log(Level.SEVERE, null, ex);
            } finally {
                try {
                    output.close();
                } catch (IOException ex) {
                    Logger.getLogger(MainAPP.class.getName()).log(Level.SEVERE, null, ex);
                }
            }

                    parserResultats(resposta);
                } else {
                    txtOutput.setText(txtOutput.getText()+"Problemes creant fitxer fzn"+"\n");
                }
        }//GEN-LAST:event_calculgecodeActionPerformed

        public static void addPath(String s) throws Exception {
              File f = new File(s);
              URL u = f.toURL();
              URLClassLoader urlClassLoader = (URLClassLoader) ClassLoader.getSystemClassLoader();
              Class urlClass = URLClassLoader.class;
              Method method = urlClass.getDeclaredMethod("addURL", new Class[]{URL.class});
              method.setAccessible(true);
              method.invoke(urlClassLoader, new Object[]{u});
        }

        public ArrayList<String> llegirFitxerResultat(String path) {
        ArrayList<String> resposta=new ArrayList<String>();
        FileReader fr = null;
        String sCadena;
        try {
            fr = new FileReader(path);
            BufferedReader bf = new BufferedReader(fr);
            while ((sCadena = bf.readLine()) != null) {
                //System.out.println(sCadena);
                resposta.add(sCadena);
            }
        } catch (IOException ex) {
            Logger.getLogger(MainAPP.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            try {
                fr.close();
            } catch (IOException ex) {
                Logger.getLogger(MainAPP.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
                    return resposta;
        }

        private void calculfzn2smtActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_calculfzn2smtActionPerformed
            fzn2smt f=new fzn2smt();
            f.setYices("./yices.exe -f");
            f.setInput("./pfc.fzn");
        try {
            f.execute();
        } catch (Exception ex) {
            Logger.getLogger(MainAPP.class.getName()).log(Level.SEVERE, null, ex);
        }
        }//GEN-LAST:event_calculfzn2smtActionPerformed

        private void mostrarResultatsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mostrarResultatsActionPerformed
            ArrayList<String> resultat=llegirFitxerResultat("./resultat.txt");
            parserResultats(resultat);
        }//GEN-LAST:event_mostrarResultatsActionPerformed


        public ArrayList<String> executaPrograma(String args[]) {
            Runtime runtime = Runtime.getRuntime();

        String[] command = args;
        ProcessBuilder probuilder = new ProcessBuilder( command );

        ArrayList<String> output=new ArrayList();
        Process process = null;
        try {
            int i;
            process = probuilder.start();
        InputStream is = process.getInputStream();
        InputStreamReader isr = new InputStreamReader(is);
        BufferedReader br = new BufferedReader(isr);
        String line;
        while ((line = br.readLine()) != null) {
            System.out.println(line);
            output.add(line);
        }
        } catch (IOException ex) {
            Logger.getLogger(MainAPP.class.getName()).log(Level.SEVERE, null, ex);
        }

        //Wait to get exit value
        try {
            int exitValue = process.waitFor();
            output.add(String.valueOf(exitValue));
        } catch (InterruptedException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
         return output;
        }

	public class TaulaHoraris extends DefaultTableModel {
		private TaulaHoraris(Object[][] lstProfessors, Object[] columnNames) {
			super(lstProfessors,columnNames);
		}
		@Override
			public Class getColumnClass(int columna) {
				if (columna == 0) return String.class;
				return franjaHoraria.class;
			}
	}

	public class TaulaBoolHoraris extends DefaultTableModel {
		private TaulaBoolHoraris(Object[][] lstProfessors, Object[] columnNames) {
			super(lstProfessors,columnNames);
		}
		@Override
			public Class getColumnClass(int columna) {
				if (columna == 0) return String.class;
				return Boolean.class;
			}
	}

	public Color colorTipologia(int idTipologia) {
		switch(idTipologia) {
			case 0:
				return Color.GRAY;
			case 1:
				return Color.ORANGE;
			case 2:
				return Color.GREEN;
			case 3:
				return Color.YELLOW;
		}
		return null;
	}

	public class RenderHoraris extends JLabel implements TableCellRenderer {

		public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
			JLabel Etiq=new JLabel();
			Etiq.setHorizontalAlignment(CENTER);
			if (value instanceof preSolucio) {
                                preSolucio x=(preSolucio)value;
                                professor px=x.getProfessor();
                                Etiq.setToolTipText("Grup Preassignat a "+px.toString());
                                Etiq.setOpaque(true);
				Etiq.setBackground(Color.RED);
				Etiq.setText("Preassignat");
				return Etiq;
                        } else if (value instanceof franjaHoraria) {
				franjaHoraria x = (franjaHoraria) value;
				if (x.getMarcat()==true) {
					Etiq.setOpaque(true);
					Etiq.setBackground(Color.BLUE);
					return Etiq;
				} else return null;
			} else if (value instanceof assignaturaTipologiaGrup) {
				assignaturaTipologiaGrup x = (assignaturaTipologiaGrup)value;
				Etiq.setOpaque(true);
				Etiq.setBackground(colorTipologia(x.getTipologia()));
				Etiq.setText(x.getNomGrup());
				Etiq.setToolTipText(x.getNomGrup());
				return Etiq;
			} else if (value instanceof ArrayList) {
				ArrayList x = (ArrayList) value;
				int i, len=x.size();
				String text="";
				for (i=0;i<len;i++) {
                                        if (x.get(i) instanceof assignaturaTipologiaGrup) {
                                            assignaturaTipologiaGrup aux=(assignaturaTipologiaGrup) x.get(i);
                                            if (text.equals("")) {
                                                text=aux.getNomGrup();
                                                Etiq.setToolTipText("<html><body>Grup "+aux.getNomGrup());
                                            } else {
                                                text+=" / "+aux.getNomGrup();
                                                Etiq.setToolTipText(Etiq.getToolTipText()+"<br />Grup "+aux.getNomGrup());
                                            }
                                        } else {
                                            preSolucio aux2=(preSolucio) x.get(i);
                                            if (text.equals("")) {
                                                text=aux2.getAtg().getNomGrup();
                                                Etiq.setToolTipText("<html><body>Grup donat per "+aux2.getProfessor().toString());
                                            } else {
                                                Etiq.setToolTipText(Etiq.getToolTipText()+"<br />Grup donat per "+aux2.getProfessor().toString());
                                                text+=" / "+aux2.getAtg().getNomGrup();
                                            }
                                        }
				}
				Etiq.setText(text);
                                Etiq.setToolTipText(Etiq.getToolTipText()+"</body></html>");
				Etiq.setOpaque(true);
				return Etiq;
			} else return null;
		}
	}

	private boolean editarHorarisGrups, editarHorarisProfessors;
	private DefaultTableModel modelHoraris, modelHorarisProfessor;
        private HashMap llistaPreSolucions, auxPreSolucions;
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTabbedPane HorarisGrups;
    private javax.swing.JTabbedPane HorarisProfessors;
    private javax.swing.JButton btnAdd;
    private javax.swing.JButton btnAddProfessor;
    private javax.swing.JButton btnAddProfessors;
    private javax.swing.JButton btnCancelEditHorari;
    private javax.swing.JButton btnCancelEditHorariProfessor;
    private javax.swing.JButton btnCreateDznFile;
    private javax.swing.JButton btnCreateFznFile;
    private javax.swing.JButton btnDelProf;
    private javax.swing.JButton btnDelete;
    private javax.swing.JButton btnDeleteProfessor;
    private javax.swing.JButton btnEdit;
    private javax.swing.JButton btnEditHorari;
    private javax.swing.JButton btnEditHorariProfessor;
    private javax.swing.JButton btnEditProfessors;
    private javax.swing.JButton calculG12;
    private javax.swing.JButton calculfzn2smt;
    private javax.swing.JButton calculgecode;
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JScrollPane jScrollPane7;
    private javax.swing.JTabbedPane jTabbedPanePrincipal;
    private javax.swing.JList lstGeneralProfessors;
    private javax.swing.JList lstProfessors;
    private javax.swing.JButton mostrarResultats;
    private javax.swing.JScrollPane spGeneralProfessors;
    private javax.swing.JScrollPane spProfessors;
    private javax.swing.JLabel statusAnimationLabel;
    private javax.swing.JLabel statusMessageLabel;
    private javax.swing.JPanel statusPanel;
    private javax.swing.JTable tblHoraris;
    private javax.swing.JTable tblHoraris2;
    private javax.swing.JTable tblHorarisProfessors;
    private javax.swing.JTable tblHorarisProfessors2;
    private javax.swing.JTree treeAssigCapacitades;
    private javax.swing.JTree treeAssignatures;
    private javax.swing.JTextArea txtOutput;
    // End of variables declaration//GEN-END:variables
}
