grammar CompFlatzincResult; 

options{
	output=AST;
	}

@header {
import java.io.*; 
import java.lang.Object; 
import java.util.Vector;   
import java.util.Set;   
import java.util.SortedSet;   
import java.util.TreeSet;   
import java.util.Iterator;  
}  

@members {
	SymTable<Regsort> stsort=new SymTable<Regsort>(10);
	boolean expandir=false;
	ListString slig=new ListString();
	int contslig=0;
	String esoguio=" ";
	String po="(";
	String pt=")";

    	public void displayRecognitionError(String[] tokenNames,RecognitionException e) {
        	String hdr = getErrorHeader(e);
        	String msg = getErrorMessage(e, tokenNames);
        	System.err.println("     ");
    	}

	private String treure_V(String a)
	{
		if (a==null)
		{
			return("");
		}
		else
		{
			String aux="";
			int c=0;
			int i1=a.indexOf("V",c);
			int i2=a.indexOf("N",c);		
			int i;
			if (i1==(-1)) {i=i2;} else {if (i2==(-1)) {i=i1;} else {if (i1<i2) {i=i1;} else {i=i2;}}}
			while (i!=(-1))
			{
				aux=aux+a.substring(c,i);
				c=i+1;			
				i1=a.indexOf("V",c);
				i2=a.indexOf("N",c);
				if (i1==(-1)) {i=i2;} else {if (i2==(-1)) {i=i1;} else {if (i1<i2) {i=i1;} else {i=i2;}}}
			}
			aux=aux+a.substring(c,a.length());
			return(aux);
		}
	}
	
	private void traspas_a_registre_sortida(SymTable<Registre> st, SymTable<Regsort> stsort)
	{
		Iterator<String> s=st.conjuntClaus().iterator();
		Registre r;
		while (s.hasNext())
		{
			r=st.obtenir(s.next());
			String lexema=r.getLexema();
			String out=r.getOut();
			Boolean ini=r.getInicialitzat();
			if (!r.getIgual().equals(""))
			{
				r=st.obtenir(r.getIgual());
			}
			if (!out.equals(""))
			{
				Regsort rs=new Regsort();
				rs.putLexema(lexema);
				rs.putSignatura(treure_V(r.getSignatura()));
				rs.putInicialitzat(ini);
				rs.putOut(out);				
				if (rs.getInicialitzat()) 
				{
					rs.putVariable("N");
				} 
				else 
				{
					rs.putVariable("V");
				}
				rs.putValor("");
				if (rs.getSignatura().equals("B")) {rs.putValor(((Boolean)r.getValorBool()).toString());}
				if (rs.getSignatura().equals("I")) {rs.putValor(((Integer)r.getValorInt()).toString());}
				if (rs.getSignatura().equals("F")) {rs.putValor(((Float)r.getValorFloat()).toString());}
				rs.putValorArray(r.getValorArray());
				rs.putDim(r.getDim());
				rs.putValorSet(r.getValorSet());
				stsort.inserir(rs.getLexema(),rs);
			}
		}
		
	}
	
	private void imprimir_sortida(SymTable<Regsort> stsort,SymTable<Registre> st)
	{
		SortedSet<String> ordenats=new TreeSet<String>();
		ordenats.addAll(stsort.conjuntClaus());
		Iterator<String> s=ordenats.iterator();
		Regsort rs;
		while (s.hasNext())
		{
			rs=stsort.obtenir(s.next());
			String outa=rs.getOut();
			String signatura=rs.getSignatura();
			if (signatura.equals("I") || signatura.equals("B") || signatura.equals("F")) 
			{
				if (rs.getInicialitzat())
				{
					System.out.println(rs.getLexema()+" = "+rs.getValor()+";");
				}
				else
				{
					System.out.println(rs.getLexema()+" = "+"undefined;");
				}
			}
			else
			{
				if (signatura.equals("SI"))
				{
					System.out.print(rs.getLexema()+" = {");
					ListBool ls=rs.getValorSet();
					Boolean primer=true;
					SortedSet<Integer> ordenats2=new TreeSet<Integer>();
					ordenats2.addAll(ls.conjuntClaus());
					Iterator<Integer> j=ordenats2.iterator();
					while (j.hasNext())
					{
						Integer r=j.next();
						if (ls.existeix(r))
						{
							if (!primer) {System.out.print(", ");} else {primer=false;}
							System.out.print(r.toString());
						}
					}
					System.out.println("};");
				}
				else
				{
					System.out.print(rs.getLexema()+" = ");
					if (!outa.equals("output")) {System.out.print("array"+outa+", ");}
					System.out.print("[");
					ListString ls=rs.getValorArray();
					int dim=rs.getDim();
					for (int j=1; j<=dim; j++)
					{
						if (j>1) {System.out.print(", ");}
						if (ls.existeix(j))
						{
							if (signatura.equals("[SI"))
							{
								Registre rs2=st.obtenir(ls.obtenir(j));
								System.out.print("{");
								ListBool lb=rs2.getValorSet();
								Boolean primer=true;
								SortedSet<Integer> ordenats3=new TreeSet<Integer>();
								ordenats3.addAll(lb.conjuntClaus());
								Iterator<Integer> j2=ordenats3.iterator();
								while (j2.hasNext())
								{
									Integer r=j2.next();
									if (lb.existeix(r))
									{
										if (!primer) {System.out.print(", ");} else {primer=false;}
										System.out.print(r.toString());
									}
								}
								System.out.print("}");
							}
							else //vector de diferents de set
							{
								System.out.print(ls.obtenir(j));
							}
						}
						else
						{
								System.out.print("undefined");
						}
					}
					System.out.print("]");
					if (!outa.equals("output")) {System.out.print(")");}
					System.out.println(";");
				} 
			}
		}
	}


	private void no_inicialitzats_igual(SymTable<Registre> st)	
	{
		Boolean nomod=true;
		while (nomod && slig.tamany()!=0)
		{
			nomod=false;
			Iterator<Integer> it=slig.conjuntClaus().iterator();
			while (it.hasNext())
			{
				Integer iio=it.next();
				String ss=slig.obtenir(iio);
				String s2[]=ss.split("#");
				Registre rig1=st.obtenir(s2[0]);
				Registre rig2=st.obtenir(s2[1]);
				if (!rig1.getInicialitzat() && rig2.getInicialitzat())
				{
					nomod=true;
					rig1.putIgual(rig2.getLexema());
					rig1.putInicialitzat(true);
					st.modificar(rig1.getLexema(),rig1);
				}
				rig1=st.obtenir(s2[0]);	
				if (rig1.getInicialitzat() && !rig2.getInicialitzat())
				{
					nomod=true;
					rig2.putIgual(rig1.getLexema());
					rig2.putInicialitzat(true);
					st.modificar(rig2.getLexema(),rig2);	
				}
				//slig.esborrar(iio);	
			}
		}
	}
}

model [SymTable<Registre> st, boolean exp, Boolean max] returns [String valor]
	:	'sat'  
		{	
			expandir=$exp;
			$valor="";
		} 
		'MODEL' 
		(ig=igualtats[$st, $exp, $max] 
			{if ($ig.maxi.equals("maximize_")) {$valor=$ig.maxv;}}
		)* 
		{
			if (!$max)
			{
				no_inicialitzats_igual($st);
				slig=new ListString();
				traspas_a_registre_sortida($st, stsort);
				imprimir_sortida(stsort,$st);
				System.out.println("----------");
			}
		}
	|	'unsat'  .* {$valor="unsat";if (!$max) {System.out.println("=====UNSATISFIABLE=====");}} 
	|	'unknown' .* {$valor="unKnown";System.out.println("unknown");if (!$max) {System.out.println("=====UNKNOWN=====");}} 
	;	

igualtats [SymTable<Registre> st, boolean exp, Boolean max] returns [String maxi,String maxv]
	:	'(' '=' i=identifier v=valor')' 
		{
			$maxi=$i.id;
			$maxv=$v.val;
			if (!$max)
			{
				String id=$i.id;
				String pos=$i.pos;
				String vset="";
				String auxaux1="";
				String auxaux2="";
				String auxaux3="";
				String auxaux4="";
				auxaux4=id;
				if (id.matches("[a-zA-Z0-9_-]+_-?[0-9]+_") && pos.equals(""))
				{
					int ii=id.length();
					ii--;
					char a=id.charAt(ii-1);
					while (a!='_')
					{
						ii--;
						a=id.charAt(ii);
					}
					id=$i.id.substring(0,ii);
					pos=$i.id.substring(ii+1,$i.id.length()-1);
					auxaux3=id;
					/*if (id.matches("[a-zA-Z0-9_]+__i-i"))
					{
						id=id.substring(0,id.length()-3);
					}*/
					auxaux2=id;
					if (id.matches("[a-zA-Z0-9_]+_i-i"))
					{
						id=id.substring(0,id.length()-4);
					}
					auxaux1=id;
					if (id.matches("[a-zA-Z0-9_]+_-?[0-9]+_"))
					{
						int ii2=id.length();
						ii2--;
						char a2=id.charAt(ii2-1);
						while (a2!='_')
						{
							ii2--;
							a2=id.charAt(ii2);
						}
						vset=pos;
						pos=id.substring(ii2+1,id.length()-1);
						id=id.substring(0,ii2);
					}
				}
				Registre r;
				if (!$st.existeix(id))
				{
					id=auxaux1;
					pos=vset;
					vset="";
					if (!$st.existeix(auxaux1))
					{
						id=auxaux2;
						if (!$st.existeix(auxaux2))
						{
							id=auxaux3;
							if (!$st.existeix(auxaux3))
							{
								id=$i.id;
								pos=$i.pos;	
								r=$st.obtenir(auxaux4);					}
							else
							{
								r=$st.obtenir(auxaux3);
							}
						}
						else
						{
							r=$st.obtenir(auxaux2);
						}
					}
					else
					{
						r=$st.obtenir(auxaux1);
					}
	
			}
				else
				{
					r=$st.obtenir(id);
				}
				id=r.getLexema();
				String signatura=treure_V(r.getSignatura());
				if (signatura.equals("SI") && vset.equals("")) {vset=pos;pos="";}			
				if (!$v.tipus.equals("S"))
				{
					if (signatura.equals("I") || signatura.equals("B") || signatura.equals("F")) 
					{
						if (signatura.equals("B")) {r.putValorBool(Boolean.parseBoolean($v.val));}
						if (signatura.equals("I")) {r.putValorInt(Integer.parseInt($v.val));}
						if (signatura.equals("F")) 
						{
							Float f3;
							if ($v.val.matches(".*/.*"))
							{
								String[] ff=new String[2];
								ff[0]="";
								ff[1]="";
								ff=$v.val.split("/");
								Integer i11=Integer.parseInt(ff[0]);
								Integer i12=Integer.parseInt(ff[1]);
								Float f1=i11.floatValue();
								Float f2=i12.floatValue();
								f3=f1/f2;
							}	
							else
							{
								Integer i11=Integer.parseInt($v.val);
								f3=i11.floatValue();
							}
							r.putValorFloat(f3);
						}				
					}
					else
					{
						if (signatura.equals("SI"))
						{
							ListBool lb=r.getValorSet();
							if (!lb.existeix(Integer.parseInt(vset)) && $v.tipus.equals("B"))
							{
								if (Boolean.parseBoolean($v.val))
								{
									lb.inserir(Integer.parseInt(vset),true);
									r.putValorSet(lb);
								}
							}
						}
						else
						{
							if (signatura.equals("[SI"))
							{
								ListString ls=r.getValorArray();
								String s=ls.obtenir(Integer.parseInt(pos));
								Registre r2=st.obtenir(s);
								ListBool lb=r2.getValorSet();
								if (!lb.existeix(Integer.parseInt(vset)) && $v.tipus.equals("B"))
								{
									if (Boolean.parseBoolean($v.val))
									{
										lb.inserir(Integer.parseInt(vset),true);
									}
								}
								/*else
								{
									if (Boolean.parseBoolean($v.val))
									{
										lb.modificar(Integer.parseInt(vset),true);
									}
								}*/
								r2.putValorSet(lb);
								r2.putInicialitzat(true);
								st.modificar(r2.getLexema(),r2);
							}
							else //vector de diferents de set
							{
								ListString ls=r.getValorArray();
								if (!ls.existeix(Integer.parseInt(pos)))
								{
									ls.inserir(Integer.parseInt(pos),$v.val);
								}
								else
								{
									ls.modificar(Integer.parseInt(pos),$v.val);
								}
								r.putValorArray(ls);
							}
						}
					}
					r.putInicialitzat(true);
					st.modificar(r.getLexema(),r);
				}
				else
				{
					Registre r1=$st.obtenir($i.text);
					Registre r2=$st.obtenir($v.text);
					if (!r1.getInicialitzat() || !r2.getInicialitzat()) 
					{
						contslig++;
						slig.inserir(contslig,r1.getLexema()+"#"+r2.getLexema());
					}
				}
			}
		}
	;	

identifier returns [String id, String pos]
	:	i=IDENT {$id=$i.text;$pos="";}
	|	'(' i=IDENT i2=INT_LITERAL')'{$id=$i.text;$pos=$i2.text;}
	;
	
valor returns [String tipus, String val]
	:	i=INT_LITERAL {$tipus="I";$val=$i.text;}
	|	t=INT_LITERAL '/' t2=INT_LITERAL {$tipus="F";$val=$t.text+"/"+$t2.text;}
	|	'true' {$tipus="B";$val="true";}
	|	'false' {$tipus="B";$val="false";}
	|	z=IDENT {$tipus="S";$val=$z.text;}
	;
	
INT_LITERAL 
	: 	('-')?('0'..'9')+  
	;

FLOAT_LITERAL 
	: 	(('-')?('0'..'9')+ '.' ('0'..'9')+ )  => ('-')?('0'..'9')+ '.' ('0'..'9')+  
			(
			 ('E' | 'e') ('+'|'-')? ('0'..'9')+ 
			|
			)
		| ('-')?('0'..'9')+ (
					('E' | 'e') ('+'|'-')? ('0'..'9')+ 
					| {$type=INT_LITERAL;}
					)
	;

	
WS
	: (' '|'\n'|'\r'|'\t')+	{$channel=HIDDEN;}   //ignore whitespace
	;	
COMMENT
	: '---'
		( '-' {$channel=HIDDEN;}
		 | ~('-') .* '---'	{$channel=HIDDEN;}  //ignore comments
		)
	| 'no default' {$channel=HIDDEN;}
	;	

IDENT
	:	 
	('A'..'Z'|'a'..'z')('A'..'Z'|'a'..'z'|'0'..'9'|'_'|'-')*
	;