tree grammar CompFlatzincWalker; 

options{
	tokenVocab=CompFlatzinc;
	ASTLabelType=CommonTree;  
	output=AST;
	}

@header {
import java.io.*; 
import java.lang.Object; 
import java.util.Vector;   
import java.util.Set;   
import java.util.SortedSet;   
import java.util.TreeSet;   
import java.util.Iterator;  
}  

@members {
	SymTable<Registre> st=new SymTable<Registre>(1000); 
	boolean error=false;
	Integer conterror=0;
	String[] nomErr=new String[30]; 
	Vector<String> smt=new Vector<String>(4000);
	int temp=0;
	int litexp=0;
	int litcum=0;
	boolean reals=false;
	boolean vectors=false;
	boolean sets=false;
	boolean lia=false;	
	boolean nia=false;	
	SymTable<String> extrafuns=new SymTable<String>(1000);
	SymTable<String> extrapreds=new SymTable<String>(1000);
	boolean expandir=false;
	int deflow=-10000000;
	int defup=10000000;
	String codi="codi.smt";
	String esoguio=" ";
	String po="(";
	String pt=")";
	boolean executar;
	Boolean solveKindMax=false;
	String solveMin=((Integer)deflow).toString();
	String solveMax=((Integer)defup).toString();
	boolean minzero;
	
	
	
	private void afegir_predicats()
	{
	Registre r;
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("array_bool_and"); r.putSignatura("V[B,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("array_bool_element"); r.putSignatura("VI,V[B,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("array_bool_or"); r.putSignatura("V[B,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("array_float_element"); r.putSignatura("VI,V[F,VF");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("array_int_element"); r.putSignatura("VI,V[I,VI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("array_set_element"); r.putSignatura("VI,V[SI,VSI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("array_var_bool_element"); r.putSignatura("VI,V[B,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("array_var_float_element"); r.putSignatura("VI,V[F,VF");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("array_var_int_element"); r.putSignatura("VI,V[I,VI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("array_var_set_element"); r.putSignatura("VI,V[SI,VSI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("bool2int"); r.putSignatura("VB,VI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("bool_and"); r.putSignatura("VB,VB,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("bool_clause"); r.putSignatura("V[B,V[B");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("bool_clause_reif"); r.putSignatura("V[B,V[B,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("bool_eq"); r.putSignatura("VB,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("bool_eq_reif"); r.putSignatura("VB,VB,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("bool_ge"); r.putSignatura("VB,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("bool_ge_reif"); r.putSignatura("VB,VB,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("bool_gt"); r.putSignatura("VB,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("bool_gt_reif"); r.putSignatura("VB,VB,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("bool_le"); r.putSignatura("VB,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("bool_le_reif"); r.putSignatura("VB,VB,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("bool_left_imp"); r.putSignatura("VB,VB,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("bool_lt"); r.putSignatura("VB,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("bool_lt_reif"); r.putSignatura("VB,VB,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("bool_ne"); r.putSignatura("VB,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("bool_ne_reif"); r.putSignatura("VB,VB,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("bool_not"); r.putSignatura("VB,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("bool_or"); r.putSignatura("VB,VB,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("bool_right_imp"); r.putSignatura("VB,VB,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("bool_xor"); r.putSignatura("VB,VB,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(true);r.putLexema("float_abs"); r.putSignatura("VF,VF");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(true);r.putLexema("float_div"); r.putSignatura("VF,VF,VF");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("float_eq"); r.putSignatura("VF,VF");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("float_eq_reif"); r.putSignatura("VF,VF,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("float_ge"); r.putSignatura("VF,VF");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("float_ge_reif"); r.putSignatura("VF,VF,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("float_gt"); r.putSignatura("VF,VF");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("float_gt_reif"); r.putSignatura("VF,VF,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("float_le"); r.putSignatura("VF,VF");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("float_le_reif"); r.putSignatura("VF,VF,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(true);r.putLexema("float_lin_eq"); r.putSignatura("[F,V[F,F");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(4);r.putLia(true);r.putLexema("float_lin_eq_reif"); r.putSignatura("[F,V[F,F,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(true);r.putLexema("float_lin_ge"); r.putSignatura("[F,V[F,F");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(4);r.putLia(true);r.putLexema("float_lin_ge_reif"); r.putSignatura("[F,V[F,F,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(true);r.putLexema("float_lin_gt"); r.putSignatura("[F,V[F,F");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(4);r.putLia(true);r.putLexema("float_lin_gt_reif"); r.putSignatura("[F,V[F,F,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(true);r.putLexema("float_lin_le"); r.putSignatura("[F,V[F,F");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(4);r.putLia(true);r.putLexema("float_lin_le_reif"); r.putSignatura("[F,V[F,F,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(true);r.putLexema("float_lin_lt"); r.putSignatura("[F,V[F,F");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(4);r.putLia(true);r.putLexema("float_lin_lt_reif"); r.putSignatura("[F,V[F,F,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(true);r.putLexema("float_lin_ne"); r.putSignatura("[F,V[F,F");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(4);r.putLia(true);r.putLexema("float_lin_ne_reif"); r.putSignatura("[F,V[F,F,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("float_lt"); r.putSignatura("VF,VF");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("float_lt_reif"); r.putSignatura("VF,VF,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("float_max"); r.putSignatura("VF,VF,VF");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("float_min"); r.putSignatura("VF,VF,VF");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("float_minus"); r.putSignatura("VF,VF,VF");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("float_ne"); r.putSignatura("VF,VF");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("float_ne_reif"); r.putSignatura("VF,VF,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("float_negate"); r.putSignatura("VF,VF");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("float_plus"); r.putSignatura("VF,VF,VF");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(true);r.putLexema("float_times"); r.putSignatura("VF,VF,VF");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("int_abs"); r.putSignatura("VI,VI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(true);r.putLexema("int_div"); r.putSignatura("VI,VI,VI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("int_eq"); r.putSignatura("VI,VI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("int_eq_reif"); r.putSignatura("VI,VI,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("int_ge"); r.putSignatura("VI,VI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("int_ge_reif"); r.putSignatura("VI,VI,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("int_gt"); r.putSignatura("VI,VI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("int_gt_reif"); r.putSignatura("VI,VI,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("int_le"); r.putSignatura("VI,VI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("int_le_reif"); r.putSignatura("VI,VI,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(true);r.putLexema("int_lin_eq"); r.putSignatura("[I,V[I,I");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(4);r.putLia(true);r.putLexema("int_lin_eq_reif"); r.putSignatura("[I,V[I,I,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(true);r.putLexema("int_lin_ge"); r.putSignatura("[I,V[I,I");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(4);r.putLia(true);r.putLexema("int_lin_ge_reif"); r.putSignatura("[I,V[I,I,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(true);r.putLexema("int_lin_gt"); r.putSignatura("[I,V[I,I");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(4);r.putLia(true);r.putLexema("int_lin_gt_reif"); r.putSignatura("[I,V[I,I,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(true);r.putLexema("int_lin_le"); r.putSignatura("[I,V[I,I");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(4);r.putLia(true);r.putLexema("int_lin_le_reif"); r.putSignatura("[I,V[I,I,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(true);r.putLexema("int_lin_lt"); r.putSignatura("[I,V[I,I");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(4);r.putLia(true);r.putLexema("int_lin_lt_reif"); r.putSignatura("[I,V[I,I,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(true);r.putLexema("int_lin_ne"); r.putSignatura("[I,V[I,I");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(4);r.putLia(true);r.putLexema("int_lin_ne_reif"); r.putSignatura("[I,V[I,I,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("int_lt"); r.putSignatura("VI,VI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("int_lt_reif"); r.putSignatura("VI,VI,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("int_max"); r.putSignatura("VI,VI,VI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("int_min"); r.putSignatura("VI,VI,VI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("int_minus"); r.putSignatura("VI,VI,VI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(true);r.putLexema("int_mod"); r.putSignatura("VI,VI,VI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("int_ne"); r.putSignatura("VI,VI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("int_ne_reif"); r.putSignatura("VI,VI,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("int_negate"); r.putSignatura("VI,VI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("int_plus"); r.putSignatura("VI,VI,VI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(true);r.putLexema("int_times"); r.putSignatura("VI,VI,VI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("int2float"); r.putSignatura("VI,VF");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(true);r.putLexema("set_card"); r.putSignatura("VSI,VI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("set_diff"); r.putSignatura("VSI,VSI,VSI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("set_eq"); r.putSignatura("VSI,VSI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("set_eq_reif"); r.putSignatura("VSI,VSI,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("set_ge"); r.putSignatura("VSI,VSI");st.inserir(r.getLexema(),r); 
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("set_ge_reif"); r.putSignatura("VSI,VSI,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("set_gt"); r.putSignatura("VSI,VSI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("set_gt_reif"); r.putSignatura("VSI,VSI,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("set_in"); r.putSignatura("VI,VSI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("set_in_reif"); r.putSignatura("VI,VSI,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("set_intersect"); r.putSignatura("VSI,VSI,VSI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("set_le"); r.putSignatura("VSI,VSI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("set_le_reif"); r.putSignatura("VSI,VSI,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("set_lt"); r.putSignatura("VSI,VSI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("set_lt_reif"); r.putSignatura("VSI,VSI,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("set_ne"); r.putSignatura("VSI,VSI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("set_ne_reif"); r.putSignatura("VSI,VSI,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("set_subset"); r.putSignatura("VSI,VSI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("set_subset_reif"); r.putSignatura("VSI,VSI,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(2);r.putLia(false);r.putLexema("set_superset"); r.putSignatura("VSI,VSI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("set_superset_reif"); r.putSignatura("VSI,VSI,VB");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("set_symdiff"); r.putSignatura("VSI,VSI,VSI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(3);r.putLia(false);r.putLexema("set_union"); r.putSignatura("VSI,VSI,VSI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(1);r.putLia(false);r.putLexema("fzn2smt_all_different_int"); r.putSignatura("[VI");st.inserir(r.getLexema(),r);
	r=new Registre();r.putTipus('P');r.putDim(4);r.putLia(true);r.putLexema("fzn2smt_cumulative"); r.putSignatura("[VI,[VI,[VI,VI");st.inserir(r.getLexema(),r);
	}
	
	
	private void inicialitzarError() 
	{
		nomErr[1]="Identifier declaration error";
		nomErr[2]="Unexpected Boolean literal";
		nomErr[3]="Unexpected Integer literal";
		nomErr[4]="Unexpected Float literal";
		nomErr[5]="Unexpected String literal";
		nomErr[6]="Undeclared identifier";
		nomErr[7]="Wrong type";
		nomErr[8]="Only integer set allowed";
		nomErr[9]="Array dimension error";
		nomErr[10]="Wrong predicate parameters";
		nomErr[11]="Unsuportted predicate";
		nomErr[12]="Array expected";
		nomErr[13]="Out of range";
		nomErr[14]="Array dimension error";
		nomErr[15]="Set variable domain must be bounded";
		nomErr[16]="Wrong range";
		nomErr[17]="Assignement value is out of range";
		nomErr[18]="Not a flatzinc expression";
		nomErr[19]="Internal Error";
	}
	
	
	private void missatgeError(int i, String texte, int linia)
	{
		System.err.println("Semantic error: "+nomErr[i]+" "+texte+" at line : "+linia);
		error=true;
		conterror++;
	}
	
	
	private void llistatRegistres(){
		Iterator<Registre> i=st.valors().iterator();
		while (i.hasNext())
			{
			i.next().Imprimir();
			}
	}
	
	private void obtenir_funs_preds(SymTable<String> extrafuns)
	{
		Iterator<String> i=extrafuns.conjuntClaus().iterator();
		while (i.hasNext()) {
			String a=i.next();
			String p=extrafuns.obtenir(a); 
			String t="";
			if (p.equals("I")) {t="Int";System.out.print(" ("+a+" "+t+")");}
			if (p.equals("F")) {t="Real";System.out.print(" ("+a+" "+t+")");}
			if (p.equals("B")) {System.out.print(" ("+a+")");}
			if (p.substring(0,1).equals("[")) {
				if (p.substring(1,2).equals("I")) {t=" Int";}
				if (p.substring(1,2).equals("F")) {t=" Real";}
				if (p.substring(1,2).equals("B")) {t="";}
				if (expandir) 
				{	
					Registre r=st.obtenir(a);
					int z=r.getDim();
					for (int tt=1;tt<=z;tt++)
					{
						System.out.print(" ("+a+"_"+tt+"_"+t+")");
					}
				}
				else {
					System.out.print(" ("+a+" Int"+t+")");
				}
			}						
		}
	}
	
	private void comprobar_funs_preds(SymTable<String> extrafuns)
	{
		Iterator<String> i=extrafuns.conjuntClaus().iterator();
		while (i.hasNext()) {
			String a=i.next();
			String p=extrafuns.obtenir(a); 
			if (p.equals("F")) {reals=true;}
			if (p.substring(0,1).equals("[") && (!expandir)) {vectors=true;}						
		}
	}
	
	private String treure_V(String a)
	{
		if (a==null)
		{
			return("");
		}
		else
		{
			String aux="";
			int c=0;
			int i1=a.indexOf("V",c);
			int i2=a.indexOf("N",c);		
			int i;
			if (i1==(-1)) {i=i2;} else {if (i2==(-1)) {i=i1;} else {if (i1<i2) {i=i1;} else {i=i2;}}}
			while (i!=(-1))
			{
				aux=aux+a.substring(c,i);
				c=i+1;			
				i1=a.indexOf("V",c);
				i2=a.indexOf("N",c);
				if (i1==(-1)) {i=i2;} else {if (i2==(-1)) {i=i1;} else {if (i1<i2) {i=i1;} else {i=i2;}}}
			}
			aux=aux+a.substring(c,a.length());
			return(aux);
		}
	}

	private boolean signatura_compatible(String signatura, String[] ntipus, int ncont)
	{
		String aux="";
		int c=0;
		int c1;
		String sep;
		for (int i=0; i<ncont; i++)
		{
			if (ntipus[i]==null) {ntipus[i]="";}
			sep=",";
			if (i==0) {sep="";}
			c1=signatura.indexOf(",",c);
			if (c1==(-1)) {c1=signatura.length();}
			if (ntipus[i].equals("") || ntipus[i].equals("null"))
			{
				String aa=signatura.substring(c,c1);
				if (aa.indexOf("[",0)==(-1)) {aa="["+aa;}
				aux=aux+sep+aa;
				ntipus[i]=aa;
			}
			else
			{
				aux=aux+sep+ntipus[i];
			} 
			c=c1+1;
		}
		return (treure_V(signatura).equals(treure_V(aux)));
	}
	
	private String neg(String pos)
	{
		if (pos.length()>=1)
		{
			if (pos.substring(0,1).equals("-"))
			{
				pos="(~ "+pos.substring(1,pos.length())+")";
			}
		}
		return(pos);
	}
	
	private String neg2(Integer i)
	{
		String pos=i.toString();
		if (pos.length()>=1)
		{
			if (pos.substring(0,1).equals("-"))
			{
				pos="(~ "+pos.substring(1,pos.length())+")";
			}
		}
		return(pos);
	}
	
	private void mirar_si_rang(String p, String[] ntipus, String[] nvalors, int ini, int fi, String patro, int ncont,int linia)
	{
		int trobat=ini-1;
		int valorrang=30000000;
		int act=ini;
		int vi=0;
		int vf=0;
		String tip="";
		ListBool lb=new ListBool();
		while (act<=fi)
		{
			String v=nvalors[act];
			String text="";
			if (expandir)
			{
				if (v.substring(v.length()-1,v.length()).equals("_"))
				{
					int iii=v.length();
					iii--;
					char a=v.charAt(iii-1);
					while (a!='_')
					{
						iii--;
						a=v.charAt(iii);
					}
					text=v.substring(0,iii);
				}
				else
				{
					text=v;
				}
			}
			else
			{
				if (v.substring(0,1).equals("("))
				{
					int ii=v.indexOf(" ",0);
					text=v.substring(1,ii);
				}
				else
				{
					text=v;
				}
			}
			Registre r=st.obtenir(text);
			if (r.getValori()!=null)
			{
				if (!r.getValori().equals(""))
				{
					Integer vi2=Integer.parseInt(r.getValori());
					Integer vf2=Integer.parseInt(r.getValorf());
					if ((vf2-vi2)<valorrang)
					{
						trobat=act;
						tip="rang";
						vi=vi2;
						vf=vf2;
						valorrang=vf-vi;
					}
				}
			}
			if (r.getValorSetRang()!=null)
			{
				Integer avr=r.getValorSetRang().tamany();
				if (avr!=0)
				{
					if (avr<valorrang)
					{
						trobat=act;
						tip="llista";
						lb=r.getValorSetRang();
						valorrang=avr;
					}
				}
			}	
			act++;
		}
		if (trobat==(ini-1))
		{
			obtenir_string( p, ntipus, nvalors, patro, ncont, linia);
			nia=true;
		}
		else
		{
			String literal=nvalors[trobat];
			if (tip.equals("rang"))
			{		
				for (int val=vi; val<=vf; val++)
				{
					nvalors[trobat]=val+"";
					obtenir_string( p, ntipus, nvalors, "(implies (= "+literal+" "+neg2(val)+") "+patro+")", ncont, linia);
				}
			}
			else
			{
				Iterator<Integer> it=lb.conjuntClaus().iterator();
				while (it.hasNext())
				{
					int val=it.next();
					nvalors[trobat]=val+"";
					obtenir_string( p, ntipus, nvalors, "(implies (= "+literal+" "+neg2(val)+") "+patro+")", ncont, linia);
				}
			}
		}
	}
	
	private void obtenir_string(String p, String[] ntipus, String[] nvalors, String patro, int ncont,int linia)
	{
		Registre r=st.obtenir(p);
		if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) {
			missatgeError(10,p,linia); 
		}
		else{
			if (r.getLia()) {lia=true;}
			String aux="";
			int c=0;
			int i=patro.indexOf("$",c);
			while (i!=(-1))
			{
				aux=aux+patro.substring(c,i)+neg(nvalors[Integer.parseInt(patro.substring(i+1,i+2))]); 
				c=i+2;			
				i=patro.indexOf("$",c);
			}
			smt.add(aux+patro.substring(c,patro.length()));
		}
	}
	
	private void obtenir_string_lin(String p, String[] ntipus, String[] nvalors, String op, boolean reif, int ncont, int linia, boolean f)
	{
		Registre r=st.obtenir(p);
		if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont) || ntipus[0].substring(0,1).equals("V") || ntipus[2].substring(0,1).equals("V")) 
		{
			missatgeError(10,p,linia); 
		}
		else{
			String aux="";
			if (nvalors[0]==null && nvalors[1]==null) 
			{
				if (f) {aux="0.0";} else {aux="0";}
			}
			else
			{
				if (nvalors[0]==null || nvalors[1]==null) 
				{
					missatgeError(14,p,linia);  
				}
				else
				{
					if (r.getLia()) {lia=true;}
					Registre r1=st.obtenir(nvalors[0]);
					Registre r2=st.obtenir(nvalors[1]);
					int tt=r1.getDim();
					if (tt==r2.getDim())
					{
						ListString a1=r1.getValorArray();
						ListString a2=r2.getValorArray();
						char t1=r1.getTipus();
						char t2=r2.getTipus();
						String aux1="";			
						String aux2="";			
						String lexema1=r1.getLexema();			
						String lexema2=r2.getLexema();	
						for (int i=1;i<=tt;i++)
						{
							if (t1=='N') 
							{
								aux1=neg(a1.obtenir(i));
							}
							else
							{
								aux1=po+lexema1+esoguio+i+esoguio+pt;
							}
							if (t2=='N')  
							{
								aux2=neg(a2.obtenir(i));
							}
							else
							{
								aux2=po+lexema2+esoguio+i+esoguio+pt;
							}
							aux=aux+" (* "+aux1+" "+aux2+")";
						}
						aux="(+"+aux+")";
					}
					else 
					{
						missatgeError(14,p,linia);  
					}
				}
			}
			if (op.equals("<>")) 
			{
				aux="(not (= "+aux+" "+neg(nvalors[2])+"))";
			}
			else
			{
				aux="("+op+" "+aux+" "+neg(nvalors[2])+")";
			}
			if (reif)
			{
				aux="(= "+aux+" "+neg(nvalors[3])+")";
			}
			smt.add(aux);
		}
	}

	private void obtenir_string_element(String p, String[] ntipus, String[] nvalors, int ncont, int linia)
	{
		Registre r=st.obtenir(p);
		if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
		{
			missatgeError(10,p, linia); 
		}
		else
		{
			if (nvalors[1]==null) 
			{
				smt.add("false");
			}
			else
			{
				if (r.getLia()) {lia=true;}
				Registre r1=st.obtenir(nvalors[1]);
				int tt=r1.getDim();
				ListString a1=r1.getValorArray();
				char t1=r1.getTipus();
				String aux1="";			
				String lexema1=r1.getLexema();	
				if (!treure_V(r1.getSignatura()).equals("[SI"))	
				{	
					if (expandir)
					{
						litexp++;
						String literal="lit___exp___e"+litexp;
						//extrafuns.inserir(literal,"I");
						inserirIdent(literal,'V',"VI",0,"",false,new ListString(),new ListBool(),"","","", new Vector<String>(),0,"");
						smt.add("(>= "+literal+" "+"1)"); 	   		
						smt.add("(<= "+literal+" "+tt+")"); 	
						smt.add("(= "+literal+" "+neg(nvalors[0])+")");						
						for (int i=1;i<=tt;i++)
						{
							if (t1=='N') 
							{
								aux1=neg(a1.obtenir(i));
							}
							else  
							{
								aux1=po+lexema1+esoguio+i+esoguio+pt;
							}
							smt.add("(implies (= "+literal+" "+i+") (= "+aux1+" "+neg(nvalors[2])+"))");
						}
					}
					else 
					{
						smt.add("(>= "+neg(nvalors[0])+" "+"1)"); 	   		
						smt.add("(<= "+neg(nvalors[0])+" "+tt+")"); 	
						if (t1=='N')
						{
							String sign=treure_V(r1.getSignatura());
							if (sign.substring(1,2).equals("B"))
							{
								if (!extrapreds.existeix(lexema1))
								{
									extrapreds.inserir(lexema1,sign);
									afegir_restriccions_vector(true,false,lexema1,treure_V(r1.getSignatura()),r1.getValorArray(),tt,"",r1.getValori(),r1.getValorf(),r1.getVal(),linia);
								}
							}
							else 
							{
								if (!extrafuns.existeix(lexema1))
								{
									extrafuns.inserir(lexema1,sign);
									afegir_restriccions_vector(true,false,lexema1,treure_V(r1.getSignatura()),r1.getValorArray(),tt,"",r1.getValori(),r1.getValorf(),r1.getVal(),linia);
								}
							}
						}
						smt.add("(= ("+lexema1+" "+neg(nvalors[0])+") "+neg(nvalors[2])+")");
					}
				}
				else
				{
					ListBool vsa=new ListBool();
					vsa=unio_valors(r1);
					Registre r7=st.obtenir(nvalors[2]);
					String[] nt=new String[5]; nt[0]="SI"; nt[1]="SI";
					String[] nv=new String[5]; nv[0]=""; nv[1]=r7.getLexema();
					if (nvalors[0].matches("(-)?[0-9]+")) 
					{
						int index=Integer.parseInt(nvalors[0]);
						if ((index<1) || (index>tt))
						{
							smt.add("false");
						}
						else
						{
							Registre r3=st.obtenir(r1.getValorArray().obtenir(index));
							nv[0]=r3.getLexema();
						}
					}
					else
					{				
						litexp++;
						String literal2="lit___exp___e"+litexp;
						//extrafuns.inserir(literal2,"I");
						inserirIdent(literal2,'V',"VI",0,"",false,new ListString(),new ListBool(),"","","", new Vector<String>(),0,"");
						smt.add("(<= 1 "+nvalors[0]+")");
						smt.add("(>= "+tt+" "+nvalors[0]+")");
						smt.add("(= "+literal2+" "+neg(nvalors[0])+")");
						litexp++;	
						String literal="lit___exp___e"+litexp;
						tractar_var_set("llista","llista",literal,false,'V',pasar_vector_bool_a_string(vsa),new Vector<String>(),"","","","",linia,true,"");
						for (int i=1;i<=tt;i++)
						{
							Registre r3=st.obtenir(r1.getValorArray().obtenir(i));
							implica_igualar_set(literal2,r3.getLexema(),literal,vsa,r3.getValorSet(),i);
						}
						nv[0]=literal;					
					}
					if (!nv[0].equals("")) {operar_set(nt,nv,2,"igualtat",false,p,linia);}
				}
			}
		}
	}


	private String obtenir_string_clause(String p, String[] ntipus, String[] nvalors, int ncont, int linia)
	{
		Registre r=st.obtenir(p);
		String aux="";
		String auxseg="";
		if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
		{
			missatgeError(10,p,linia); 
		}
		else
		{
			if (r.getLia()) {lia=true;}
			if (nvalors[0]!=null) 
			{
				Registre r1=st.obtenir(nvalors[0]);
				int tt=r1.getDim();
				ListString a1=r1.getValorArray();
				char t1=r1.getTipus();
				String aux1="";			
				String lexema1=r1.getLexema();			
				if (expandir || (t1=='N'))
				{
					for (int i=1;i<=tt;i++)
					{
						if (t1=='N') 
						{
							aux1=neg(a1.obtenir(i));
						}
						else  
						{
							aux1=po+lexema1+esoguio+i+esoguio+pt;
						}
						aux=aux+" "+aux1;
					}
				aux="(or "+aux+")";
				}
				else 
				{
					litexp++;
					String literal="lit___exp___e"+litexp;
					//extrafuns.inserir(literal,"I");
					inserirIdent(literal,'V',"VI",0,"",false,new ListString(),new ListBool(),"","","", new Vector<String>(),0,"");
					smt.add("(>= "+literal+" "+"1)"); 	   		
					smt.add("(<= "+literal+" "+tt+")"); 							
					aux="(= ("+lexema1+" "+literal+") true)";
				}
			}
			if (nvalors[1]!=null) 
			{
				Registre r2=st.obtenir(nvalors[1]);
				int tt2=r2.getDim();
				ListString a2=r2.getValorArray();
				char t2=r2.getTipus();
				String aux2="";			
				String lexema2=r2.getLexema();			
				if (expandir || (t2=='N'))
				{
					for (int i2=1;i2<=tt2;i2++)
					{
						if (t2=='N') 
						{
							aux2=neg(a2.obtenir(i2));
						}
						else  
						{
							aux2=po+lexema2+esoguio+i2+esoguio+pt;
						}
						auxseg=auxseg+" (not "+aux2+")";
					}
				auxseg="(or "+auxseg+")";
				}
				else 
				{
					litexp++;
					String literal2="lit___exp___e"+litexp;
					//extrafuns.inserir(literal2,"I");
					inserirIdent(literal2,'V',"VI",0,"",false,new ListString(),new ListBool(),"","","", new Vector<String>(),0,"");
					smt.add("(>= "+literal2+" "+"1)"); 	   		
					smt.add("(<= "+literal2+" "+tt2+")"); 							
					auxseg="(= ("+lexema2+" "+literal2+") false)";
				}
			}
		}
		aux=aux+" "+auxseg;
		if (!aux.equals(" ")){
			return("(or "+aux+")");
		}
		else
		{
			return("false");
		}
	}





			
	private void inserirIdentSet(String t, String t2, String texte, boolean inic, char tipus, Vector<String>  pos, Vector<String>  val, String in, String fi, String in2, String fi2, int linia, boolean inicialitzat,String out) 
	{
		if (st.existeix(texte)) 
			{
				missatgeError(1, texte, linia);
			}
		else 
		{	
			Registre r=new Registre(texte,tipus,((Character)tipus).toString()+"SI");
			r.putInicialitzat(inic);//r.putInicialitzat(!(tipus=='V'));
			ListBool ps=new ListBool(10);
			r.putPossibleSet(ps);
			r.putOut(out);
			if (t==null) {t="";}
			if (t.equals("") || t.equals("llista"))
			{
				r.putinSet(deflow);
				r.putfiSet(defup);
			}
			else //rang
			{
				r.putinSet(Integer.parseInt(in));
				r.putfiSet(Integer.parseInt(fi));
				for (int auxi=r.getInSet(); auxi<=r.getFiSet(); auxi++)
				{
					ps.inserir(auxi,true);					
				}
				r.putPossibleSet(ps);
			}
			if (t.equals("llista"))
			{
				Iterator<String> il=pos.iterator();  
				while (il.hasNext())
					{
						String aaaa=il.next();
						if (!ps.existeix(Integer.parseInt(aaaa)))
						{
							ps.inserir(Integer.parseInt(aaaa),true);
						}
					}			
				r.putPossibleSet(ps);
			}
			ListBool psinic=new ListBool(10);
			if (inic)
			{
				if (inicialitzat)
				{
					if (t2.equals("rang"))
					{
						for (int auxi2=Integer.parseInt(in2); auxi2<=Integer.parseInt(fi2); auxi2++)
						{
							if (((t.equals("llista") || t.equals("rang")) && !ps.existeix(auxi2) ) || (t.equals("") && (auxi2<deflow || auxi2>defup) ))
							{
								missatgeError(17, texte, linia);
							}
							if (!psinic.existeix(auxi2) && ( ((t.equals("llista") || t.equals("rang")) && ps.existeix(auxi2) ) || (t.equals("") && (auxi2>=deflow && auxi2<=defup) )))
							{
								psinic.inserir(auxi2,true);
							}					
						}
					}
					if (t2.equals("llista"))
					{
						Iterator<String> ilinic=val.iterator();  
						while (ilinic.hasNext())
						{
							String aaaa=ilinic.next();
							int aaaai=Integer.parseInt(aaaa);
							if (((t.equals("llista") || t.equals("rang")) && !ps.existeix(aaaai) ) || (t.equals("") && (aaaai<deflow && aaaai>defup) ))
							{
								missatgeError(17, texte, linia);
							}
							if (!psinic.existeix(aaaai) && ( ((t.equals("llista") || t.equals("rang")) && ps.existeix(aaaai) ) || (t.equals("") && (aaaai>=deflow && aaaai<=defup) )))
							{
								psinic.inserir(aaaai,true);
							}
						}
					}
				}
				else
				{
					missatgeError(7, texte, linia);
				}
			}					
			r.putValorSet(psinic);
			st.inserir(texte,r);
		}
	}
	
	private void comp_assignacio_scalar(String texte,  String sign,  String v, String t,String valori, String valorf, Vector<String>  val,int linia) 
	{
		if (t.equals("llista"))
		{
			if (sign.equals("I")) 
			{
				try 
				{
					int inint=Integer.parseInt(v);
					Iterator<String> il=val.iterator();  
					Boolean trobat=false;
					while (il.hasNext() && !trobat)
					{
						String aaaa=il.next();
						int i=Integer.parseInt(aaaa);
						if (i==inint)
						{
							trobat=true;
						}
					}
					if (!trobat) {missatgeError(17, texte, linia);}
				}
				catch (Exception e) {}
			}
			if (sign.equals("F")) 
			{
				try 
				{
					float infloat=Float.parseFloat(v);
					Iterator<String> fl=val.iterator();  
					Boolean trobat=false;
					while (fl.hasNext() && !trobat)
					{
						String aaaa=fl.next();
						float f=Float.parseFloat(aaaa);
						if (f==infloat)
						{
							trobat=true;
						}
					}
					if (!trobat) {missatgeError(17, texte, linia);}
				}
				catch (Exception e) {}
			}
		}
		if (t.equals("rang"))
		{
			if (sign.equals("I")) 
			{
				try 
				{
					int inint=Integer.parseInt(v);
					if (inint<Integer.parseInt(valori) || inint>Integer.parseInt(valorf)) {missatgeError(17, texte, linia);}
				}
				catch (Exception e) {}
			}
			if (sign.equals("F")) 
			{
				try 
				{
				float infloat=Float.parseFloat(v);
				if (infloat<Float.parseFloat(valori) || infloat>Float.parseFloat(valorf)) {missatgeError(17, texte, linia);}
				}
				catch (Exception e) {}
			}
		}
	}
	
	private void inserirIdent(String texte, char tipus, String signatura, int dim, String v, boolean ini, ListString l, ListBool s, String t,String valori, String valorf, Vector<String>  val,int linia,String out) 
	{
		if (st.existeix(texte)) 
		{
			missatgeError(1, texte, linia);
		}
		else 
		{	
			try 
			{
				Registre r=new Registre(texte,tipus,signatura);
				r.putDim(dim);
				r.putValorArray(l);
				r.putValorSet(s);
				r.putInicialitzat(ini);
				if (valori==null) {valori="";}
				if (valorf==null) {valorf="";}
				r.putValori(valori);
				r.putValorf(valorf);
				if (treure_V(signatura).equals("I") || treure_V(signatura).equals("[I")) {r.putValorSetRang(passar_vector_a_list_bool(val));}
				r.putOut(out);
				if (ini) 
				{
					String sign=signatura; 
					comp_assignacio_scalar(texte,treure_V(sign),v,t,valori,valorf,val,linia);
					/*if (tipus=='N')
					{*/
							if (treure_V(sign).equals("I")) {r.putValorInt(Integer.parseInt(v));}
							if (treure_V(sign).equals("F")) {r.putValorFloat(Float.parseFloat(v));}
							if (treure_V(sign).equals("B")) {r.putValorBool(Boolean.parseBoolean(v));}
					//}				
				}
				String sign=signatura; 
				if (sign.startsWith("V")) 
				{
					sign=sign.substring(1,sign.length());
					if (sign.equals("I")) {extrafuns.inserir(texte,"I");}
					if (sign.equals("F")) {extrafuns.inserir(texte,"F");}
					if (sign.equals("B")) {extrapreds.inserir(texte,"B");}			
					if (sign.substring(0,1).equals("[")) 
					{
						if (sign.substring(1,2).equals("B"))
						{
							extrapreds.inserir(texte,sign);
						}
						else 
						{
							if (!sign.substring(1,sign.length()).equals("SI"))
							{
								extrafuns.inserir(texte,sign);
							}
						}
					}
				}				 
				st.inserir(texte,r);
			}
			catch (Exception r)
			{
				missatgeError(7,texte, linia);
			}
		}						
	}




	private void llistarsmt(Vector<String> smt)
	{ 
		if (smt.size()==0)
		{
			System.out.println("\t\ttrue");
		}
		else
		{
			String aux;
			Iterator<String> i=smt.iterator();
			while (i.hasNext())
				{
					aux=i.next();
					if (!aux.equals(""))
					{
						if (aux.substring(0,1).equals(" ")) {aux=aux.substring(1,aux.length());}
						System.out.println("\t\t"+aux);
					}
				}
		}			
	}

	
	private void afegir_restriccions_vector(Boolean afegir,Boolean inic,String lexema,String sign,ListString ls,int dim, String t, String valori, String valorf, Vector<String> val,int linia)
	{
		String aux="";
		for (int i=1;i<=dim;i++)
		{
			if (afegir) {smt.add("(= "+po+lexema+esoguio+i+esoguio+pt+" "+neg(ls.obtenir(i))+")");}
			if (inic) {comp_assignacio_scalar(lexema,treure_V(sign),ls.obtenir(i),t,valori,valorf,val,linia);}
		}					
	} 
	
	private String teoria() 
	{
		String teoria="LIA";
		if (lia) {teoria="LIA";}
		if (nia) {teoria="NIA";}
		if (vectors && reals && !teoria.equals("NIA")) {
			teoria="UFLRA";
		}
		else {
			if (vectors) {
				teoria="UF"+teoria;
			}
			if (reals && !teoria.equals("NIA")) {
				teoria="LRA";
			}
		}
		return(teoria);
	}

	private void tractar_var_set(String t, String t2, String texte, boolean inic, char tipus, Vector<String>  pos, Vector<String>  val, String in, String fi, String in2, String fi2, int linia, boolean inicialitzat,String out)
	{
		inserirIdentSet(t, t2,texte, inic, tipus, pos, val, in, fi,in2,fi2,linia,inicialitzat,out);
		Registre r4=st.obtenir(texte);
		Iterator<Integer> ii78=r4.getPossibleSet().conjuntClaus().iterator();
		Set<Integer> conjunt=r4.getValorSet().conjuntClaus();
		while (ii78.hasNext())
		{
			Integer ii782=ii78.next();
			extrapreds.inserir(texte+"_"+ii782+"_","B");
			extrafuns.inserir(texte+"_i-i_"+ii782+"_","I");
			if (inic)
			{
				if (conjunt.contains(ii782))
				{
					smt.add("(= "+texte+"_i-i_"+ii782+"_ 1)");
					smt.add("(= "+texte+"_"+ii782+"_ true)");							
				}
				else
				{
					smt.add("(= "+texte+"_i-i_"+ii782+"_ 0)");
					smt.add("(= "+texte+"_"+ii782+"_ false)");							
				}
			}
			else
			{
			smt.add("(>= "+texte+"_i-i_"+ii782+"_ 0)");
			smt.add("(<= "+texte+"_i-i_"+ii782+"_ 1)");
			smt.add("(ite "+texte+"_"+ii782+"_ (= "+texte+"_i-i_"+ii782+"_ 1)"+" (= "+texte+"_i-i_"+ii782+"_ 0))");
			}
		}
	}
	
	private Vector<String> pasar_vector_bool_a_string(ListBool s)
	{
		Vector<String> vs=new Vector<String>();
		if (!(s==null))
		{
			Iterator<Integer> it=s.conjuntClaus().iterator();
			while (it.hasNext())
			{
				vs.add(it.next().toString());
			}
		}
		return(vs);
	}

	private ListBool passar_vector_a_list_bool(Vector<String> s)
	{
		ListBool vs=new ListBool();
		if (!(s==null))
		{
			Iterator<String> it=s.iterator();
			while (it.hasNext())
			{
				int ii=Integer.parseInt(it.next());
				vs.inserir(ii,true);
			}
		}
		return(vs);
	}

	private Vector<String> passar_list_a_vector_string(ListString s)
	{
		Vector<String> vs=new Vector<String>();
		if (!(s==null))
		{
			Iterator<Integer> it=s.conjuntClaus().iterator();
			while (it.hasNext())
			{
				int ii=it.next();
				vs.add(s.obtenir(ii));
			}
		}
		return(vs);
	}
	

	private void operar_set_in(String[] ntipus,String[] nvalors,int ncont,boolean reif,String texte,int linia)
	{
		boolean exb=st.existeix(nvalors[1]);
		boolean esvara=nvalors[0].substring(0,1).equals("V");
		boolean esvarb=nvalors[1].substring(0,1).equals("V");
		if (!exb)
		{
			missatgeError(1,texte,linia);
		}
		else
		{
			Registre rb=st.obtenir(nvalors[1]);
			boolean inica=nvalors[0].matches("(-)?[0-9]+");
			boolean inicb=rb.getInicialitzat();
			ListBool posb=rb.getPossibleSet();
			ListBool valb=rb.getValorSet();
			int infb=rb.getInSet();
			int supb=rb.getFiSet();
			String tipusb="llista";
			if (posb==null && infb!=(-10000001)) {tipusb="nollista";}
			String aaa=nvalors[0];
			int aaai=0;
			if (inica) {aaai=Integer.parseInt(aaa);}
			ListBool bbb;
			if (inicb) {bbb=valb;} else {bbb=posb;}
			if (bbb==null) {bbb=valb;}
			String variable=rb.getLexema();
					
			String stg="";
			String stg2="";
			
			if (inica && inicb) {if (!bbb.existeix(aaai)) {stg="false";}}
			if (!inica)
			{
				if (bbb==null) {stg="false";}
				else
				{
					Iterator<Integer> itc=bbb.conjuntClaus().iterator();
					while (itc.hasNext())
					{
						Integer aux=itc.next();
						if (!inicb) {smt.add("(implies (= "+aaa+" "+aux+") "+variable+"_"+aux+"_)");}
						stg2=stg2+" (= "+aaa+" "+aux+")";
					}
					stg="(or "+stg2+")";
				}				
			}
			if (inica && !inicb) 
			{
				if (bbb==null) {stg="false";}
				else
				{
					if (!bbb.existeix(aaai)) {stg="false";} else {stg=variable+"_"+aaa+"_";}
				}				
			}
			
		
			if (reif) 
			{
				if (stg.equals("")) {stg="true";} 
				stg="(= (and "+stg+") "+nvalors[2]+")";
			}
			if (!stg.equals("")) {smt.add(stg);}
		}
	}

	private void operar_set(String[] ntipus,String[] nvalors,int ncont,String oper, boolean reif,String texte,int linia)
	{
		boolean exa=st.existeix(nvalors[0]);
		boolean exb=st.existeix(nvalors[1]);
		boolean esvara=nvalors[0].substring(0,1).equals("V");
		boolean esvarb=nvalors[1].substring(0,1).equals("V");
		if (!exa || !exb)
		{
			missatgeError(1,texte,linia);
		}
		else
		{
			Registre ra=st.obtenir(nvalors[0]);
			Registre rb=st.obtenir(nvalors[1]);
			boolean inica=ra.getInicialitzat();
			boolean inicb=rb.getInicialitzat();
			ListBool posa=ra.getPossibleSet();
			ListBool posb=rb.getPossibleSet();
			ListBool vala=ra.getValorSet();
			ListBool valb=rb.getValorSet();
			int infa=ra.getInSet();
			int infb=rb.getInSet();
			int supa=ra.getFiSet();
			int supb=rb.getFiSet();
			String tipusa="llista";
			String tipusb="llista";
			if (posa==null && infa!=(-10000001)) {tipusa="nollista";}
			if (posb==null && infb!=(-10000001)) {tipusb="nollista";}
			ListBool aaa;
			ListBool bbb;
			if (inica) {aaa=vala;} else {aaa=posa;}
			if (inicb) {bbb=valb;} else {bbb=posb;}
			
			
			
			ListBool cab=trobar_comuns(aaa,bbb);
			ListBool camb=trobar_diferencia(aaa,bbb);
			ListBool cbma=trobar_diferencia(bbb,aaa);
			
			String stg="";
			
			if (oper.equals("ge")) {stg=glet(inicb,inica,cab,cbma,camb,rb.getLexema(),ra.getLexema(),"e","g",bbb,aaa);}
			if (oper.equals("gt")) {stg=glet(inicb,inica,cab,cbma,camb,rb.getLexema(),ra.getLexema(),"t","g",bbb,aaa);}
			if (oper.equals("le")) {stg=glet(inica,inicb,cab,camb,cbma,ra.getLexema(),rb.getLexema(),"e","l",aaa,bbb);}
			if (oper.equals("lt")) {stg=glet(inica,inicb,cab,camb,cbma,ra.getLexema(),rb.getLexema(),"t","l",aaa,bbb);}
			if (oper.equals("igualtat")) {stg=igualtat(inica,inicb,cab,camb,cbma,ra.getLexema(),rb.getLexema());}
			if (oper.equals("subset")) {stg=subset(inica,inicb,cab,camb,cbma,ra.getLexema(),rb.getLexema());}
			if (oper.equals("superset")) {stg=subset(inicb,inica,cab,cbma,camb,rb.getLexema(),ra.getLexema());}
			if (oper.equals("desigualtat")) 
			{
				stg=igualtat(inica,inicb,cab,camb,cbma,ra.getLexema(),rb.getLexema());
				if (!stg.equals("false") && !stg.equals("")) {stg="(not (and "+stg+"))";}
				if (stg.equals("")) {stg="false";} else {if (stg.equals("false")){stg="";}}
			}
	
	
		
			if (reif) 
			{
				if (stg.equals("")) {stg="true";} 
				stg="(= (and "+stg+") "+nvalors[2]+")";
			}
			if (!stg.equals("")) {smt.add(stg);}
		}
	}
	
	private String escriure_cond_mes_petit_dif_sim(String positius, String negatius, String iguals, int contpos, int contneg, int contigu, String stg, boolean sensenomesneg)
	{
		String stg1=stg;
		if (stg1.equals(" false")) {stg1="";}
		if (!stg1.equals(" true"))
		{
			if (positius.equals("") && negatius.equals(""))
			{
				if (stg1.equals("")) {stg1=" false";}
			}
			if (positius.equals("") && !negatius.equals(""))
			{
				//sensenomesneg=true;
				if (!sensenomesneg) 
				{
					if (stg1.equals("")) {stg1=" false";}
				}
				else
				{
					if (contneg==1) {stg1=stg1+" (and (not"+negatius+")";} else {stg1=stg1+" (and (not (or"+negatius+"))";}
				}
			}
			if (!positius.equals("") && negatius.equals(""))
			{
				if (contpos==1) {stg1=stg1+" (and "+positius;} else {stg1=stg1+" (and (or"+positius+")";}
			}
			if (!positius.equals("") && !negatius.equals(""))
			{
				if (contpos==1) {stg1=stg1+" (and"+positius;} else {stg1=stg1+" (and (or"+positius+")";}
				if (contneg==1) {stg1=stg1+" (not"+negatius+")";} else {stg1=stg1+" (not (or"+negatius+"))";}
			}
			if (!stg1.equals(" false"))
			{
				if (!positius.equals("") || !negatius.equals(""))
				{
					stg1=stg1+iguals+")";
				}
			}
		}
		return(stg1);
	}

	private String glet(boolean inica, boolean inicb, ListBool cab, ListBool camb, ListBool cbma,String tra, String trb, String et, String gl, ListBool prim, ListBool seg)
	{ 
		String stg="";
		String stg2="";
		if (inica && inicb) {if (camb.tamany()!=0 || (et.equals("t") && cbma.tamany()==0)) {stg=" false";}}
		if (inica && !inicb) 
		{
			if (camb.tamany()!=0) {stg=" false";}
			else
			{
				stg2=recorrer(cab,trb);
				if (!stg2.equals("")) {stg=stg2;}
				if (et.equals("t"))
				{
					stg2=recorrer(cbma,trb);
					if (!stg2.equals("")) {stg=stg+" (or"+stg2+"))";} else {stg=" false";}
				}
			}
		}
		if (!inica && inicb) 
		{
				stg2=recorrer(camb,tra);
				if (!stg2.equals("")) {stg=stg+" (not (or "+stg2+"))";}
				if (et.equals("t") && (cbma.tamany()==0)) {stg2=recorrer(cab,tra);if (!stg2.equals("")) {stg=stg+" (not (and "+stg2+"))";} else {stg=" false";}}
		}
		if (!inica && !inicb) 
		{
			stg2=recorrer2(cab,tra,trb,"implies","","");
			if (!stg2.equals("")) {stg=stg2;}
			stg2=recorrer(camb,tra);
			if (!stg2.equals("")) {stg=stg+" (not (or"+stg2+"))";}
			if (et.equals("t"))
			{
				stg2=recorrer(cbma,trb);
				String stg3=recorrer2(cab,trb,tra,"implies","(not ",")");
				if (stg2.equals("") || stg3.equals("")) {stg=" false";} else {stg=stg+" (or"+stg2+stg3+")";}
			}
		}
		ListString junts=juntar_sets_amb_referencia(prim,seg);
		String stg1=" false";
		if (!(junts.tamany()==0))
		{
			SortedSet<Integer> ordenats=new TreeSet<Integer>();
			ordenats.addAll(junts.conjuntClaus());
			boolean acabar=false;
			String reg="";
			boolean a=true;
			boolean b=true;
			String negatius="";
			int contneg=0;
			String positius="";
			int contpos=0;
			String iguals="";
			int contigu=0;
			Iterator<Integer> itc=ordenats.iterator();
			while (!acabar && itc.hasNext())
			{
				int i=itc.next();
				reg=junts.obtenir(i);
				if (reg.equals("1")) {a=true;b=false;}
				if (reg.equals("2")) {a=false;b=true;}
				if (reg.equals("12")) {a=true;b=true;}
				if (a)
				{
					if (b)
					{
						if (inicb)
						{
							if (inica)
							{
							}
							else
							{
								//stg1=escriure_cond_mes_petit_dif_sim(positius,negatius,contpos,contneg,stg1,false);
								negatius=negatius+" (not "+tra+"_"+i+"_)";
								contneg++;
								positius="";
								contpos=0;
							}
						}
						else
						{
							if (inica)
							{
								stg1=escriure_cond_mes_petit_dif_sim(positius,negatius+" "+trb+"_"+i+"_",iguals,contpos,contneg+1,contigu,stg1,true);
								negatius=negatius+" (not "+trb+"_"+i+"_)";
								contneg++;
								positius="";
								contpos=0;
							}
							else
							{
								//stg1=escriure_cond_mes_petit_dif_sim(positius,negatius,contpos,contneg,stg1,false);
								positius=" "+tra+"_"+i+"_";
								contpos=1;
								negatius=" "+trb+"_"+i+"_";
								contneg++;
								stg1=escriure_cond_mes_petit_dif_sim(positius,negatius,iguals,contpos,contneg,contigu,stg1,false);
								positius="";
								contpos=0;
								negatius="";
								contneg=0;
								iguals=iguals+" (="+" "+tra+"_"+i+"_"+" "+trb+"_"+i+"_"+")";
								contigu++;
							}
						} 
					}
					else
					{
						if (inica)
						{
							stg1=escriure_cond_mes_petit_dif_sim(positius,negatius,iguals,contpos,contneg,contigu,stg1,true);
							if (negatius.equals("")) {stg1=" true";}
							positius="";
							negatius="";
							contpos=0;
							contneg=0;
							acabar=true;
						}
						else
						{
							positius=positius+" "+tra+"_"+i+"_";
							contpos++;
							stg1=escriure_cond_mes_petit_dif_sim(positius,negatius,iguals,contpos,contneg,contigu,stg1,false);
 							positius="";
							contpos=0;
						}
					}
				}
				else
				{
					if (inicb)
				{
						//stg1=escriure_cond_mes_petit_dif_sim(positius,negatius,contpos,contneg,stg1,false);
						positius="";
						negatius="";
						contpos=0;
						contneg=0;
						acabar=true;
					}
					else
					{
						negatius=negatius+" "+trb+"_"+i+"_";
						contneg++;
					}
				}				
			}
			if (!acabar) //arribo al final per tant queden tots els negatius per l'inclusi==> crec que no caldria per que ja esta a l'inclussi pero per ara ho deixo
			{
				stg1=escriure_cond_mes_petit_dif_sim(positius,negatius,iguals,contpos,contneg,contigu,stg1,true);
			}
		}
		if (!stg.equals(""))
		{
			if (!stg1.equals(" true")) {if (stg1.equals(" false")) {stg=stg.substring(1,stg.length());} else {if (stg.equals(" false")) {stg="(or"+stg1+")";} else {stg="(or (and"+stg+")"+stg1+")";}}} else {stg="";}
		}
		return(stg);
	}
	
	private ListString juntar_sets_amb_referencia(ListBool prim,ListBool seg)
	{
		ListString resultat=new ListString();
		if (!(prim==null))
		{
			Iterator<Integer> itc=prim.conjuntClaus().iterator();
			while (itc.hasNext())
			{
				Integer aux=itc.next();
				String aa="1";
				if (seg.existeix(aux)) {aa="12";}
				resultat.inserir(aux,aa);
			}
		}
		if (!(seg==null))
		{
			Iterator<Integer> itc=seg.conjuntClaus().iterator();
			while (itc.hasNext())
			{
				Integer aux=itc.next();
				if (!prim.existeix(aux))
				{
					String aa="2";
					resultat.inserir(aux,aa);
				}
			}
		}		
		return(resultat);
	}
	
	private String subset(boolean inica, boolean inicb, ListBool cab, ListBool camb, ListBool cbma,String tra, String trb)
	{ 
		String stg="";
		String stg2="";
		if (inica && inicb) {if (camb.tamany()!=0) {stg="false";}}
		if (inica && !inicb) 
		{
			if ((camb.tamany()!=0)) {stg="false";}
			else
			{
				stg2=recorrer(cab,trb);
				if (!stg2.equals("")) {stg=stg2;}
			}
		}
		if (!inica && inicb) 
		{
			stg2=recorrer(camb,tra);
			if (!stg2.equals("")) {stg=stg+" (not (or"+stg2+"))";}
		}
		if (!inica && !inicb) 
		{
			stg2=recorrer2(cab,tra,trb,"implies","","");
			if (!stg2.equals("")) {stg=stg2;}
			stg2=recorrer(camb,tra);
			if (!stg2.equals("")) {stg=stg+" (not (or"+stg2+"))";}
		}
		return(stg);
	}
	
	private String igualtat(boolean inica, boolean inicb, ListBool cab, ListBool camb, ListBool cbma,String tra, String trb)
	{ 
		String stg="";
		String stg2="";
		if (inica && inicb) {if ((camb.tamany()!=0) || (cbma.tamany()!=0)) {stg="false";}}
		if (inica && !inicb) 
		{
			if ((camb.tamany()!=0)) {stg="false";}
			else
			{
				stg2=recorrer(cab,trb);
				if (!stg2.equals("")) {stg=stg2;}
				stg2=recorrer(cbma,trb);
				if (!stg2.equals("")) {stg=stg+" (not (or"+stg2+"))";}
			}
		}
		if (!inica && inicb) 
		{
			if ((cbma.tamany()!=0)) {stg="false";}
			else
			{
				stg2=recorrer(cab,tra);
				if (!stg2.equals("")) {stg=stg2;}
				stg2=recorrer(camb,tra);
				if (!stg2.equals("")) {stg=stg+" (not (or"+stg2+"))";}
			}
		}
		if (!inica && !inicb) 
		{
			stg2=recorrer2(cab,tra,trb,"=","","");
			if (!stg2.equals("")) {stg=stg2;}
			stg2=recorrer(camb,tra);
			if (!stg2.equals("")) {stg=stg+" (not (or"+stg2+"))";}
			stg2=recorrer(cbma,trb);
			if (!stg2.equals("")) {stg=stg+" (not (or"+stg2+"))";}
		}
		return(stg);
	}

	private String recorrer(ListBool c,String variable)
	{
		String resultat="";
		if (!(c==null))
		{
			Iterator<Integer> itc=c.conjuntClaus().iterator();
			while (itc.hasNext())
			{
				Integer aux=itc.next();
				resultat=resultat+" "+variable+"_"+aux+"_";
			}
		}
		return(resultat);
	}

	private String recorrer2(ListBool c,String variable1,String variable2,String oper,String abans, String despres)
	{
		String resultat="";
		if (!(c==null))
		{
			Iterator<Integer> itc=c.conjuntClaus().iterator();
			while (itc.hasNext())
			{
				Integer aux=itc.next();
				resultat=resultat+" "+abans+"("+oper+" "+variable1+"_"+aux+"_ "+variable2+"_"+aux+"_)"+despres;
			}
		}
		return(resultat);
	}

	private ListBool trobar_comuns(ListBool a,ListBool b)
	{
		return(operar(a,b,true));
	}
	
	private ListBool trobar_diferencia(ListBool a,ListBool b)
	{
		return(operar(a,b,false));
	} 
	
	private ListBool operar(ListBool a,ListBool b,boolean comuns)
	{
		ListBool resultat=new ListBool();
		if (!(a==null))
		{
			Iterator<Integer> ita=a.conjuntClaus().iterator();
			while (ita.hasNext())
			{
				Integer aux=ita.next();
				if (comuns) {if (b.existeix(aux)) {resultat.inserir(aux,true);}}
				if (!comuns) {if (!b.existeix(aux)) {resultat.inserir(aux,true);}}
			}
		}
		return(resultat);
	} 

	private String tractar_acces_array(Registre r,String p,String p2,String i,boolean lit,int linia,String tipus)
	{
		String resultat="";
		String tipusVector=treure_V(r.getSignatura()).substring(1,treure_V(r.getSignatura()).length());
		if (r.getInicialitzat()) 
		{
			if (lit) 
			{
				if ((Integer.parseInt(i)>=1) && (Integer.parseInt(i)<=r.getDim()))
				{
					resultat=r.getValorArray().obtenir(Integer.parseInt(i));
				}
				else
				{
					missatgeError(9,p,linia);
				}
			}
			else
			{
				if (st.existeix(p2))
				{
					Registre r2=st.obtenir(p2);
					if ("I".equals(treure_V(r2.getSignatura())))
					{
						if (r2.getInicialitzat())
						{
							if ((r2.getValorInt()>=1) && (r2.getValorInt()<=r.getDim()))
							{
								resultat=r.getValorArray().obtenir(r2.getValorInt());
							}
							else
							{
								missatgeError(9,p,linia);
							}
						}
						else
						{
							smt.add("(<= 1 "+p2+")");
							smt.add("(>= "+((Integer)r.getDim()).toString()+" "+p2+")");
							if (expandir || tipus.equals("SI"))
							{
								litexp++;
								String literal="lit___exp___e"+litexp;
								ListBool vsa=new ListBool();
								ListBool total=unio_valors(r);
								for (int t=1; t<=r.getDim(); t++)
								{
									if (tipus.equals("SI"))
									{
										Registre r3=st.obtenir(r.getValorArray().obtenir(t));
										if (t==1)
										{
											vsa=r3.getPossibleSet();
											if (vsa.tamany()==0)
											{
												vsa=total;
											}
										}
										implica_igualar_set(p2,r3.getLexema(),literal,vsa,r3.getValorSet(),t);
									}
									else
									{
										smt.add("(implies "+"(= "+p2+" "+t+") (= "+literal+" "+r.getValorArray().obtenir(t)+"))");
									}
								}
								if (tipus.equals("SI"))
								{
									tractar_var_set("llista","llista",literal,false,'V',pasar_vector_bool_a_string(vsa),new Vector<String>(),"","","","",linia,true,"");
								}
								else
								{
									inserirIdent(literal,'V',"V"+tipusVector,0,"",false,new ListString(),new ListBool(),"","","",new Vector<String>(),linia,""); 
								}
								resultat=literal;
							}
							else
							{
								String sign=treure_V(r.getSignatura());
								if (sign.substring(1,2).equals("B"))
								{
									if (!extrapreds.existeix(p))
									{
										extrapreds.inserir(p,sign);
										afegir_restriccions_vector(true,false,p,sign,r.getValorArray(),r.getDim(),"",r.getValori(),r.getValorf(),r.getVal(),linia);
									}
								}
								else 
								{
									if (!extrafuns.existeix(p))
									{
										extrafuns.inserir(p,sign);
										afegir_restriccions_vector(true,false,p,sign,r.getValorArray(),r.getDim(),"",r.getValori(),r.getValorf(),r.getVal(),linia);
									}
								}
								resultat=po+p+esoguio+p2+esoguio+pt;
							}
						}
					}
					else
					{
						missatgeError(7,p,linia);
					}
				}
				else
				{
					missatgeError(6,p,linia);
				}
			}
		} 
		else 
		{
			if (lit) 
			{
				if ((Integer.parseInt(i)>=1) && (Integer.parseInt(i)<=r.getDim()))
				{
					if (tipus.equals("SI"))
					{
						resultat=r.getValorArray().obtenir(Integer.parseInt(i));
					}
					else
					{
						resultat=po+p+esoguio+i+esoguio+pt;
					}
				}
				else
				{
					missatgeError(9,p,linia);
				}
			} 
			else 
			{
				if (st.existeix(p2))
				{
					Registre r2=st.obtenir(p2);
					if ("I".equals(treure_V(r2.getSignatura())))
					{
						if (r2.getInicialitzat())
						{
							if ((r2.getValorInt()>=1) && (r2.getValorInt()<=r.getDim()))
							{
								if (tipus.equals("SI"))
								{
									missatgeError(19,p,linia);//no passara mai										//no passara mai
									resultat=r.getValorArray().obtenir(Integer.parseInt(i));
								}
								else
								{
									resultat=po+p+esoguio+r2.getValorInt()+esoguio+pt;
								}
							}
							else
							{
								missatgeError(9,p,linia);
							}
						}
						else
						{
							smt.add("(<= 1 "+p2+")");
							smt.add("(>= "+((Integer)r.getDim()).toString()+" "+p2+")");
							if (expandir)
							{
								litexp++;
								String literal="lit___exp___e"+litexp;
								for (int t=1; t<=r.getDim(); t++)
								{
									if (tipus.equals("SI"))
									{
										missatgeError(19,p,linia);//no passara mai
									}
									else
									{
										smt.add("(implies "+"(= "+p2+" "+t+") (= "+literal+" "+po+p+esoguio+t+esoguio+pt+"))");
									}
								}
								if (tipus.equals("SI"))
								{
								}
								else
								{
									inserirIdent(literal,'V',"V"+tipusVector,0,"",false,new ListString(),new ListBool(),"","","",new Vector<String>(),linia,""); 
								}
								resultat=literal;
							}
							else
							{
								resultat=po+p+esoguio+p2+esoguio+pt;
							}
						}
					}
					else
					{
						missatgeError(7,p,linia);
					}
				}
				else
				{
					missatgeError(6,p,linia);
				}
			}
		}
		return(resultat);
	}

	private ListBool unio_valors(Registre r)
	{
		ListBool resultat=new ListBool();
		for (int t=1; t<=r.getDim(); t++)
		{
			Registre r2=st.obtenir(r.getValorArray().obtenir(t));
			if (r2.getValorSet().tamany()!=0) {resultat.addAll(r2.getValorSet());} else {resultat.addAll(r2.getPossibleSet());}
		}
		return(resultat);
	}
	
	private void implica_igualar_set(String p2,String nomregistre,String literal,ListBool possibles,ListBool valors,int t)
	{
		if (!(possibles==null))
		{
			Registre r=st.obtenir(nomregistre);
			ListBool posireg=new ListBool();
			if (r.getInicialitzat()) {posireg=r.getValorSet();} else {posireg=r.getPossibleSet();}
			boolean ini=(valors.tamany()!=0);
			Iterator<Integer> ita=possibles.conjuntClaus().iterator();
			String aux=""; 
			while (ita.hasNext())
			{
				Integer ii=ita.next();
				if (ini)
				{
					if (valors.existeix(ii)) {aux=aux+" (= "+literal+"_"+ii+"_ true)";} else {aux=aux+" (= "+literal+"_"+ii+"_ false)";}
				}
				else
				{
					if (posireg.existeix(ii)) {aux=aux+" (= "+literal+"_"+ii+"_ "+nomregistre+"_"+ii+"_)";} else {aux=aux+" (= "+literal+"_"+ii+"_ false)";}
				}
			}
			if (!aux.equals("")) {smt.add("(implies (= "+p2+" "+t+") (and "+aux+"))");}
		}	
	}
	

	private void operar_set_3(String[] ntipus,String[] nvalors,int ncont,String oper, boolean reif,String texte,int linia)
	{
		boolean exa=st.existeix(nvalors[0]);
		boolean exb=st.existeix(nvalors[1]);
		boolean exc=st.existeix(nvalors[2]);
		boolean esvara=nvalors[0].substring(0,1).equals("V");
		boolean esvarb=nvalors[1].substring(0,1).equals("V");
		boolean esvarc=nvalors[2].substring(0,1).equals("V");
		if (!exa || !exb || !exc)
		{
			missatgeError(1,texte,linia);
		}
		else
		{
			Registre ra=st.obtenir(nvalors[0]);
			Registre rb=st.obtenir(nvalors[1]);
			Registre rc=st.obtenir(nvalors[2]);
			boolean inica=ra.getInicialitzat();
			boolean inicb=rb.getInicialitzat();
			boolean inicc=rc.getInicialitzat();
			ListBool posa=ra.getPossibleSet();
			ListBool posb=rb.getPossibleSet();
			ListBool posc=rc.getPossibleSet();
			ListBool vala=ra.getValorSet();
			ListBool valb=rb.getValorSet();
			ListBool valc=rc.getValorSet();
			String tipusa="llista";
			String tipusb="llista";
			String tipusc="llista";
			ListString aaa;
			ListString bbb;
			ListString ccc;
			if (inica) {aaa=passar_a_string(vala);} else {aaa=passar_a_string(posa);}
			if (inicb) {bbb=passar_a_string(valb);} else {bbb=passar_a_string(posb);}
			if (inicc) {ccc=passar_a_string(valc);} else {ccc=passar_a_string(posc);}
			
			
			
			String stg="";
			
			if (oper.equals("interseccio")) 
			{
				ListString cab=trobar_comuns_3(aaa,bbb,oper,inica,inicb);
				stg=igualtat_3(inica,inicb,inicc,cab,ccc,ra.getLexema(),rb.getLexema(),rc.getLexema(),aaa,bbb,"interseccio");
			}
			if (oper.equals("unio")) 
			{
				ListString cab=trobar_comuns_3(aaa,bbb,oper,inica,inicb);
				ListString camb=trobar_diferencia_3(aaa,bbb,oper,inica,inicb,true);
				ListString cbma=trobar_diferencia_3(bbb,aaa,oper,inicb,inica,false);
				cab.addAll(camb);
				cab.addAll(cbma);
				stg=igualtat_3(inica,inicb,inicc,cab,ccc,ra.getLexema(),rb.getLexema(),rc.getLexema(),aaa,bbb,"unio");
			}
			if (oper.equals("diferencia"))  
			{
				ListString camb=trobar_diferencia_3(aaa,bbb,oper,inica,inicb,true);
				if (!inicb) {camb.addAll(trobar_comuns_3(aaa,bbb,oper,inica,inicb));}
				stg=igualtat_3(inica,inicb,inicc,camb,ccc,ra.getLexema(),rb.getLexema(),rc.getLexema(),aaa,bbb,"diferencia");
			}
			if (oper.equals("diferenciasimetrica")) 
			{
				ListString camb=trobar_diferencia_3(aaa,bbb,oper,inica,inicb,true);
				ListString cbma=trobar_diferencia_3(bbb,aaa,oper,inicb,inica,false);
				camb.addAll(cbma);
				if (!inicb || !inica) {camb.addAll(trobar_comuns_3(aaa,bbb,oper,inica,inicb));}
				stg=igualtat_3(inica,inicb,inicc,camb,ccc,ra.getLexema(),rb.getLexema(),rc.getLexema(),aaa,bbb,"diferenciasimetrica");
			}
	
	
			if (!stg.equals("")) {smt.add(stg);}
		}
	}
	private String obtenir_string_3(String[] nvalors, String patro, int ii)
	{
		String aux="";
		if (patro.equals(""))
		{
			aux=nvalors[2]+"_"+ii+"_";
		}
		else
		{
			int c=0;
			int i=patro.indexOf("$",c);
			while (i!=(-1))
			{
				aux=aux+patro.substring(c,i)+nvalors[Integer.parseInt(patro.substring(i+1,i+2))]+"_"+ii+"_"; 
				c=i+2;			
				i=patro.indexOf("$",c);
		}
			aux=aux+patro.substring(c,patro.length());
		}
		return(aux);
	}
	
	private String igualtat_3(boolean inica, boolean inicb, boolean inicc, ListString a, ListString b,String tra, String trb, String trc,ListString aaa, ListString bbb, String oper)
	{ 
		ListString cab=trobar_comuns_3(a,b,"igualtat",false,inicc);
		ListString camb=trobar_diferencia_3(a,b,"igualtat",false,inicc,true);
		ListString cbma=trobar_diferencia_3(b,a,"igualtat",false,inicc,true);
		String stg="";
		String stg2="";
		if (inica && inicb && inicc) {if ((camb.tamany()!=0) || (cbma.tamany()!=0)) {stg="false";}}
		else //if ((!inica && !inicb && !inicc) || ((inica || inicb) && !inicc) || ((!inica || !inicb) && inicc))
		{
			if (inicc && (cbma.tamany()!=0)) 
			{
				stg="false";
			}
			else
			{
				if (oper.equals("unio") && ((inica && trobar_diferencia_3(aaa,b,"igualtat",false,inicc,true).tamany()!=0) || (inicb && trobar_diferencia_3(bbb,b,"igualtat",false,inicc,true).tamany()!=0)))
				{
					stg="false";
				}
				else
				{
					ListString lsaux=aaa;
					lsaux.addAll(bbb);
					if (oper.equals("interseccio") && inica && inicb && trobar_diferencia_3(lsaux,b,"igualtat",false,inicc,true).tamany()!=0)
					{
						stg="false"; 
					}
					else
					{
						if (oper.equals("diferencia") && 
						((inicb && inica && trobar_diferencia_3(a,b,"igualtat",false,inicc,true).tamany()!=0) ||
						(inica && trobar_diferencia_3(trobar_diferencia_3(aaa,bbb,"igualtat",false,inicc,true),b,"igualtat",false,inicc,true).tamany()!=0)))
						{
							stg="false"; 
						}
						else
						{
							if (oper.equals("diferenciasimetrica") && 
							((inicb && inica && trobar_diferencia_3(a,b,"igualtat",false,inicc,true).tamany()!=0) ||
							(inica && trobar_diferencia_3(trobar_diferencia_3(aaa,bbb,"igualtat",false,inicc,true),b,"igualtat",false,inicc,true).tamany()!=0) ||
							(inicb && trobar_diferencia_3(trobar_diferencia_3(bbb,aaa,"igualtat",false,inicc,true),b,"igualtat",false,inicc,true).tamany()!=0)))
							{
								stg="false"; 
							}
							else
							{
								stg2=recorrer2_3(cab,tra,trb,trc,"=","","",inicc);
								if (!stg2.equals("")) {stg=stg2;}
								stg2=recorrer_3(camb,tra,trb,trc);
								if (!stg2.equals("")) {stg=stg+" (not (or"+stg2+"))";}
								stg2=recorrer_3(cbma,tra,trb,trc);
								if (!stg2.equals("")) {stg=stg+" (not (or"+stg2+"))";}
							}
						}
					}
				}
			}
		}
		return(stg);
	}

	private String recorrer_3(ListString c,String variable1,String variable2,String variable3)
	{
		String resultat="";
		String[] nvalors=new String[3];
		nvalors[0]=variable1;
		nvalors[1]=variable2;
		nvalors[2]=variable3;
		if (!(c==null))
		{
			Iterator<Integer> itc=c.conjuntClaus().iterator();
			while (itc.hasNext())
			{
				Integer aux=itc.next();
				String hh=obtenir_string_3(nvalors,c.obtenir(aux),aux);
				if (!hh.equals("true")) {resultat=resultat+" "+hh;} 
			}
		}
		return(resultat);
	}

	private String recorrer2_3(ListString c,String variable1,String variable2,String variable3,String oper,String abans, String despres,Boolean inicc)
	{
		String resultat="";
		String[] nvalors=new String[3];
		nvalors[0]=variable1;
		nvalors[1]=variable2;
		nvalors[2]=variable3;
		
		String variable3aux="";
		if (!(c==null))
		{
			Iterator<Integer> itc=c.conjuntClaus().iterator();
			while (itc.hasNext())
			{
				Integer aux=itc.next();
				if (inicc) {variable3aux="true";} else {variable3aux=variable3+"_"+aux+"_";}
				String hh=abans+"("+oper+" "+obtenir_string_3(nvalors,c.obtenir(aux),aux)+" "+variable3aux+")"+despres;
				if (!hh.equals(abans+"(= true true)"+despres)) {resultat=resultat+" "+hh;}
			}
		}
		return(resultat);
	}
	private ListString trobar_comuns_3(ListString a,ListString b,String oper,boolean inica,boolean inicb)
	{
		ListString resultat=new ListString();
		String texte="";
		if (oper.equals("interseccio")) 
		{
			if (!inica && !inicb) {texte="(and $0 $1)";}
			if (!inica && inicb) {texte="$0";}
			if (inica && !inicb) {texte="$1";}
			if (inica && inicb) {texte="";}
		}
		if (oper.equals("unio")) 
		{
			if (!inica && !inicb) {texte="(or $0 $1)";}
			if (!inica && inicb) {texte="true";}
			if (inica && !inicb) {texte="true";}
			if (inica && inicb) {texte="true";}
		}
		if (oper.equals("diferencia")) 
		{
			if (!inica && !inicb) {texte="(and $0 (not $1))";}
			if (!inica && inicb) {texte="";}
			if (inica && !inicb) {texte="(not $1)";}
			if (inica && inicb) {texte="";}
		}
		if (oper.equals("diferenciasimetrica")) 
		{
			if (!inica && !inicb) {texte="(or (and $0 (not $1)) (and $1 (not $0)) )";}
			if (!inica && inicb) {texte="(not $0)";}
			if (inica && !inicb) {texte="(not $1)";}
			if (inica && inicb) {texte="";}
		}
		if (oper.equals("igualtat")) {texte="igualtat";}
		resultat=operar_3(a,b,true,texte);
		return(resultat);
	}
	
	private ListString trobar_diferencia_3(ListString a,ListString b,String oper,boolean inica,boolean inicb,boolean amb)
	{
		ListString resultat=new ListString();
		String texte="";
		if (oper.equals("unio")) 
		{
			if (!inica && !inicb) {if (amb) {texte="$0";} else {texte="$1";}}
			if (!inica && inicb) {if (amb) {texte="$0";} else {texte="$1";}}
			if (inica && !inicb) {texte="true";}
			if (inica && inicb) {texte="true";}
		}
		if (oper.equals("diferencia") || oper.equals("diferenciasimetrica")) 
		{
			if (!inica && !inicb) {if (amb) {texte="$0";} else {texte="$1";}}
			if (!inica && inicb) {if (amb) {texte="$0";} else {texte="$1";}}
			if (inica && !inicb) {texte="true";}
			if (inica && inicb) {texte="true";}
		}
		if (oper.equals("igualtat")) {texte="igualtat";}
		resultat=operar_3(a,b,false,texte);
		return(resultat);
	} 
	
	private ListString operar_3(ListString a,ListString b,boolean comuns,String texte)
	{
		ListString resultat=new ListString();
		if (!(a==null))
		{
			Iterator<Integer> ita=a.conjuntClaus().iterator();
			while (ita.hasNext())
			{
				Integer aux=ita.next();
				String texte2=texte;
				if (texte.equals("igualtat")) {texte2=a.obtenir(aux);}
				if (comuns) {if (b.existeix(aux)) {resultat.inserir(aux,texte2);}}
				if (!comuns) {if (!b.existeix(aux)) {resultat.inserir(aux,texte2);}}
			}
		}
		return(resultat);
	} 

	private ListString passar_a_string(ListBool a)
	{
		ListString resultat=new ListString();
		if (!(a==null))
		{
			Iterator<Integer> ita=a.conjuntClaus().iterator();
			while (ita.hasNext())
			{
				Integer aux=ita.next();
				resultat.inserir(aux,"");
			}
		}
		return(resultat);
	} 
	
	private void max_min(String tipus,String valor, Boolean init,Boolean max,int linia)
	{
		if (executar || minzero) 
		{
			if (init)
			{
				solveKindMax=false;
			}
			else
			{
				solveKindMax=true;
				String aux=valor;
				String nom="";
				if (expandir)
				{
					if (aux.substring(aux.length()-1,aux.length()).equals("_"))
					{
						int ii=aux.length();
						ii--;
						char a=aux.charAt(ii-1);
						while (a!='_')
						{
							ii--;
							a=aux.charAt(ii);
						}
						nom=aux.substring(0,ii);
					}
					else
					{
						nom=aux;
					}
				}
				else
				{
					if (aux.substring(0,1).equals("("))
					{
						int ii=1;
						char a=aux.charAt(ii);
						while (a!=' ')
						{
							ii++;
							a=aux.charAt(ii);
						}
						nom=aux.substring(1,ii);
					}
					else
					{
						nom=aux;
					}
				}
				Registre r=st.obtenir(nom);
				String t="";
				if (r.getValori()!=null)
				{
					if (!r.getValori().equals(""))
					{
						solveMin=r.getValori();
						solveMax=r.getValorf();
						t="rang";
					}
				}
				if (minzero) 
				{
					inserirIdent("minimizeaux_",'V',"VI",0,"",false,new ListString(),new ListBool(),t,solveMin,solveMax,new Vector<String>(),linia,"");
					if (!max)
					{
						smt.add("(= minimizeaux_ "+neg(valor)+")");
					}
					else
					{
						smt.add("(= (~ minimizeaux_) "+neg(valor)+")");
						if (t.equals("rang"))
						{
							String auxsm=solveMin;
							Integer iaux=(0-Integer.parseInt(solveMax));
							solveMin=iaux.toString();
							iaux=(0-Integer.parseInt(auxsm));
							solveMax=iaux.toString();
						}
						
					}
					smt.add("(>= minimizeaux_ "+neg(solveMin)+")");
					smt.add("(<= minimizeaux_ "+neg(solveMax)+")");
					inserirIdent("minimize_",'V',"VI",0,"",false,new ListString(),new ListBool(),t,solveMin,solveMax,new Vector<String>(),linia,"");					
					String stm=solveMin;
					Integer sM=Integer.parseInt(solveMax)-Integer.parseInt(solveMin);
					solveMin="0";
					solveMax=sM.toString();
					smt.add("(= minimizeaux_ (+ minimize_ "+neg(stm)+"))");				
					smt.add("(>= minimize_ "+neg(solveMin)+")");
					smt.add("(<= minimize_ "+neg(solveMax)+")");
				}
				else
				{
					inserirIdent("maximize_",'V',"VI",0,"",false,new ListString(),new ListBool(),t,solveMin,solveMax,new Vector<String>(),linia,"");
					if (max)
					{
						smt.add("(= maximize_ "+neg(valor)+")");
					}
					else
					{
						smt.add("(= (~ maximize_) "+neg(valor)+")");
						if (t.equals("rang"))
						{
							String auxsm=solveMin;
							Integer iaux=(0-Integer.parseInt(solveMax));
							solveMin=iaux.toString();
							iaux=(0-Integer.parseInt(auxsm));
							solveMax=iaux.toString();
						}
						
					}
					smt.add("(>= maximize_ "+neg(solveMin)+")");
					smt.add("(<= maximize_ "+neg(solveMax)+")");
				}
			}
		}
		else
		{
			System.err.println("Model only for satisfy. Not minimize or maximize.");
		}
	}
	
	
	
}






















































//-------------------------------------
//Comenament
//-------------------------------------







flatzinc_model [Boolean exp,String output, String inp, Boolean executar2,Boolean minzero2] returns [SymTable<Registre> st2,PrintStream oo2,Boolean error2, Boolean solveKindMax2, String solveMax2, String solveMin2, OutputStream os2]
	@init {
		afegir_predicats();inicialitzarError();
		expandir=$exp;
		executar=$executar2;
		minzero=$minzero2;
		if (expandir) {esoguio="_";po="";pt="";}
	}
	:	var_decl_item*  
		constraint_item* 
		solve_item
		{
		$solveKindMax2=solveKindMax;
		$solveMax2=solveMax;
		$solveMin2=solveMin;
		$error2=error;
		PrintStream os=new PrintStream(System.out);
		if (error) {
			System.err.println(conterror+" errors");  
		}
		else 
		{
			PrintStream output2 = System.out;
			try
			{
				if (output.equals("")) 
				{
					output2 = new PrintStream("temp.smt");
					if (!inp.equals(""))
					{
						int i9=0;
						while (inp.indexOf("/",0)!=(-1) || inp.indexOf("\\",0)!=(-1))
						{
							if (inp.indexOf("/",0)!=(-1)) 
							{
								inp=inp.substring(inp.indexOf("/",0)+1,inp.length());
							}
							else
							{
								inp=inp.substring(inp.indexOf("\\",0)+1,inp.length());
							}
						}
						while (inp.indexOf(".",i9)!=(-1))
						{
							i9=inp.indexOf(".",i9)+1;
						}
						if (i9==0) 
						{
							codi=inp+".smt";
						}
						else
						{
							codi=inp.substring(0,i9-1)+".smt";
						}
					}
				}
				else
				{
					output2 = new PrintStream(output);
					int i9=0;
					while (output.indexOf("/",0)!=(-1) || output.indexOf("\\",0)!=(-1))
					{
						if (output.indexOf("/",0)!=(-1)) 
						{
							output=output.substring(output.indexOf("/",0)+1,output.length());
						}
						else
						{
							output=output.substring(output.indexOf("\\",0)+1,output.length());
						}
					}
					codi=output;
				}
				System.setOut(output2);
			}
			catch (Exception e)
			{
				System.err.println("Bad file name "+output);
				error=true;
			}
			
			
			
			$st2=st;
			$oo2=output2;
			$os2=os;
			$error2=error;
			if (!error)
			{
				char ach=codi.charAt(0);
				if (ach>='0' && ach<='9') {codi="i_"+codi;}
				System.out.println("(benchmark "+codi);
				System.out.println("\t:source { Generated by flat2smt }");
				//System.out.println("	:category { testing }");
				comprobar_funs_preds(extrafuns);
				comprobar_funs_preds(extrapreds);
				System.out.println("\t:logic QF_"+teoria());
		 		if (!extrapreds.isEmpty()) 
		 		{
		 			System.out.print("\t:extrapreds (");
		 			obtenir_funs_preds(extrapreds);
		 			System.out.println(")");
		 		}
		 		if (!extrafuns.isEmpty()) 
		 		{
		 			System.out.print("\t:extrafuns (");
		 			obtenir_funs_preds(extrafuns);
		 			System.out.println(")");
		 		}
		 		System.out.println("\t:formula (and ");
		 		llistarsmt(smt);
		 		System.out.println("\t)");
		 		System.out.print(")"); 
		 		System.out.close();

	 		}
		}
		} 
	;
 

var_decl_item
	:	^(VAR ^(i=IDENT an=annotations t=non_array_ti_expr_tail {boolean inicial=false;boolean inic=false;String tt="";Vector<String> llist=new Vector<String>();} (v1=ini_var[treure_V($t.tipus)] {inic=true;tt=$v1.valor;llist=$v1.llista;inicial=$v1.init;})?
		{
		if (!$t.tipus.equals("SI")) 
		{
			inserirIdent($i.text,'V',"V"+$t.tipus,0,tt,(inic && inicial),new ListString(),new ListBool(),$t.t,$t.valori,$t.valorf,$t.llista,$i.getLine(),$an.out);
			if (inic) 
			{   
				smt.add("(= "+$i.text+" "+neg($v1.valor)+")"); 
			}
			if ($t.t.equals("rang"))
			{
				smt.add("(>= "+$i.text+" "+neg($t.valori)+")"); 	  		
				smt.add("(<= "+$i.text+" "+neg($t.valorf)+")"); 			
			}
			if ($t.t.equals("llista"))
			{
				Iterator<String> ii=$t.llista.iterator();
				String aux="";
				while (ii.hasNext())
					{
					aux=aux+" (= "+$i.text+" "+neg(ii.next())+")";; 
					}						 
				if (!aux.equals("")) {aux="(or"+aux+")";smt.add(aux);}			
			}
			if ($t.tipus.equals("I") && $t.t.equals("") && !inic)
			{
				smt.add("(>= "+$i.text+" "+neg2(deflow)+")"); 	  		
				smt.add("(<= "+$i.text+" "+neg2(defup)+")"); 			
			}
		}
		else
		{
			if ($t.t.equals(""))
			{
				missatgeError(15,$i.text,$i.getLine());
			}
			else
			{
				tractar_var_set($t.t, $v1.t, $i.text, inic, 'V', $t.llista, llist, $t.valori, $t.valorf,$v1.valori,$v1.valorf,$i.getLine(),inicial,$an.out);
			} 
		}
		}
		))
	| 	^(NOVAR ^(i2=IDENT an=annotations t2=non_array_ti_expr_tail v2=ini_var[treure_V($t2.tipus)] 
		{
		if (!$t2.tipus.equals("SI")) 
		{
			inserirIdent($i2.text,'N',$t2.tipus,0,$v2.valor,true,new ListString(),new ListBool(),$t2.t,$t2.valori,$t2.valorf,$t2.llista,$i2.getLine(),$an.out); 
		}
		else
		{
			inserirIdentSet($t2.t, $v2.t, $i2.text, true, 'N', $t2.llista, $v2.llista, $t2.valori, $t2.valorf,$v2.valori,$v2.valorf,$i2.getLine(),$v2.init,$an.out);
		}
		}
		))

	|	^(ARRAY  v=INT_LITERAL	t3=array_decl_tail[Integer.parseInt($v.text)]	
		{
			//inserirIdent($t3.nom,$t3.varnovar.charAt(0),$t3.varnovar+"["+$t3.tipus,Integer.parseInt($v.text),"",$t3.inic,$t3.ls,new ListBool(),$t3.tt,$t3.valori,$t3.valorf,passar_list_a_vector_string($t3.ls),$v.getLine(),$t3.out); 
			inserirIdent($t3.nom,$t3.varnovar.charAt(0),$t3.varnovar+"["+$t3.tipus,Integer.parseInt($v.text),"",$t3.inic,$t3.ls,new ListBool(),$t3.tt,$t3.valori,$t3.valorf,$t3.llista,$v.getLine(),$t3.out); 
			Registre r78=st.obtenir($t3.nom);
			r78.putPossibleSet($t3.res);
			st.modificar($t3.nom,r78);
		}
		)
	;
	
ini_var [String ent] returns [String valor,Vector<String> llista, String t,String valori, String valorf, boolean init]
	:	^(IGUAL v=non_array_flat_expr[$ent] {$valor=$v.valor;$llista=$v.llista;$t=$v.t;$valori=$v.valori;$valorf=$v.valorf;$init=$v.init;})   
	;
		
array_decl_tail [Integer dim] returns [String varnovar, String tipus, String nom, ListString ls,Boolean inic, ListBool res, String out, String tt, String valori, String valorf,Vector<String> llista]
	:	^(NOVAR ^(i2=IDENT an=annotations t2=non_array_ti_expr_tail in=ini_array[$t2.tipus,$dim,false] 
		{
		$varnovar="N";$tipus=$t2.tipus;$nom=$i2.text;$ls=$in.ls;$inic=true;$res=new ListBool();$out=$an.out;$tt=$t2.t;$valori=$t2.valori;$valorf=$t2.valorf;$llista=$t2.llista;
		afegir_restriccions_vector(false,true,$i2.text,treure_V($t2.tipus),$in.ls,$dim,$t2.t,$t2.valori,$t2.valorf,$t2.llista,$i2.getLine());	
		if (treure_V($t2.tipus).equals("SI")) 
		{
			$ls=new ListString();
			for (int i22=1; i22<=$dim; i22++) 
			{
				if (!st.existeix($in.ls.obtenir(i22)))
				{
					missatgeError(7,$i2.text,$i2.getLine());
				}
				else
				{
					Registre r9=st.obtenir($in.ls.obtenir(i22));
					inserirIdentSet($t2.t, "llista", $i2.text+"_"+i22+"_", true, 'N', $t2.llista, pasar_vector_bool_a_string(r9.getValorSet()), $t2.valori, $t2.valorf,"","",$i2.getLine(),r9.getInicialitzat(),"");
					Registre r11=st.obtenir($i2.text+"_"+i22+"_");
					$res=r11.getPossibleSet();
					$ls.inserir(i22,$i2.text+"_"+i22+"_");
				}
			}
			$inic=true;
		}
		}
		))
	|	^(VAR {ListString s1=new ListString();Boolean inic2=false;} ^(i=IDENT an=annotations t=non_array_ti_expr_tail (in2=ini_array[$t.tipus,$dim,true] {s1=$in2.ls;inic2=true;})? 
		{
		$varnovar="V";$tipus=$t.tipus;$nom=$i.text;$ls=s1;$inic=inic2;$res=new ListBool();$out=$an.out;$tt=$t.t;$valori=$t.valori;$valorf=$t.valorf;$llista=$t.llista;
		if (!treure_V($t.tipus).equals("SI") && inic2) 
		{
			afegir_restriccions_vector(true,inic2,$i.text,treure_V($t.tipus),$in2.ls,$dim,$t.t,$t.valori,$t.valorf,$t.llista,$i.getLine());
		}
		if (!treure_V($t.tipus).equals("SI")) 
		{
			for (int i22=1; i22<=$dim; i22++) 
				{
				if (treure_V($t.tipus).equals("I") && $t.t.equals("") && !inic2)
				{
					smt.add("(>= "+po+$i.text+esoguio+i22+esoguio+pt+" "+neg2(deflow)+")"); 	  		
					smt.add("(<= "+po+$i.text+esoguio+i22+esoguio+pt+" "+neg2(defup)+")"); 			
				}
				if ($t.t.equals("rang")){
					smt.add("(>= "+po+$i.text+esoguio+i22+esoguio+pt+" "+neg($t.valori)+")"); 	  		
					smt.add("(<= "+po+$i.text+esoguio+i22+esoguio+pt+" "+neg($t.valorf)+")"); 			
				}
				if ($t.t.equals("llista")){
					Iterator<String> ii=$t.llista.iterator();  
					String aux="";
					while (ii.hasNext())
						{
						aux=aux+" (= "+po+$i.text+esoguio+i22+esoguio+pt+" "+neg(ii.next())+")"; 
						}			
					if (!aux.equals("")) {aux="(or"+aux+")";smt.add(aux);} 			
				}
			} 
		}
		else  //array de sets
		{
			$ls=new ListString();
			for (int i22=1; i22<=$dim; i22++)
			{
				if (inic2)
				{
					if (!st.existeix($in2.ls.obtenir(i22)))
					{
						missatgeError(7,$i.text,$i.getLine());
					}
					else
					{
						Registre r9=st.obtenir($in2.ls.obtenir(i22));
						if (r9.getInicialitzat())
						{
							tractar_var_set($t.t, "llista", $i.text+"_"+i22+"_", inic2, 'V', $t.llista,pasar_vector_bool_a_string(r9.getValorSet()), $t.valori, $t.valorf,"","",$i.getLine(),r9.getInicialitzat(),"");
						}
						else
						{
							missatgeError(7,$i2.text,$i2.getLine());
						}
					}
				}
				else
				{
					tractar_var_set($t.t, "", $i.text+"_"+i22+"_", inic2, 'V', $t.llista, new Vector<String>(), $t.valori, $t.valorf,"","",$i.getLine(),false,"");
				}
				Registre r11=st.obtenir($i.text+"_"+i22+"_");
				$res=r11.getPossibleSet();
				$ls.inserir(i22,$i.text+"_"+i22+"_");

			}
			$inic=true;
		}
		}
		))
	;
	
ini_array [String tip, Integer dim, boolean esvar] returns [ListString ls]  
	:	^(IGUAL ^(tu=PARENQT {Integer cont=1;ListString s=new ListString();} 
			//(t=scalar_flat_expr[tip,esvar] 
			(t=non_array_flat_expr[tip]
			{
				s.inserir(cont++,$t.valor);
			}
			)*
			{$ls=s;if ((cont-1)!=dim) {missatgeError(9,"",$tu.getLine());}
			}
			)) 
	;
	
annotations returns [String out]
	: 	^('output_var' {$out="output";}) 
	|	^('output_array' {int i=0;$out="";} (r=rangoset {i++;$out=$out+", "+$r.o;})+ 
			{
			if (i>0)
			{
				$out=i+"d("+$out.substring(2,$out.length());
			}
			else
			{
				$out="0d(";
			}
			}
		)
	|	ANNO {$out="";}
	; 

rangoset returns [String o] 
	:	^(DOSPUNTS i=INT_LITERAL i2=INT_LITERAL {$o=$i.text+".."+$i2.text;})
	|	CLAUO i3=INT_LITERAL {$o="{"+$i3.text;} ( COMA i4=INT_LITERAL {$o=$o+", "+$i4.text;} )* CLAUT {$o=$o+"}";}
	;	
	
non_array_ti_expr_tail returns [String tipus,String t,String valori,String valorf,Vector<String> llista]
	:	s1=scalar_ti_expr_tail {$tipus=$s1.tipus;$t=$s1.t;$valori=$s1.valori;$valorf=$s1.valorf;$llista=$s1.llista;}
	|	s2=set_ti_expr_tail {$t=$s2.t;$tipus=$s2.tipus;$valori=$s2.valori;$valorf=$s2.valorf;$llista=$s2.llista;}
	;

scalar_ti_expr_tail returns [String tipus,String t,String valori,String valorf,Vector<String> llista] 
	:	BOOL {$tipus="B";$t="";}
	|	INT {$tipus="I";$t="";}
	|	^(DOSPUNTS i1=INT_LITERAL i2=INT_LITERAL 
			{
				if (Integer.parseInt($i1.text)>Integer.parseInt($i2.text)) {missatgeError(16,$i1.text+" .. "+$i2.text,$i1.getLine());}
				$tipus="I";$t="rang";$valori=$i1.text;$valorf=$i2.text;
			} 
			)
	|	^(LLISTA {$llista=new Vector<String>();} (l=INT_LITERAL {$llista.add($l.text);})+ 
		{$tipus="I";$t="llista";} 
		)
	|	FLOAT {$tipus="F";$t="";}
	|	^(DOSPUNTS i3=FLOAT_LITERAL i4=FLOAT_LITERAL 
			{
				if (Float.parseFloat($i3.text)>Float.parseFloat($i4.text)) {missatgeError(16,$i3.text+" .. "+$i4.text,$i3.getLine());}
				$tipus="F";$t="rang";$valori=$i3.text;$valorf=$i4.text;
			} 
			)
	;

set_ti_expr_tail returns [String tipus,String t,String valori,String valorf,Vector<String> llista]
	:	^(rs=SET r1=scalar_ti_expr_tail 
		{	
		$tipus="SI";
		$t=$r1.t;
		$valori=$r1.valori;
		$valorf=$r1.valorf;
		$llista=$r1.llista;
		if (!$r1.tipus.equals("I")) {missatgeError(8,"",$rs.getLine());}
		} 
		)
	;
	
	
	





















//////////////////////////////////////////////////777777777777777
//
//		E X P R E S S I O N S
//
//////////////////////////////////////////////////777777777777777








flat_expr returns [String tipus, String valor]
	:	nafe=non_array_flat_expr["R"] {$tipus=$nafe.tipus;$valor=$nafe.valor;}
	|	^(g=PARENQT  
		{
			int cont=0;ListString l=new ListString();String tipusvec="R";
		} 
		(n=non_array_flat_expr["R"]
		{
			if (tipusvec.equals("R") || treure_V(tipusvec).equals(treure_V($n.tipus))) { 
				tipusvec=$n.tipus;
				cont++;
				l.inserir(cont,$n.valor);
			}
			else {
				missatgeError(7,$n.text,$g.getLine());   
			}	
		}
		)*
		{
			temp++;
			$tipus="["+tipusvec;
			$valor="temp___e"+temp; 
			inserirIdent($valor,'N',$tipus,cont,"",true,l,new ListBool(),"","","",new Vector<String>(),$g.getLine(),""); 
		}
		) 
	;

non_array_flat_expr [String ent] returns [String valor, ListString l, ListBool s, String tipus, String t, Vector<String> llista, String valori, String valorf, boolean init]
	:	s1=scalar_flat_expr[$ent] 
		{
		if (!$s1.tipus.equals("SI"))
		{
			$valor=$s1.valor;$tipus=$s1.tipus;$t="";$init=$s1.init;
		}
		else
		{
			String auxvalor=$s1.valor;
			if ($s1.valor.substring(0,1).equals("(")) 
			{
				int y=$s1.valor.indexOf(" ",0);
				String aux=$s1.valor.substring(1,y);
				String aux2=$s1.valor.substring(y+1,$s1.valor.indexOf(")",y+1));
				auxvalor=aux+"_"+aux2+"_";
			}	
			$t="llista";$tipus="SI";$valor="";
			Registre r7=st.obtenir(auxvalor);
			$llista=new Vector<String>();
			ListBool lb=r7.getValorSet();
			Iterator<Integer> ii3=r7.getValorSet().conjuntClaus().iterator();
			while (ii3.hasNext()) 
			{
				Integer i3=ii3.next();
				$llista.add(i3.toString());		
			}
			//$llista=pasar_vector_bool_a_string(r7.getValorSet());
			$valor=auxvalor;
			$init=r7.getInicialitzat();
		}
		} 
	|	^(i77=LLISTA  
		{
		$t="llista";$tipus="SI";$valor="";
		$llista=new Vector<String>();
		} //nomes per els sets
		(scfe=scalar_flat_expr["I"]
		{
			$llista.add($scfe.valor);
		}
		)*
		)
		{
			temp++;
			$valor="temp___e"+temp;
			$init=true;
			inserirIdentSet("llista","llista",$valor,true,'N',$llista,$llista,"","","","",$i77.getLine(),true,"");
		}
	|	^(i78=DOSPUNTS 
			{
				$t="rang";$tipus="SI";$valor="";
				if (!($ent.equals($tipus) || $ent.equals("R"))) {missatgeError(6,$id.text,$id.getLine());}
			}//nomes per els sets
		(
		id=IDENT 
		{
		if (st.existeix($id.text))
		{
			Registre r=st.obtenir($id.text);
			if (r.getTipus()=='N' && r.getSignatura().equals("I")) 
			{
				$valori=((Integer)r.getValorInt()).toString();
			}
			else
			{
				missatgeError(7,$id.text,$id.getLine());
			}
		}
		else
		{
			missatgeError(6,$id.text,$id.getLine());
		}
		}
		| ii1=INT_LITERAL
		{$valori=$ii1.text;}
		)  
		( 
		id2=IDENT 
		{
		if (st.existeix($id2.text))
		{
			Registre r=st.obtenir($id2.text);
			if (r.getTipus()=='N' && r.getSignatura().equals("I")) 
			{
				$valorf=((Integer)r.getValorInt()).toString();
			}
			else
			{
				missatgeError(7,$id2.text,$id2.getLine());
			}
		}
		else
		{
			missatgeError(6,$id.text,$id.getLine());
		}
		}
		| ii2=INT_LITERAL
		{$valorf=$ii2.text;}
		)
		{
			$init=false;
			if (Integer.parseInt($valori)>Integer.parseInt($valorf)) 
			{
				missatgeError(16,$valori+" .. "+$valorf,$ii2.getLine());
			}
			else
			{
				temp++;
				$valor="temp___e"+temp;
				$init=true;
				inserirIdentSet("rang","rang",$valor,true,'N',new Vector<String>(),new Vector<String>(),$valori,$valorf,$valori,$valorf,$i78.getLine(),true,"");
			}
		}
		) 
	;

scalar_flat_expr [String ent] returns [String valor,String tipus, boolean init] 
	:	id=IDENT  //S'HA DE MIRAR SI ES UNA VARIABLE I LLAVORS FER L'IGUAL
		{
		$valor="";
		$init=false;
		if (!($ent.equals("R"))) {
			if (st.existeix($id.text)){
				Registre r=st.obtenir($id.text);
				$tipus=$ent;
				$init=r.getInicialitzat();
				if (r.getTipus()=='N') 
				{
					if (treure_V(r.getSignatura()).equals($ent) && r.getInicialitzat()) {
						if ($ent.equals("B")) {$valor=Boolean.toString(r.getValorBool());}
						if ($ent.equals("I")) {$valor=Integer.toString(r.getValorInt());}
						if ($ent.equals("F")) {$valor=Float.toString(r.getValorFloat());}
						if ($ent.equals("SI")) {$valor=$id.text;}
					}
					else {
						missatgeError(7,$id.text,$id.getLine()); 
					}
				}
				else
				{
					if (treure_V(r.getSignatura()).equals($ent))
					{
						if ( r.getInicialitzat()) 
						{
							if (treure_V($ent).equals("B")) {$valor=Boolean.toString(r.getValorBool());}
							if (treure_V($ent).equals("I")) {$valor=Integer.toString(r.getValorInt());}
							if (treure_V($ent).equals("F")) {$valor=Float.toString(r.getValorFloat());}
							if (treure_V($ent).equals("SI")) {$valor=$id.text;}
						}
						else {$valor=$id.text;}
					}
					else
					{
						missatgeError(7,$id.text,$id.getLine()); 
					}
				}
			}
			else {
				missatgeError(6,$id.text,$id.getLine());
			}
		}
		else {
			if (st.existeix($id.text)){
				Registre r=st.obtenir($id.text);
				$tipus=r.getSignatura();
				$valor=$id.text;
				$init=r.getInicialitzat();
				if (r.getInicialitzat()) //((r.getTipus()=='N') && (r.getInicialitzat())) 
				{
					$tipus=treure_V($tipus);
					if ($tipus.equals("B")) {$valor=Boolean.toString(r.getValorBool());}
					if ($tipus.equals("I")) {$valor=Integer.toString(r.getValorInt());}
					if ($tipus.equals("F")) {$valor=Float.toString(r.getValorFloat());}
					if ($ent.equals("SI")) {$valor=$id.text;}
				}
				else 
				{
					if (r.getTipus()=='V') {
						//$tipus=$tipus.substring(1,$tipus.length());
						$valor=r.getLexema();
					}
					else {
						missatgeError(7,$id.text,$id.getLine());
					}
				}
			}
			else {
				missatgeError(6,$id.text,$id.getLine()); 
			}
		}

		}
	|	^(j=PARENQO no=IDENT 
			{boolean ide=false;} 
			(
			  no2=IDENT {}
			| no3=INT_LITERAL {ide=true;}
			)
		{
		$valor="";
		$tipus="";
		$init=false;
		if (st.existeix($no.text))
		{
			Registre r=st.obtenir($no.text);
			if (!("["+$ent).equals(treure_V(r.getSignatura())) && !$ent.equals("R"))
			{
				missatgeError(10,$no.text,$no.getLine()); 
			}
			else
			{
				$valor=tractar_acces_array(r,$no.text,$no2.text,$no3.text,ide,$no.getLine(),treure_V(r.getSignatura()).substring(1,treure_V(r.getSignatura()).length()));
			}
			$tipus=treure_V(r.getSignatura()).substring(1,treure_V(r.getSignatura()).length());
			if (!r.getSignatura().equals(treure_V(r.getSignatura()))) {$tipus="V"+$tipus;}
			$init=r.getInicialitzat();
		}
		else 
		{
			missatgeError(12,$no.text,$no.getLine());
		}
		}
		)
	|	et=TRUE  		{$init=true;$valor="true";$tipus="B";if (!($ent.equals($tipus) || $ent.equals("R"))) {missatgeError(2,"",$et.getLine());}}
	|	ef=FALSE 		{$init=true;$valor="false";$tipus="B";if (!($ent.equals($tipus) || $ent.equals("R"))) {missatgeError(2,"",$ef.getLine());}}
	| 	i=INT_LITERAL 		{$init=true;$valor=$i.text;$tipus="I";if (!($ent.equals($tipus) || $ent.equals("R"))) {missatgeError(3,"",$i.getLine());}}
	|	f=FLOAT_LITERAL 	{$init=true;$valor=$f.text;$tipus="F";if (!($ent.equals($tipus) || $ent.equals("R"))) {missatgeError(4,"",$f.getLine());}}
	|	ss=STRING_LITERAL 	{$init=true;$valor="";if (!$ent.equals("R")) {missatgeError(5,"",$ss.getLine());}}
	;











































constraint_item
	:	^(CONSTRAINT constraint_elem) 
	;
	
constraint_elem 
	:	pred_array
	|	pred_bool
	|	pred_float
	|	pred_int
	|	pred_set
	|	pred_globals
	|	^(i=IDENT flat_expr+ {missatgeError(11,$i.text,$i.getLine());})
	|	p=IDENT 
	{
			Registre r=st.obtenir($p.text);
			if (!"B".equals(treure_V(r.getSignatura())))
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				if (r.getInicialitzat()) {smt.add(((Boolean)r.getValorBool()).toString());} else {smt.add($p.text);}
			}
	}
	|	^(PARENQO p=IDENT {boolean lit=false;} (p2=IDENT | i=INT_LITERAL{lit=true;}) 
	{
			Registre r=st.obtenir($p.text);
			if (!"[B".equals(treure_V(r.getSignatura())))
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				smt.add(tractar_acces_array(r,$p.text,$p2.text,$i.text,lit,$p.getLine(),"B"));
			}
	}
	)
	;
	
	
	
pred_array
	@init {
	String[] ntipus=new String[5];
	String[] nvalors=new String[5];
	int ncont=0;
	}
	:	^(p='array_bool_and'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //array_bool_and(array[int] of var bool: as, var bool: r)   ( i=1..n as[i] ) <--> r      
			{
			Registre r=st.obtenir($p.text);
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				String aux="";
				if (nvalors[0]==null) 
				{
					aux="true";
				}
				else
				{
					if (r.getLia()) {lia=true;}
					Registre r1=st.obtenir(nvalors[0]);
					int tt=r1.getDim();
					ListString a1=r1.getValorArray();
					char t1=r1.getTipus();
					String aux1="";			
					String lexema1=r1.getLexema();			
					for (int i=1;i<=tt;i++)
					{
						if (t1=='N') 
						{
							aux1=neg(a1.obtenir(i));
						}
						else  
						{
							aux1=po+lexema1+esoguio+i+esoguio+pt;
						}
						aux=aux+" "+aux1;
					}
				}
				aux="(= (and "+aux+") "+neg(nvalors[1])+")";
				smt.add(aux);
			}
			}
		 )
	| 	^((p='array_bool_element' | p='array_var_bool_element')  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // array_bool_element(var int: b, array [int] of var int:as, var int: c)   ( b=1..n /\ as[b] =c )    
			{
			obtenir_string_element($p.text,ntipus,nvalors,ncont,$p.getLine()); 
			}
		 )
	|	^(p='array_bool_or'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //array_bool_or(array[int] of var bool: as, var bool: r)   ( ex i=1..n as[i] ) <--> r      
			{
			Registre r=st.obtenir($p.text);
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				String aux="";
				if (nvalors[0]==null) 
				{
					aux="(= false "+neg(nvalors[1])+")";
				}
				else
				{
					if (r.getLia()) {lia=true;}
					Registre r1=st.obtenir(nvalors[0]);
					int tt=r1.getDim();
					ListString a1=r1.getValorArray();
					char t1=r1.getTipus();
					String aux1="";			
					String lexema1=r1.getLexema();			
					if (expandir || (t1=='N'))
					{
						for (int i=1;i<=tt;i++)
						{
							if (t1=='N') 
							{
								aux1=neg(a1.obtenir(i));
							}
							else  
							{
								aux1=po+lexema1+esoguio+i+esoguio+pt;
							}
							aux=aux+" "+aux1;
						}
					aux="(= (or "+aux+") "+neg(nvalors[1])+")";
					}
					else 
					{
						litexp++;
						String literal="lit___exp___e"+litexp;
						//extrafuns.inserir(literal,"I");
						inserirIdent(literal,'V',"VI",0,"",false,new ListString(),new ListBool(),"","","", new Vector<String>(),0,"");
						smt.add("(>= "+literal+" "+"1)"); 	   		
						smt.add("(<= "+literal+" "+tt+")"); 							
						aux="(= (= ("+lexema1+" "+literal+") true) "+neg(nvalors[1])+")";
					}
				}
				smt.add(aux);
			}
			}
		 )
	| 	^((p='array_float_element' | p='array_var_float_element') (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // array_float_element(var int: b, array [int] of var int:as, var int: c)   ( b=1..n /\ as[b] =c )    
			{
			obtenir_string_element($p.text,ntipus,nvalors,ncont,$p.getLine()); 
			}
		 )
	| 	^((p='array_int_element' | p='array_var_int_element') (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // array_int_element(var int: b, array [int] of var int:as, var int: c)   ( b=1..n /\ as[b] =c )    
			{
			obtenir_string_element($p.text,ntipus,nvalors,ncont,$p.getLine()); 
			}
		 )
	| 	^((p='array_set_element' | p='array_var_set_element') (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // array_int_element(var int: b, array [int] of var int:as, var int: c)   ( b=1..n /\ as[b] =c )    
			{
			obtenir_string_element($p.text,ntipus,nvalors,ncont,$p.getLine()); 
			}
		 )
	;
	
	
pred_bool
	@init {
	String[] ntipus=new String[5];
	String[] nvalors=new String[5];
	int ncont=0;
	}
	:	^(p='bool2int'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // bool2int(var bool: a, var int: b)   (a <--> b = 1) /\ (!a <--> b = 0)      (or (= ((iff $0 $1) true) (= ((iff (not $0) $1) false))
			{
			//obtenir_string($p.text,ntipus,nvalors,"(or (= $1 0) (= $1 1)) (= (not (= $1 0)) $0)",ncont,$p.getLine()); 
			obtenir_string($p.text,ntipus,nvalors,"(ite $0 (= $1 1) (= $1 0))",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='bool_and'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // bool_and(var bool: a, var bool: b, var bool: r)   (a /\ b) <--> r     (iff (and $0 $1) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (and $0 $1) $2)",ncont,$p.getLine()); 
			}
		 )
	|	^(p='bool_clause'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //bool_clause_reif(array[int] of var bool: as, array[int] of var bool: bs)   ( (ex i=1..n as[i]) \/ (ex i=1..n not(bs[i])))      
			{
			String aux=obtenir_string_clause($p.text,ntipus,nvalors,ncont,$p.getLine()); 
			smt.add(aux);
			}
		 )
	|	^(p='bool_clause_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //bool_clause_reif(array[int] of var bool: as, array[int] of var bool: bs, var bool: r)   ( (ex i=1..n as[i]) \/ (ex i=1..n not(bs[i]))) <--> r      
			{
			String aux=obtenir_string_clause($p.text,ntipus,nvalors,ncont,$p.getLine()); 
			smt.add("(= "+aux+" "+nvalors[2]+")");
			}
		 )
	| 	^(p='bool_eq'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // bool_eq(var bool: a, var bool: b)   a = b    (= $0 $1)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= $0 $1)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='bool_eq_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // bool_eq_reif(var bool: a, var bool: b, var bool: r)   (a = b) <--> r     (iff (= $0 $1) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (= $0 $1) $2)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='bool_ge'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // bool_ge(var bool: a, var bool: b)   a \/ !b    (or $0 (not $1))
			{
			obtenir_string($p.text,ntipus,nvalors,"(or $0 (not $1))",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='bool_ge_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // bool_ge_reif(var bool: a, var bool: b, var bool: r)   (a \/ !b) <--> r     (iff (or $0 (not $1)) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (or $0 (not $1)) $2)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='bool_gt'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // bool_gt(var bool: a, var bool: b)   !a \/ b    (or (not $0) $1)
			{
			obtenir_string($p.text,ntipus,nvalors,"(and (not $1) $0)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='bool_gt_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // bool_gt_reif(var bool: a, var bool: b, var bool: r)   (!a \/ b) <--> r     (iff (or (not $0) $1) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (and (not $1) $0) $2)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='bool_le'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // bool_le(var bool: a, var bool: b)   !a \/ b    (or (not $0) $1)
			{
			obtenir_string($p.text,ntipus,nvalors,"(or (not $0) $1)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='bool_le_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // bool_le_reif(var bool: a, var bool: b, var bool: r)   (!a \/ b) <--> r     (iff (or (not $0) $1) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (or (not $0) $1) $2)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='bool_left_imp'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // bool_left_imp(var bool: a, var bool: b, var bool: r)   (a --> b) <--> r     (iff (implies $0 $1) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (implies $1 $0) $2)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='bool_lt'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // bool_lt(var bool: a, var bool: b)   !a /\ b    (and (not $0) $1)
			{
			obtenir_string($p.text,ntipus,nvalors,"(and (not $0) $1)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='bool_lt_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // bool_lt_reif(var bool: a, var bool: b, var bool: r)   (!a /\ b) <--> r     (iff (and (not $0) $1) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (and (not $0) $1) $2)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='bool_ne'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // bool_ne(var bool: a, var bool: b)   a <> b  (not  (= $0 $1))
			{
			obtenir_string($p.text,ntipus,nvalors,"(not (= $0 $1))",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='bool_ne_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // bool_ne_reif(var bool: a, var bool: b, var bool: r)   (a <> b) <--> r     (iff (not  (= $0 $1)) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (not (= $0 $1)) $2)",ncont,$p.getLine());
			}
		 )
	| 	^(p='bool_not'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // bool_not(var bool: a, var bool: b)   (!a = b)      (= (not $0) $1) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (not $0) $1)",ncont,$p.getLine());
			}
		 )
	| 	^(p='bool_or'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // bool_or(var bool: a, var bool: b, var bool: r)   (a or b) <--> r     (iff (or $0 $1) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (or $0 $1) $2)",ncont,$p.getLine());
			}
		 )
	| 	^(p='bool_right_imp'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // bool_right_imp(var bool: a, var bool: b, var bool: r)   (a -> b) <--> r     (iff (implies $0 $1) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (implies $0 $1) $2)",ncont,$p.getLine());
			}
		 )
	| 	^(p='bool_xor'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // bool_xor(var bool: a, var bool: b, var bool: r)   (a <> b) <--> r     (iff (xor $0 $1) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (xor $0 $1) $2)",ncont,$p.getLine());
			}
		 )
	;
	
pred_int	
	@init {
	String[] ntipus=new String[5];
	String[] nvalors=new String[5];
	int ncont=0;
	}
	:	^(p='int_abs'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // int_abs(var int: a, var int: b)   |a| = b    (ite (< $0 0) (= (* $0 -1) $1) (= $0 $1))
			{
			obtenir_string($p.text,ntipus,nvalors,"(or (= $0 $1) (= (- 0 $0) $1)) (>= $1 0)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='int_div'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // int_div(var int: a, var int: b, var int: c)   a / b= c    (= (div $0 $1) $2)
			{
			if (ntipus[0].substring(0,1).equals("V") && ntipus[1].substring(0,1).equals("V"))
			{
				//mirar_si_rang($p.text,ntipus,nvalors,0,1,"(ite (> $1 0) (and (<= (* $1 $2) $0) (> (+ (* $1 $2) $1) $0)) (and (>= (* $1 $2) $0) (< (+ (* $1 $2) $1) $0)))",ncont,$p.getLine());
				mirar_si_rang($p.text,ntipus,nvalors,0,1,"(ite (> $0 0) (and (<= (* $1 $2) $0) (ite (> $1 0) (> (+ (* $1 $2) $1) $0) (> (- (* $1 $2) $1) $0))) (and (>= (* $1 $2) $0) (ite (> $1 0) (< (- (* $1 $2) $1) $0) (< (+ (* $1 $2) $1) $0))))",ncont,$p.getLine());
			}
			else 
			{
				//obtenir_string($p.text,ntipus,nvalors,"(ite (> $1 0) (and (<= (* $1 $2) $0) (> (+ (* $1 $2) $1) $0)) (and (>= (* $1 $2) $0) (< (+ (* $1 $2) $1) $0)))",ncont,$p.getLine()); 
				obtenir_string($p.text,ntipus,nvalors,"(ite (> $0 0) (and (<= (* $1 $2) $0) (ite (> $1 0) (> (+ (* $1 $2) $1) $0) (> (- (* $1 $2) $1) $0))) (and (>= (* $1 $2) $0) (ite (> $1 0) (< (- (* $1 $2) $1) $0) (< (+ (* $1 $2) $1) $0))))",ncont,$p.getLine()); 
			}
			}
		 )
	| 	^(p='int_eq'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // int_eq(var int: a, var int: b)   a = b    (= $0 $1)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= $0 $1)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='int_eq_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // int_eq_reif(var int: a, var int: b, var bool: r)   (a = b) <--> r     (iff (= $0 $1) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (= $0 $1) $2)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='int_ge'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // int_ge(var int: a, var int: b)   a >= b    (>= $0 $1)
			{
			obtenir_string($p.text,ntipus,nvalors,"(>= $0 $1)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='int_ge_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // int_ge_reif(var int: a, var int: b, var bool: r)   (a >= b) <--> r     (iff (>= $0 $1) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (>= $0 $1) $2)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='int_gt'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // int_gt(var int: a, var int: b)   a > b    (> $0 $1)
			{
			obtenir_string($p.text,ntipus,nvalors,"(> $0 $1)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='int_gt_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // int_gt_reif(var int: a, var int: b, var bool: r)   (a > b) <--> r     (iff (> $0 $1) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (> $0 $1) $2)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='int_le'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // int_le(var int: a, var int: b)   a <= b    (<= $0 $1)
			{
			obtenir_string($p.text,ntipus,nvalors,"(<= $0 $1)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='int_le_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // int_le_reif(var int: a, var int: b, var bool: r)   (a <= b) <--> r     (iff (<= $0 $1) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (<= $0 $1) $2)",ncont,$p.getLine()); 
			}
		 )	
	| 	^(p='int_lin_eq'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //int_lin_eq(array[int] of int: as, array[int] of var int: bs, var int: b)   ( Sum(i=1..n) as[i]*bs[i] = c )      
			{
			obtenir_string_lin($p.text,ntipus,nvalors,"=",false,ncont,$p.getLine(),false);
			}
		 )
	| 	^(p='int_lin_eq_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //int_lin_eq_reif(array[int] of int: as, array[int] of var int: bs, var int: b, var bool: r)   ( Sum(i=1..n) as[i]*bs[i] = c ) <--> r
			{
			obtenir_string_lin($p.text,ntipus,nvalors,"=",true,ncont,$p.getLine(),false);
			}
		 )
	| 	^(p='int_lin_ge'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //int_lin_ge(array[int] of int: as, array[int] of var int: bs, var int: b)   ( Sum(i=1..n) as[i]*bs[i] >= c )
			{
			obtenir_string_lin($p.text,ntipus,nvalors,">=",false,ncont,$p.getLine(),false); 
			}
		 )
	| 	^(p='int_lin_ge_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //int_lin_ge_reif(array[int] of int: as, array[int] of var int: bs, var int: b, var bool: r)   ( Sum(i=1..n) as[i]*bs[i] >= c ) <--> r
			{
			obtenir_string_lin($p.text,ntipus,nvalors,">=",true,ncont,$p.getLine(),false); 
			}
		 )
	| 	^(p='int_lin_gt'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //int_lin_gt(array[int] of int: as, array[int] of var int: bs, var int: b)   ( Sum(i=1..n) as[i]*bs[i] > c )
			{
			obtenir_string_lin($p.text,ntipus,nvalors,">",false,ncont,$p.getLine(),false); 
			}
		 )
	| 	^(p='int_lin_gt_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //int_lin_gt_reif(array[int] of int: as, array[int] of var int: bs, var int: b, var bool: r)   ( Sum(i=1..n) as[i]*bs[i] > c ) <--> r
			{
			obtenir_string_lin($p.text,ntipus,nvalors,">",true,ncont,$p.getLine(),false); 
			}
		 )
	| 	^(p='int_lin_le'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //int_lin_le(array[int] of int: as, array[int] of var int: bs, var int: b)   ( Sum(i=1..n) as[i]*bs[i] <= c )
			{
			obtenir_string_lin($p.text,ntipus,nvalors,"<=",false,ncont,$p.getLine(),false); 
			}
		 )
	| 	^(p='int_lin_le_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //int_lin_le_reif(array[int] of int: as, array[int] of var int: bs, var int: b, var bool: r)   ( Sum(i=1..n) as[i]*bs[i] <= c ) <--> r
			{
			obtenir_string_lin($p.text,ntipus,nvalors,"<=",true,ncont,$p.getLine(),false); 
			}
		 )
	| 	^(p='int_lin_lt'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //int_lin_lt(array[int] of int: as, array[int] of var int: bs, var int: b)   ( Sum(i=1..n) as[i]*bs[i] < c )
			{
			obtenir_string_lin($p.text,ntipus,nvalors,"<",false,ncont,$p.getLine(),false); 
			}
		 )
	| 	^(p='int_lin_lt_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //int_lin_lt_reif(array[int] of int: as, array[int] of var int: bs, var int: b, var bool: r)   ( Sum(i=1..n) as[i]*bs[i] < c ) <--> r
			{
			obtenir_string_lin($p.text,ntipus,nvalors,"<",true,ncont,$p.getLine(),false); 
			}
		 )
	| 	^(p='int_lin_ne'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //int_lin_ne(array[int] of int: as, array[int] of var int: bs, var int: b)   ( Sum(i=1..n) as[i]*bs[i] <> c )
			{
			obtenir_string_lin($p.text,ntipus,nvalors,"<>",false,ncont,$p.getLine(),false); 
			}
		 )
	| 	^(p='int_lin_ne_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //int_lin_ne_reif(array[int] of int: as, array[int] of var int: bs, var int: b, var bool: r)   ( Sum(i=1..n) as[i]*bs[i] <> c ) <--> r
			{
			obtenir_string_lin($p.text,ntipus,nvalors,"<>",true,ncont,$p.getLine(),false); 
			}
		 )
	| 	^(p='int_lt'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // int_lt(var int: a, var int: b)   a < b    (< $0 $1)
			{
			obtenir_string($p.text,ntipus,nvalors,"(< $0 $1)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='int_lt_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // int_lt_reif(var int: a, var int: b, var bool: r)   (a < b) <--> r     (iff (< $0 $1) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (< $0 $1) $2)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='int_max'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // int_max(var int: a, var int: b, var int: c)   max(a,b) = c    (ite (< $0 $1) (= $1 $2) (= $0 $2))
			{
			obtenir_string($p.text,ntipus,nvalors,"(ite (< $0 $1) (= $1 $2) (= $0 $2))",ncont,$p.getLine()); 
			}
		 ) 
	| 	^(p='int_min'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // int_min(var int: a, var int: b, var int: c)   min(a,b) = c    (ite (> $0 $1) (= $1 $2) (= $0 $2))
			{
			obtenir_string($p.text,ntipus,nvalors,"(ite (> $0 $1) (= $1 $2) (= $0 $2))",ncont,$p.getLine()); 
			}
		 ) 
	| 	^(p='int_minus'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // int_minus(var int: a, var int: b, var int: c)   a - b = c    (= (- $0 $1) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (- $0 $1) $2)",ncont,$p.getLine());  
			if (ntipus[0].substring(0,1).equals("V") && ntipus[1].substring(0,1).equals("V")) {lia=true;}
			}
		 ) 
	| 	^(p='int_mod'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // int_mod(var int: a, var int: b, var int: c)   a - ( a / b ) * b  = c    (= (- $0 (* (/ $0 $1) $1)) $2)
			{
			temp++;
			String literal="temp___e"+temp;
			inserirIdent(literal,'V',"VI",0,"",false,new ListString(),new ListBool(),"","","",new Vector<String>(),$p.getLine(),""); 
			if (ntipus[1].substring(0,1).equals("V"))
			{
				//mirar_si_rang($p.text,ntipus,nvalors,1,1,"(and (= (+ (* "+literal+" $1) $2) $0) (ite (> $1 0) (and (> (+ (* "+literal+" $1) $1) $0) (>= $2 0) (< $2 $1)) (and (< (+ (* "+literal+" $1) $1) $0) (<= $2 0) (> $2 $1))))",ncont,$p.getLine());
				mirar_si_rang($p.text,ntipus,nvalors,1,1,"(and (= (+ (* "+literal+" $1) $2) $0) (ite (> $0 0) (ite (> $1 0) (and (> (+ (* "+literal+" $1) $1) $0) (>= $2 0) (< $2 $1)) (and (> (- (* "+literal+" $1) $1) $0) (>= $2 0) (< $2 (- 0 $1)))) (ite (> $1 0) (and (< (- (* "+literal+" $1) $1) $0) (<= $2 0) (> $2 (- 0 $1))) (and (< (+ (* "+literal+" $1) $1) $0) (<= $2 0) (> $2 $1)))))",ncont,$p.getLine());
			}
			else 
			{
				//obtenir_string($p.text,ntipus,nvalors,"(and (= (+ (* "+literal+" $1) $2) $0) (ite (> $1 0) (and (> (+ (* "+literal+" $1) $1) $0) (>= $2 0) (< $2 $1)) (and (< (+ (* "+literal+" $1) $1) $0) (<= $2 0) (> $2 $1))))",ncont,$p.getLine()); 
				obtenir_string($p.text,ntipus,nvalors,"(and (= (+ (* "+literal+" $1) $2) $0) (ite (> $0 0) (ite (> $1 0) (and (> (+ (* "+literal+" $1) $1) $0) (>= $2 0) (< $2 $1)) (and (> (- (* "+literal+" $1) $1) $0) (>= $2 0) (< $2 (- 0 $1)))) (ite (> $1 0) (and (< (- (* "+literal+" $1) $1) $0) (<= $2 0) (> $2 (- 0 $1))) (and (< (+ (* "+literal+" $1) $1) $0) (<= $2 0) (> $2 $1)))))",ncont,$p.getLine()); 
			}
			}
		 ) 
	| 	^(p='int_ne'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // int_ne(var int: a, var int: b)   a != b    (not (= $0 $1))
			{
			obtenir_string($p.text,ntipus,nvalors,"(not (= $0 $1))",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='int_ne_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // int_ne_reif(var int: a, var int: b, var bool: r)   (a != b) <--> r     (iff (not( (= $0 $1)) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (not (= $0 $1)) $2)",ncont,$p.getLine());
			}
		 )
	| 	^(p='int_negate'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // int_negate(var int: a, var int: b)   - a = b     (= (- 0 $0) $1)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (- 0 $0) $1)",ncont,$p.getLine()); 
			}
		 ) 
	| 	^(p='int_plus'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // int_plus(var int: a, var int: b, var int: c)   a + b = c    (= (+ $0 $1) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (+ $0 $1) $2)",ncont,$p.getLine()); 
			if (ntipus[0].substring(0,1).equals("V") && ntipus[1].substring(0,1).equals("V")) {lia=true;}
			}
		 ) 
	| 	^(p='int_times'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // int_times(var int: a, var int: b, var int: c)   a * b = c    (* (+ $0 $1) $2)
			{
			if (ntipus[0].substring(0,1).equals("V") && ntipus[1].substring(0,1).equals("V"))
			{
				mirar_si_rang($p.text,ntipus,nvalors,0,1,"(= (* $0 $1) $2)",ncont,$p.getLine());
			}
			else 
			{
				obtenir_string($p.text,ntipus,nvalors,"(= (* $0 $1) $2)",ncont,$p.getLine()); 
			}
			}
		 ) 
	| 	^(p='int2float'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // int2float(var int: a, var float: b)    a = b     (= $0 $1)
			{
			obtenir_string($p.text,ntipus,nvalors,"(<= (* $0 1.0) $1) (> (* (+ $0 1) 1.0) $1)",ncont,$p.getLine()); 
			}
		 ) 
	;

pred_float	
	@init {
	String[] ntipus=new String[5];
	String[] nvalors=new String[5];
	int ncont=0;
	}
	:	^(p='float_abs'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // float_abs(var float: a, var float: b)   |a| = b    (ite (< $0 0) (= (* $0 -1) $1) (= $0 $1))
			{
			obtenir_string($p.text,ntipus,nvalors,"(or (= $0 $1) (= (- 0 $0) $1)) (>= $1 0)",ncont,$p.getLine()); 
			}
		 ) 
	| 	^(p='float_div'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // float_div(var float: a, var float: b, var float: c)   a / b= c    (= (div $0 $1) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (* $1 $2) $0)",ncont,$p.getLine()); 
			if (ntipus[1].substring(0,1).equals("V") && ntipus[2].substring(0,1).equals("V")) {nia=true;}
			}
		 )
	| 	^(p='float_eq'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // float_eq(var int: a, var int: b)   a = b    (= $0 $1)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= $0 $1)",ncont,$p.getLine());  
			}
		 )
	| 	^(p='float_eq_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // float_eq_reif(var float: a, var float: b, var bool: r)   (a = b) <--> r     (iff (= $0 $1) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (= $0 $1) $2)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='float_ge'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // float_ge(var float: a, var float: b)   a >= b    (>= $0 $1)
			{
			obtenir_string($p.text,ntipus,nvalors,"(>= $0 $1)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='float_ge_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // float_ge_reif(var float: a, var float: b, var bool: r)   (a >= b) <--> r     (iff (>= $0 $1) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (>= $0 $1) $2)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='float_gt'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // float_gt(var float: a, var float: b)   a > b    (> $0 $1)
			{
			obtenir_string($p.text,ntipus,nvalors,"(> $0 $1)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='float_gt_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // float_gt_reif(var float: a, var float: b, var bool: r)   (a > b) <--> r     (iff (> $0 $1) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (> $0 $1) $2)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='float_le'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // float_le(var float: a, var float: b)   a <= b    (<= $0 $1)
			{
			obtenir_string($p.text,ntipus,nvalors,"(<= $0 $1)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='float_le_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // float_le_reif(var float: a, var float: b, var bool: r)   (a <= b) <--> r     (iff (<= $0 $1) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (<= $0 $1) $2)",ncont,$p.getLine()); 
			}
		 )	
	| 	^(p='float_lin_eq'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //float_lin_eq(array[int] of float: as, array[int] of var float: bs, var float: b)   ( Sum(i=1..n) as[i]*bs[i] = c )      
			{
			obtenir_string_lin($p.text,ntipus,nvalors,"=",false,ncont,$p.getLine(),true); 
			}
		 )
	| 	^(p='float_lin_eq_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //float_lin_eq_reif(array[int] of float: as, array[int] of var float: bs, var float: b, var bool: r)   ( Sum(i=1..n) as[i]*bs[i] = c ) <--> r
			{
			obtenir_string_lin($p.text,ntipus,nvalors,"=",true,ncont,$p.getLine(),true); 
			}
		 )
	| 	^(p='float_lin_ge'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //float_lin_ge(array[int] of float: as, array[int] of var float: bs, var float: b)   ( Sum(i=1..n) as[i]*bs[i] >= c )
			{
			obtenir_string_lin($p.text,ntipus,nvalors,">=",false,ncont,$p.getLine(),true); 
			}
		 )
	| 	^(p='float_lin_ge_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //float_lin_ge_reif(array[int] of float: as, array[int] of var float: bs, var float: b, var bool: r)   ( Sum(i=1..n) as[i]*bs[i] >= c ) <--> r
			{
			obtenir_string_lin($p.text,ntipus,nvalors,">=",true,ncont,$p.getLine(),true);
			}
		 )
	| 	^(p='float_lin_gt'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //float_lin_gt(array[int] of float: as, array[int] of var float: bs, var float: b)   ( Sum(i=1..n) as[i]*bs[i] > c )
			{
			obtenir_string_lin($p.text,ntipus,nvalors,">",false,ncont,$p.getLine(),true); 
			}
		 )
	| 	^(p='float_lin_gt_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //float_lin_gt_reif(array[int] of float: as, array[int] of var float: bs, var float: b, var bool: r)   ( Sum(i=1..n) as[i]*bs[i] > c ) <--> r
			{
			obtenir_string_lin($p.text,ntipus,nvalors,">",true,ncont,$p.getLine(),true); 
			}
		 )
	| 	^(p='float_lin_le'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //float_lin_le(array[int] of float: as, array[int] of var float: bs, var float: b)   ( Sum(i=1..n) as[i]*bs[i] <= c )
			{
			obtenir_string_lin($p.text,ntipus,nvalors,"<=",false,ncont,$p.getLine(),true);
			}
		 )
	| 	^(p='float_lin_le_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //float_lin_le_reif(array[int] of float: as, array[int] of var float: bs, var float: b, var bool: r)   ( Sum(i=1..n) as[i]*bs[i] <= c ) <--> r
			{
			obtenir_string_lin($p.text,ntipus,nvalors,"<=",true,ncont,$p.getLine(),true);
			}
		 )
	| 	^(p='float_lin_lt'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //float_lin_lt(array[int] of float: as, array[int] of var float: bs, var float: b)   ( Sum(i=1..n) as[i]*bs[i] < c )
			{
			obtenir_string_lin($p.text,ntipus,nvalors,"<",false,ncont,$p.getLine(),true); 
			}
		 )
	| 	^(p='float_lin_lt_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //float_lin_lt_reif(array[int] of float: as, array[int] of var float: bs, var float: b, var bool: r)   ( Sum(i=1..n) as[i]*bs[i] < c ) <--> r
			{
			obtenir_string_lin($p.text,ntipus,nvalors,"<",true,ncont,$p.getLine(),true); 
			}
		 )
	| 	^(p='float_lin_ne'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //float_lin_ne(array[int] of float: as, array[int] of var float: bs, var float: b)   ( Sum(i=1..n) as[i]*bs[i] <> c )
			{
			obtenir_string_lin($p.text,ntipus,nvalors,"<>",false,ncont,$p.getLine(),true); 
			}
		 )
	| 	^(p='float_lin_ne_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ //float_lin_ne_reif(array[int] of float: as, array[int] of var float: bs, var float: b, var bool: r)   ( Sum(i=1..n) as[i]*bs[i] <> c ) <--> r
			{
			obtenir_string_lin($p.text,ntipus,nvalors,"<>",true,ncont,$p.getLine(),true); 
			}
		 )
	| 	^(p='float_lt'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // float_lt(var float: a, var float: b)   a < b    (< $0 $1)
			{
			obtenir_string($p.text,ntipus,nvalors,"(< $0 $1)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='float_lt_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // float_lt_reif(var float: a, var float: b, var bool: r)   (a < b) <--> r     (iff (< $0 $1) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (< $0 $1) $2)",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='float_max'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // float_max(var float: a, var float: b, var float: c)   max(a,b) = c    (ite (< $0 $1) (= $1 $2) (= $0 $2))
			{
			obtenir_string($p.text,ntipus,nvalors,"(ite (< $0 $1) (= $1 $2) (= $0 $2))",ncont,$p.getLine()); 
			}
		 ) 
	| 	^(p='float_min'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // float_min(var float: a, var float: b, var float: c)   min(a,b) = c    (ite (> $0 $1) (= $1 $2) (= $0 $2))
			{
			obtenir_string($p.text,ntipus,nvalors,"(ite (> $0 $1) (= $1 $2) (= $0 $2))",ncont,$p.getLine()); 
			}
		 ) 
	| 	^(p='float_minus'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // float_minus(var float: a, var float: b, var float: c)   a - b = c    (= (- $0 $1) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (- $0 $1) $2)",ncont,$p.getLine()); 
			if (ntipus[0].substring(0,1).equals("V") && ntipus[1].substring(0,1).equals("V")) {lia=true;}
			}
		 ) 
	| 	^(p='float_ne'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // float_ne(var float: a, var float: b)   a != b    (not (= $0 $1))
			{
			obtenir_string($p.text,ntipus,nvalors,"(not (= $0 $1))",ncont,$p.getLine()); 
			}
		 )
	| 	^(p='float_ne_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // float_ne_reif(var float: a, var float: b, var bool: r)   (a != b) <--> r     (iff (not( (= $0 $1)) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (not (= $0 $1)) $2)",ncont,$p.getLine());
			}
		 )
	| 	^(p='float_negate'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // float_negate(var float: a, var float: b)   - a = b     (= (- 0 $0) $1)
				{
			obtenir_string($p.text,ntipus,nvalors,"(= (- 0 $0) $1)",ncont,$p.getLine()); 
			}
		 ) 
	| 	^(p='float_plus'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // float_plus(var float: a, var float: b, var float: c)   a + b = c    (= (+ $0 $1) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (+ $0 $1) $2)",ncont,$p.getLine()); 
			if (ntipus[0].substring(0,1).equals("V") && ntipus[1].substring(0,1).equals("V")) {lia=true;}
			}
		)
	| 	^(p='float_times'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // float_times(var float: a, var float: b, var float: c)   a + b = c    (= (* $0 $1) $2)
			{
			obtenir_string($p.text,ntipus,nvalors,"(= (* $0 $1) $2)",ncont,$p.getLine()); 
			if (ntipus[0].substring(0,1).equals("V") && ntipus[1].substring(0,1).equals("V")) {nia=true;}
			}
		 ) 
	;

		
pred_set	
	@init {
	String[] ntipus=new String[5];
	String[] nvalors=new String[5];
	int ncont=0;
	}
	:	^(p='set_card'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // set_card(var set of int: a, var int: b)   |a| = b     (= (SUM $0_i) $1)
			{
			Registre r=st.obtenir($p.text);
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				if (r.getLia()) {lia=true;}
				Registre r4=st.obtenir(nvalors[0]);
				Iterator<Integer> ii3=r4.getPossibleSet().conjuntClaus().iterator();
				Set<Integer> conjunt=r4.getValorSet().conjuntClaus();
				int cont=0;
				String aux="";
				while (ii3.hasNext()) 
				{
					Integer ii32=ii3.next();
					if (r4.tipus=='N' || r4.getInicialitzat())
					{
						if (conjunt.contains(ii32)) {cont++;}
					}
					else
					{
						aux=aux+" "+nvalors[0]+"_i-i_"+ii32+"_";
					}
				}
				if (r4.tipus=='N' || r4.getInicialitzat()) {aux=((Integer)cont).toString();} else {aux="(+ "+aux+")";}
				smt.add("(= "+aux+" "+nvalors[1]+")");
			}
			}
		)
	|	^(p='set_diff'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // set_diff(var set of int: a, var set of int: b, var set of int: b)     a diff b = c
			{
			Registre r=st.obtenir($p.text);
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				operar_set_3(ntipus,nvalors,ncont,"diferencia",false,$p.text,$p.getLine());
			}
			}
		)
	|	^(p='set_eq'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // set_eq(var set of int: a, var set of int: b)   a= b     
			{
			Registre r=st.obtenir($p.text);
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				operar_set(ntipus,nvalors,ncont,"igualtat",false,$p.text,$p.getLine());
			}
			}
		)
	|	^(p='set_eq_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // set_eq_reif(var set of int: a, var set of int: b, var bool c)   (a= b) <--> c  
			{
			Registre r=st.obtenir($p.text);
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				operar_set(ntipus,nvalors,ncont,"igualtat",true,$p.text,$p.getLine());
			}
			}
		)
	|	^(p='set_ge'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // set_ge(var set of int: a, var set of int: b)  
			{
			Registre r=st.obtenir($p.text);
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				operar_set(ntipus,nvalors,ncont,"ge",false,$p.text,$p.getLine());
			}
			}
		)
	|	^(p='set_ge_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // set_ge_reif(var set of int: a, var set of int: b, var bool c)  
			{
			Registre r=st.obtenir($p.text);
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				operar_set(ntipus,nvalors,ncont,"ge",true,$p.text,$p.getLine());
			}
			}
		)
	|	^(p='set_gt'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // set_gt(var set of int: a, var set of int: b)  
			{
			Registre r=st.obtenir($p.text);
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				operar_set(ntipus,nvalors,ncont,"gt",false,$p.text,$p.getLine());
			}
			}
		)
	|	^(p='set_gt_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // set_gt_reif(var set of int: a, var set of int: b, var bool c)  
			{
			Registre r=st.obtenir($p.text);
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				operar_set(ntipus,nvalors,ncont,"gt",true,$p.text,$p.getLine());
			}
			}
		)
	|	^(p='set_in'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // set_in(var int: a, var set of int: b)  
			{
			Registre r=st.obtenir($p.text);
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				operar_set_in(ntipus,nvalors,ncont,false,$p.text,$p.getLine());
			}
			}
		)
	|	^(p='set_in_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // set_in_reif(var int: a, var set of int: b)  
			{
			Registre r=st.obtenir($p.text);
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				operar_set_in(ntipus,nvalors,ncont,true,$p.text,$p.getLine());
			}
			}
		)
	|	^(p='set_intersect'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // set_intersect(var set of int: a, var set of int: b, var set of int: b)     a intersect b = c
			{
			Registre r=st.obtenir($p.text);
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				operar_set_3(ntipus,nvalors,ncont,"interseccio",false,$p.text,$p.getLine());
			}
			}
		)
	|	^(p='set_le'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // set_le(var set of int: a, var set of int: b) 
			{
			Registre r=st.obtenir($p.text);
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				operar_set(ntipus,nvalors,ncont,"le",false,$p.text,$p.getLine());
			}
			}
		)
	|	^(p='set_le_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // set_le_reif(var set of int: a, var set of int: b, var bool c)  
			{
			Registre r=st.obtenir($p.text);
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				operar_set(ntipus,nvalors,ncont,"le",true,$p.text,$p.getLine());
			}
			}
		)
	|	^(p='set_lt'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // set_lt(var set of int: a, var set of int: b)  
			{
			Registre r=st.obtenir($p.text);
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				operar_set(ntipus,nvalors,ncont,"lt",false,$p.text,$p.getLine());
			}
			}
		)
	|	^(p='set_lt_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // set_lt_reif(var set of int: a, var set of int: b, var bool c)  
			{
			Registre r=st.obtenir($p.text);
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				operar_set(ntipus,nvalors,ncont,"lt",true,$p.text,$p.getLine());
			}
			}
		)
	|	^(p='set_ne'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // set_ne(var set of int: a, var set of int: b)   a!= b     
			{
			Registre r=st.obtenir($p.text);
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				operar_set(ntipus,nvalors,ncont,"desigualtat",false,$p.text,$p.getLine());
			}
			}
		)
	|	^(p='set_ne_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // set_ne_reif(var set of int: a, var set of int: b, var bool c)   (a!= b) <--> c  
			{
			Registre r=st.obtenir($p.text);
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				operar_set(ntipus,nvalors,ncont,"desigualtat",true,$p.text,$p.getLine());
			}
			}
		)
	|	^(p='set_subset'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // set_subset(var set of int: a, var set of int: b)   a<= b     
			{
			Registre r=st.obtenir($p.text);
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				operar_set(ntipus,nvalors,ncont,"subset",false,$p.text,$p.getLine());
			}
			}
		)
	|	^(p='set_subset_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // set_subset_reif(var set of int: a, var set of int: b, var bool c)   (a<= b) <--> c  
			{
			Registre r=st.obtenir($p.text);
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				operar_set(ntipus,nvalors,ncont,"subset",true,$p.text,$p.getLine());
			}
			}
		)
	|	^(p='set_superset'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // set_superset(var set of int: a, var set of int: b)   a>= b     
			{
			Registre r=st.obtenir($p.text);
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				operar_set(ntipus,nvalors,ncont,"superset",false,$p.text,$p.getLine());
			}
			}
		)
	|	^(p='set_superset_reif'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // set_superset_reif(var set of int: a, var set of int: b, var bool c)   (a>= b) <--> c  
			{
			Registre r=st.obtenir($p.text);
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				operar_set(ntipus,nvalors,ncont,"superset",true,$p.text,$p.getLine());
			}
			}
		)
	|	^(p='set_symdiff'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // set_symdiff(var set of int: a, var set of int: b, var set of int: b)     a symdiff b = c
			{
			Registre r=st.obtenir($p.text);
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				operar_set_3(ntipus,nvalors,ncont,"diferenciasimetrica",false,$p.text,$p.getLine());
			}
			}
		)
	|	^(p='set_union'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // set_union(var set of int: a, var set of int: b, var set of int: b)     a union b = c
			{
			Registre r=st.obtenir($p.text);
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				operar_set_3(ntipus,nvalors,ncont,"unio",false,$p.text,$p.getLine());
			}
			}
		)
	;

pred_globals	
	@init {
	String[] ntipus=new String[5];
	String[] nvalors=new String[5];
	int ncont=0;
	}
	:	^(p='fzn2smt_all_different_int'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // fzn2smt_all_different_int(array[int] of var int: a)   
			{
			Registre r=st.obtenir($p.text);
			//System.err.println(ntipus[0]+"      >>>>    "+ncont+"     >>>> "+r.getSignatura());
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				String aux="";
				if (nvalors[0]!=null) 
				{
					if (r.getLia()) {lia=true;}
					Registre r1=st.obtenir(nvalors[0]);
					int tt=r1.getDim();
					ListString a1=r1.getValorArray();
					char t1=r1.getTipus();
					String aux1="";			
					String lexema1=r1.getLexema();	
					if (tt>1)
					{		
						for (int i=1;i<=tt;i++)
						{
							if (t1=='N') 
							{
								aux1=neg(a1.obtenir(i));
							}
							else  
							{
								aux1=po+lexema1+esoguio+i+esoguio+pt;
							}
							aux=aux+" "+aux1;
						}
						aux="(distinct"+aux+")";
						smt.add(aux);
					}
				}
			}
			}
		 )
	|	^(p='fzn2smt_cumulative'  (f=flat_expr {ntipus[ncont]=$f.tipus;nvalors[ncont++]=$f.valor;} )+ // fzn2smt_cumulative(array[int] of var int: s,array[int] of var int: d,array[int] of var int: r,var int: c)   
			{
			Registre r=st.obtenir($p.text);
			if (ncont!=r.getDim() || !signatura_compatible(r.getSignatura(),ntipus,ncont)) 
			{
				missatgeError(10,$p.text,$p.getLine()); 
			}
			else
			{
				String auxt="";
				if (nvalors[0]!=null) 
				{
					if (r.getLia()) {lia=true;}
					Registre r0=st.obtenir(nvalors[0]);
					int tt=r0.getDim();
					ListString as=r0.getValorArray();
					char t0=r0.getTipus();
					String auxjs="";			
					String lexema0=r0.getLexema();			
					Registre r1=st.obtenir(nvalors[1]);
					ListString ad=r1.getValorArray();
					char t1=r1.getTipus();
					String lexema1=r1.getLexema();			
					Registre r2=st.obtenir(nvalors[2]);
					ListString ar=r2.getValorArray();
					char t2=r2.getTipus();
					String auxjr="";			
					String lexema2=r2.getLexema();			
					litcum++;
					String literal="lit___cum__e"+litcum+"__";
					for (int j=1;j<=tt;j++)
					{
						if (t0=='N') 
						{
							auxjs=neg(as.obtenir(j));
						}
						else  
						{
							auxjs=po+lexema0+esoguio+j+esoguio+pt;
						}
						if (t2=='N') 
						{
							auxjr=neg(ar.obtenir(j));
						}
						else  
						{
							auxjr=po+lexema2+esoguio+j+esoguio+pt;
						}
						for (int i=1;i<=tt;i++)
						{
							String aux="";
							if (i!=j)
							{
								String auxis="";
								String auxid="";
								String auxir="";
								if (t0=='N') 
								{
									auxis=neg(as.obtenir(i));
								}
								else  
								{
									auxis=po+lexema0+esoguio+i+esoguio+pt;
								}
								if (t1=='N') 
								{
									auxid=neg(ad.obtenir(i));
								}
								else  
								{
									auxid=po+lexema1+esoguio+i+esoguio+pt;
								}
								if (t2=='N') 
								{
									auxir=neg(ar.obtenir(i));
								}
								else  
								{
									auxir=po+lexema2+esoguio+i+esoguio+pt;
								}
								String lit1=literal+"__1__"+i+"__"+j;
								inserirIdent(lit1,'V',"VB",0,"",false,new ListString(),new ListBool(),"","","", new Vector<String>(),0,"");
								smt.add("(= "+lit1+" (<= "+auxis+" "+auxjs+"))"); 	   		
								String lit2=literal+"__2__"+i+"__"+j;
								inserirIdent(lit2,'V',"VB",0,"",false,new ListString(),new ListBool(),"","","", new Vector<String>(),0,"");
								smt.add("(= "+lit2+" (< "+auxjs+" (+ "+auxis+" "+auxid+")))"); 	   		
								String lit=literal+i+"__"+j;
								inserirIdent(lit,'V',"VI",0,"",false,new ListString(),new ListBool(),"","","", new Vector<String>(),0,"");
								smt.add("(>= "+lit+" 0)"); 	   		
								smt.add("(<= "+lit+" 1)"); 	
								smt.add("(ite (and "+lit1+" "+lit2+") (= "+lit+" 1) (= "+lit+" 0))");						
								auxt=auxt+" (* "+auxir+" "+lit+" )";
							}
						}
					smt.add("(<= (+"+auxt+") (- "+nvalors[3]+" "+auxjr+"))");
					auxt="";	
					}											
					/*for (int j=1;j<=tt;j++)
					{
						for (int i=1;i<j;i++)
						{
							String lit1ij=literal+"__1__"+i+"__"+j;
							String lit1ji=literal+"__1__"+j+"__"+i;
							String lit2ij=literal+"__2__"+i+"__"+j;
							String lit2ji=literal+"__2__"+j+"__"+i;
							smt.add("(or "+lit1ij+" "+lit2ij+")"); 	   		
							smt.add("(or "+lit1ji+" "+lit2ji+")"); 	   		
							smt.add("(or "+lit1ij+" "+lit1ji+")"); 	   		
							smt.add("(implies "+lit1ij+" "+lit2ji+")"); 	   		
							smt.add("(implies "+lit1ji+" "+lit2ij+")");    		
						}
					}*/
				}
			}
			} 
		 )
	;	

solve_item 
	:	^(SOLVE  solve_kind)
	;

solve_kind 
	:	SATISFY {solveKindMax=false;}
	|	^(p=MINIMIZE s1=scalar_flat_expr["I"]) 
		{
			
			max_min($s1.tipus,$s1.valor,$s1.init,false,$p.getLine());
		}
	|	^(p=MAXIMIZE s2=scalar_flat_expr["I"]) 
		{
			max_min($s2.tipus,$s2.valor,$s2.init,true,$p.getLine());
		}
	;


	